/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2005 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include "tms.h"

#ifdef CODE_SEGMENT
#pragma segment DATA1_C_A
#endif

struct prayer_struct prayers[NUM_PRAYERS] =
    {
    {"adoration", 0, PRAYER_ADORATION, GIFT_ANY, PRAY_AUTOMATIC},
    {"aegis of God", EXTREMELY_DIFFICULT, PRAYER_AEGIS_OF_GOD, GIFT_FAITH|
      GIFT_MIRACULOUS_POWERS, 0},
    {"blessing", DIFFICULT, PRAYER_BLESSING, GIFT_ANY, 0},
    {"breath of God", 0, PRAYER_BREATH_OF_GOD, GIFT_ANY, PRAY_AUTOMATIC},
    {"breath prayer", 0, PRAYER_BREATH_PRAYER, GIFT_ANY, PRAY_AUTOMATIC},
    {"breathe underwater", VERY_DIFFICULT, PRAYER_BREATHE_UNDERWATER,
      GIFT_MIRACULOUS_POWERS, 0},
    {"chant", 0, PRAYER_CHANT, GIFT_ANY, PRAY_AUTOMATIC},
    {"chariot of fire", LEGENDARILY_DIFFICULT, PRAYER_CHARIOT_OF_FIRE,
      GIFT_MIRACULOUS_POWERS|GIFT_FAITH, 0},
    {"contemplate Scripture", 0, PRAYER_CONTEMPLATE_SCRIPTURE, GIFT_ANY,
      PRAY_AUTOMATIC},
    {"converse", DIFFICULT, PRAYER_CONVERSE,
      GIFT_MIRACULOUS_POWERS|GIFT_SPEAKING_IN_TONGUES|
      GIFT_INTERPRETING_TONGUES,
      PRAY_TWO_CRITICAL_SUCCESSES_PERMANENT},
    {"dance", 0, PRAYER_DANCE, GIFT_ANY, PRAY_AUTOMATIC},
    {"dawn of creation", 0, PRAYER_DAWN_OF_CREATION,
      GIFT_COMMUNION|GIFT_SPEAKING_IN_TONGUES|GIFT_INTERPRETING_TONGUES,
      PRAY_AUTOMATIC},
    {"divine sustenance", VERY_DIFFICULT, PRAYER_DIVINE_SUSTENANCE,
      GIFT_MIRACULOUS_POWERS|GIFT_FAITH|GIFT_PROPHECY|GIFT_COMMUNION,
      PRAY_CRITICAL_SUCCESS_PERMANENT},
    {"doxology", 0, PRAYER_DOXOLOGY, GIFT_ANY, PRAY_AUTOMATIC},
    {"emptying", 0, PRAYER_EMPTYING, GIFT_ANY, PRAY_AUTOMATIC},
    {"favor with man", DIFFICULT, PRAYER_FAVOR_WITH_MAN,
      GIFT_FAITH|GIFT_PREACHING|GIFT_TEACHING|GIFT_PROPHECY|GIFT_WISDOM,
      PRAY_AUTOMATIC|PRAY_TWO_CRITICAL_SUCCESSES_PERMANENT},
    {"final strike", EXTREMELY_DIFFICULT, PRAYER_FINAL_STRIKE,
      GIFT_MIRACULOUS_POWERS|GIFT_FAITH, 0},
    {"fire from Heaven", VERY_DIFFICULT, PRAYER_FIRE_FROM_HEAVEN,
      GIFT_MIRACULOUS_POWERS, 0},
    {"flying", VERY_DIFFICULT, PRAYER_FLYING, GIFT_MIRACULOUS_POWERS,
      PRAY_CRITICAL_SUCCESS_PERMANENT},
    {"fortitude", DIFFICULT, PRAYER_FORTITUDE, GIFT_ANY,
      PRAY_TWO_CRITICAL_SUCCESSES_PERMANENT},
    {"funeral", 0, PRAYER_FUNERAL, GIFT_ANY, PRAY_AUTOMATIC|PRAY_TAKES_HOUR},
    {"guardian angel", VERY_DIFFICULT, PRAYER_GUARDIAN_ANGEL, GIFT_ANY,
      0},
    {"healing", DIFFICULT, PRAYER_HEALING, GIFT_HEALING, 0},
    {"holy ground", EXTREMELY_DIFFICULT, PRAYER_HOLY_GROUND, GIFT_FAITH,
      0},
    {"holy of holies", 0, PRAYER_HOLY_OF_HOLIES, GIFT_ANY, PRAY_AUTOMATIC},
    {"humbling before God", 0, PRAYER_HUMBLING_BEFORE_GOD, GIFT_ANY,
      PRAY_AUTOMATIC},
    {"images", 0, PRAYER_IMAGES, GIFT_ANY, PRAY_AUTOMATIC},
    {"increase attribute", LEGENDARILY_DIFFICULT, PRAYER_INCREASE_ATTRIBUTE,
      GIFT_MIRACULOUS_POWERS, 0},
    {"increase faith", VERY_DIFFICULT, PRAYER_INCREASE_FAITH, GIFT_ANY,
      PRAY_CRITICAL_SUCCESS_PERMANENT},
    {"increase skill", EXTREMELY_DIFFICULT, PRAYER_INCREASE_SKILL,
      GIFT_MIRACULOUS_POWERS, 0},
    {"insight", DIFFICULT, PRAYER_INSIGHT, GIFT_WORD_OF_KNOWLEDGE, 0},
    {"interpret tongues", 0, PRAYER_INTERPRET_TONGUES,
      GIFT_INTERPRETING_TONGUES, PRAY_AUTOMATIC|PRAY_REQUIRES_GIFT},
    {"Janra blessing", 0, PRAYER_JANRA_BLESSING, GIFT_ANY,
      PRAY_AUTOMATIC},
    {"kythe", 0, PRAYER_KYTHE, GIFT_ANY, PRAY_AUTOMATIC},
    {"lightning strike", VERY_DIFFICULT, PRAYER_LIGHTNING_STRIKE,
      GIFT_MIRACULOUS_POWERS, 0},
    {"listen to creation", 0, PRAYER_LISTEN_TO_CREATION, GIFT_ANY,
      PRAY_AUTOMATIC},
    {"listen to silence", 0, PRAYER_LISTEN_TO_SILENCE, GIFT_ANY,
      PRAY_AUTOMATIC},
    {"listen to the eternal song", 0, PRAYER_LISTEN_TO_THE_ETERNAL_SONG,
        GIFT_ANY, PRAY_AUTOMATIC},
    {"liturgy", 0, PRAYER_LITURGY, GIFT_ANY, PRAY_AUTOMATIC},
    {"love", 0, PRAYER_LOVE, GIFT_ANY, PRAY_AUTOMATIC},
    {"meditation", 0, PRAYER_MEDITATION, GIFT_ANY, PRAY_AUTOMATIC},
    {"Name", 0, PRAYER_NAME, GIFT_ANY, PRAY_AUTOMATIC},
    {"name of Jesus", 0, PRAYER_NAME_OF_JESUS, GIFT_ANY, PRAY_AUTOMATIC},
    {"offer self", 0, PRAYER_OFFER_SELF, GIFT_ANY,
      PRAY_AUTOMATIC},
    {"paternoster", 0, PRAYER_PATERNOSTER, GIFT_ANY,
      PRAY_AUTOMATIC},
    {"persuasion", DIFFICULT, PRAYER_PERSUASION, GIFT_ANY, 0},
    {"praise God", 0, PRAYER_PRAISE_GOD, GIFT_ANY, PRAY_AUTOMATIC},
    {"prologue to John", 0, PRAYER_PROLOGUE_TO_JOHN, GIFT_ANY, PRAY_AUTOMATIC},
    {"providence", MODERATE, PRAYER_PROVIDENCE, GIFT_ANY,
      PRAY_THREE_CRITICAL_SUCCESSES_PERMANENT},
    {"raise dead", VERY_DIFFICULT, PRAYER_RAISE_DEAD,
      GIFT_HEALING|GIFT_MIRACULOUS_POWERS, 0},
    {"receive gift", EXTREMELY_DIFFICULT, PRAYER_RECEIVE_GIFT, GIFT_ANY,
      0},
    {"rejuvenate", LEGENDARILY_DIFFICULT, PRAYER_REJUVENATE, GIFT_HEALING,
      0},
    {"restoration", VERY_DIFFICULT, PRAYER_RESTORATION,
      GIFT_HEALING|GIFT_MIRACULOUS_POWERS|GIFT_FAITH, 0},
    {"reveal terrain", VERY_DIFFICULT, PRAYER_REVEAL_TERRAIN,
      GIFT_WORD_OF_KNOWLEDGE, 0},
    {"sanctuary", VERY_DIFFICULT, PRAYER_SANCTUARY, GIFT_ANY,
      0},
    {"shining light", DIFFICULT, PRAYER_SHINING_LIGHT, GIFT_MIRACULOUS_POWERS,
      0},
    {"silent communion", 0, PRAYER_SILENT_COMMUNION, GIFT_ANY, PRAY_AUTOMATIC},
    {"silent contemplation", 0, PRAYER_SILENT_CONTEMPLATION, GIFT_ANY,
      PRAY_AUTOMATIC},
    {"sing in tongues", 0, PRAYER_SING_IN_TONGUES, GIFT_SPEAKING_IN_TONGUES,
      PRAY_AUTOMATIC|PRAY_REQUIRES_GIFT},
    {"sing praises", 0, PRAYER_SING_PRAISES, GIFT_ANY, PRAY_AUTOMATIC},
    {"slay creature", EXTREMELY_DIFFICULT, PRAYER_SLAY_CREATURE,
      GIFT_MIRACULOUS_POWERS, 0},
    {"speak in tongues", 0, PRAYER_SPEAK_IN_TONGUES, GIFT_SPEAKING_IN_TONGUES,
      PRAY_AUTOMATIC|PRAY_REQUIRES_GIFT},
    {"star song", 0, PRAYER_STAR_SONG, GIFT_ANY, PRAY_AUTOMATIC},
    {"stillness", 0, PRAYER_STILLNESS, GIFT_ANY, PRAY_AUTOMATIC},
    {"stop time", EXTREMELY_DIFFICULT, PRAYER_STOP_TIME, GIFT_MIRACULOUS_POWERS,
      0},
    {"submission", 0, PRAYER_SUBMISSION, GIFT_ANY, PRAY_AUTOMATIC},
    {"thanksgiving", 0, PRAYER_THANKSGIVING, GIFT_ANY, PRAY_AUTOMATIC},
    {"together with another person", 0, PRAYER_TOGETHER_WITH_ANOTHER_PERSON,
      GIFT_ANY, PRAY_AUTOMATIC},
    {"tremble", 0, PRAYER_TREMBLE, GIFT_ANY, PRAY_AUTOMATIC},
    {"walk on water", VERY_DIFFICULT, PRAYER_WALK_ON_WATER,
      GIFT_MIRACULOUS_POWERS, 0},
    {"worship", 0, PRAYER_WORSHIP, GIFT_ANY, PRAY_AUTOMATIC},
    {"worship service", 0, PRAYER_WORSHIP_SERVICE, GIFT_ANY, PRAY_AUTOMATIC}
    /* {"name", DIFFICULTY, IDENTITY, GIFTS, FLAGS}, */
    };

#ifdef CODE_SEGMENT
#pragma segment DATA1_C_B
#endif

struct master_creature master_creatures_original[NUM_CREATURES] = { {"", "Janra", "",
"", "corpse of a Janra", ICON_JANRA_MALE, 0, -10, {20, 0, 5, 0, 0, 4, 0, 0, 2, 5, 5, 5},
{20, 0, 5, 0, 0, 4, 0, 0, 2, 5, 5, 5}, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50,
0, 0, 150*LB, SECOND, 5, 0, EASY, 0, TALK_JANRA, MEAT_NONE, 0, 0, 0, 0, 0,
JANRA, 0, HUMAN|LEFT_HANDED, 0, 0, 0, 0, 100, 100, 100, 100, HITS, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "Jec", "", "", "corpse of a Jec", ICON_JEC_MALE, 0, -10, {0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 30, 0, 0, 110*LB, SECOND, 3, 0, DIFFICULT, 0, TALK_JEC, MEAT_NONE, 0,
0, 0, 0, 0, JEC, 0, HUMAN, 0, 0, 0, 0, 10, 10, 100, 100, HITS, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "Nor\'krin", "", "", "corpse of a Nor\'krin", ICON_NORKRIN_MALE, 0, -10, {0, 0, 0, 0,
0, 0, 3, 5, 0, 0, 5, 0}, {0, 0, 0, 0, 0, 0, 3, 5, 0, 0, 5, 0}, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 175*LB, SECOND, 20, 0, DIFFICULT, 0,
TALK_NORKRIN, MEAT_NONE, 0, 0, 0, 0, 0, NORKRIN, 0, HUMAN, 0, 0, 0, 0, 0, 0,
1000, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "Shal", "", "", "corpse of a Shal", ICON_SHAL_MALE, 0, -10, {0, 0, 0, 0, 0, 2, 0, 0,
0, -5, 0, 0}, {0, 0, 0, 0, 0, 2, 0, 0, 0, -5, 0, 0}, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 10, 0, 0, 130*LB, SECOND, 1, 0, MODERATE, 0, TALK_SHAL, MEAT_NONE,
0, 0, 0, 0, 0, SHAL, 0, HUMAN, 0, 0, 0, 0, 5, 10, 20, 50, HITS, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "Tuz", "", "", "corpse of a Tuz", ICON_TUZ_MALE, 0, -10, {0, 0, 0, 5, 0, 0, 0, 0,
0, 0, 10, 10}, {0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 10, 10}, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 20, 0, 0, 250*LB, SECOND, 1, 0, DIFFICULT, 0, TALK_TUZ, MEAT_NONE,
0, 0, 0, 0, 0, TUZ, 0, HUMAN, 0, 0, 0, 0, 200, 0, 0, 0, HITS, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "Urvanovestilli", "", "", "corpse of an Urvanovestilli", ICON_URVANOVESTILLI_MALE, 0, -10, {0,
0, 2, 0, 5, 5, 2, 3, 0, 0, -10, 0}, {0, 0, 2, 0, 5, 5, 2, 3, 0, 0, -10, 0}, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40, 0, 0, 70*LB, SECOND, 2, 0, DIFFICULT, 0,
TALK_URVANOVESTILLI, MEAT_NONE, 0, 0, 0, 0, 0, URVANOVESTILLI, 0, HUMAN, 0, 0,
0, 0, 1000, 1000, 50, 20, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL,
NULL, 0, 0, 0, 0},

{"", "Yedidia", "", "", "corpse of a Yedidia", ICON_YEDIDIA_MALE, 0, -10, {0, 0, 5, 0, 0, 3,
0, 0, 10, 0, 0, 0}, {0, 0, 5, 0, 0, 3, 0, 0, 10, 0, 0, 0}, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 30, 0, 0, 150*LB, SECOND, 4, 0, MODERATE, 0, TALK_YEDIDIA,
MEAT_NONE, 0, 0, 0, 0, 0, YEDIDIA, 0, HUMAN, 0, 0, 0, 0, 50, 100, 200, 400,
HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "angel", "", "", "angel's robes", ICON_ANGEL, 0, 20, {50, 50,
50, 50, 50, 50, 50, 50, 50, 50, 50, 50}, {50, 50, 50, 50, 50, 50, 50, 50, 50,
50, 50, 50}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 0, 0, 500*LB, SECOND, 4,
0, MODERATE, 0, TALK_INTERCESSOR, MEAT_NONE, 0, 0, 0, 0, 0, ANGEL, 0,
TERRIFYING|FLYING|HAS_LIGHT_SOURCE, 0, 100, 0, 0, 50, 100, 200, 400, STABS|SLASHES,
MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "acid slime mold", "", "", "blob of slimy acid", ICON_ACID_SLIME_MOLD, 20, 0, {20, 0, 0,
10, 10, -100, -100, -100, 10, 20, 10, 0}, {20, 0, 0, 10, 10, -100, -100, -100,
10, 20, 10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10000L*AU, 50, 0, 0, 200*LB,
3L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_DEAD, 75, 0, 0, 0, 0,
ACID_SLIME_MOLD, 0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "acid spitter", "", "", "acid spitter's carcass", ICON_ACID_SPITTER, 20, 0, {20, 0, 0,
20, 20, -100, -100, -100, 10, 10, 30, 0}, {20, 0, 0, 20, 20, -100, -100, -100,
10, 10, 30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1000L*AU, 40, 0, 0, 150*LB,
SECOND, 1, 0, DIFFICULT, 0, 0, MEAT_MEAT, 60, 0, 0, 0, 0, ACID_SPITTER, 0,
MISSLE_ATTACK|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, CLAWS|BITES, SPITS_ACID_ON,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "anteater", "", "", "anteater's carcass", ICON_ANTEATER, 0, 0, {10, 0, 0, 10, 10,
-100, -100, -100, 10, 10, 0, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10, 10,
0, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10*SI, 40, 0, 0, 10*LB, 2L*SECOND, 1,
0, MODERATE, 0, 0, MEAT_MEAT, 10, 0, 0, 0, 0, ANTEATER, 0, NO_DEFEND_MASTER,
0, 0, 0, 0, 0, 0, 0, 0, CLAWS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL,
NULL, 0, 0, 0, 0},

{"", "barracuda", "", "", "barracuda's carcass", ICON_BARRACUDA, 0, 0, {10, 0, 0, 10, 10,
-100, -100, -100, 10, 10, -10, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10,
10, -10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20L*AU, 40, 0, 0, 7*LB, SECOND,
1, 0, DIFFICULT, 0, 0, MEAT_FILLET, 70, 0, 0, 0, 0, BARRACUDA, 0,
WATER_ONLY|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "bass", "", "", "bass's carcass", ICON_BASS, 0, -10, {10, 0, 0, 0, 10, -100,
-100, -100, 10, 10, -10, 0}, {10, 0, 0, 0, 10, -100, -100, -100, 10, 10, -10,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2L*SI, 40, 0, 0, 2*LB, 2L*SECOND, 3, 0,
MODERATE, 0, 0, MEAT_FILLET, 10, 0, 0, 0, 0, BASS, 0, WATER_ONLY, 0, 0, 0, 0,
0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "bear", "", "", "bear's carcass", ICON_BEAR, 0, 0, {20, 0, 0, 30, 10, -100,
-100, -100, -10, 0, 40, 0}, {20, 0, 0, 30, 10, -100, -100, -100, -10, 0, 40,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 500L*AU, 30, 0, 0, 800*LB, SECOND, 1, 0,
VERY_DIFFICULT, 0, 0, MEAT_JERKY, 80, 0, 0, 0, 0, BEAR, 0, BELLICOSE, 0, 0, 0,
0, 0, 0, 0, 0, CLAWS|BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL,
NULL, 0, 0, 0, 0},

{"", "Behemoth", "", "", "Behemoth's carcass", ICON_BEHEMOTH, 0, 0, {10, 0, 0, 30, 20,
-100, -100, -100, -10, -10, 70, 0}, {10, 0, 0, 30, 20, -100, -100, -100, -10,
-10, 70, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1000000L*AU, 20, 0, 0, 50L*TON,
15L*SECOND, 1, 0, EXTREMELY_DIFFICULT, 0, 0, MEAT_MEAT, 20, 0, 0, 0, 0,
BEHEMOTH, 0, UNIQUE|TERRIFYING|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0,
RAMS|CLAWS|BITES|TRAMPLES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
0, 0, 0, 0},

{"", "boar", "", "", "boar's carcass", ICON_BOAR, 0, 0, {20, 0, 0, 10, 10, -100,
-100, -100, 10, 10, 25, 0}, {20, 0, 0, 10, 10, -100, -100, -100, 10, 10, 25,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5L*AU, 40, 0, 0, 25*LB, 2L*SECOND, 1, 0,
DIFFICULT, 0, 0, MEAT_MEAT, 60, 0, 0, 0, 0, BOAR, 0, BELLICOSE, 0, 0, 0, 0, 0,
0, 0, 0, CLAWS|BITES|GORES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL,
NULL, 0, 0, 0, 0},

{"", "bulette", "", "", "bulette's carcass", ICON_BULETTE, 0, 0, {0, 0, 0, 30, 10,
-100, -100, -100, 10, 10, 30, 0}, {0, 0, 0, 30, 10, -100, -100, -100, 10, 10,
30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 800L*AU, 40, 0, 0, 1000L*LB,
5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 90, 0, 0, 0, 0, BULETTE, 0,
BELLICOSE|HIDDEN, 0, 0, 0, 0, 0, 0, 0, 0, CLAWS|BITES, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "caribou", "", "", "caribou's carcass", ICON_CARIBOU, 0, 0, {10, 0, 0, 10, 10,
-100, -100, -100, 10, 10, 30, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10, 10,
30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200L*AU, 40, 0, 0, 1500L*LB,
5L*SECOND, 30, 0, DIFFICULT, 0, 0, MEAT_MEAT, 20, 0, 0, 0, 0, CARIBOU, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, RAMS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL,
NULL, 0, 0, 0, 0},

{"", "carnivorous log", "", "", "dead carnivorous log", ICON_CARNIVOROUS_LOG, 0, 0, {10, 0, 0,
20, 10, -100, -100, -100, 0, 10, 30, 0}, {10, 0, 0, 20, 10, -100, -100, -100,
0, 10, 30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100L*AU, 40, 0, 0, 1000L*LB,
3L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_DEAD, 80, 0, 0, 0, 0,
CARNIVOROUS_LOG, 0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, HITS|SQUEEZES,
MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "carnivorous tree", "", "", "dead carnivorous tree", ICON_CARNIVOROUS_TREE, 0, 0, {10, 0,
0, 20, 10, -100, -100, -100, 10, 10, 40, 0}, {10, 0, 0, 20, 10, -100, -100,
-100, 10, 10, 40, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250L*AU, 40, 0, 0, TON,
5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_DEAD, 80, 0, 0, 0, 0,
CARNIVOROUS_TREE, 0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, HITS|SQUEEZES,
MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "chimera", "", "", "chimera's carcass", ICON_CHIMERA, 20, 0, {10, 0, 0, 10, 10,
-100, -100, -100, 10, 10, 10, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10, 10,
10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 400L*AU, 40, 0, 0, 400*LB, 2L*SECOND,
1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 75, 0, 0, 0, 0, CHIMERA, 0,
MISSLE_ATTACK|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, CLAWS|BITES,
BREATHES_FIRE_ON, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "cobra", "", "", "cobra's carcass", ICON_COBRA, 30, -10, {10, 0, 0, 10, 10,
-100, -100, -100, 10, 30, -10, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10,
30, -10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50L*AU, 60, 0, 0, 3*LB, SECOND,
1, 0, DIFFICULT, 0, 0, MEAT_MEAT, 40, 0, 0, 0, 0, COBRA, 0, BELLICOSE, 0, 0,
0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
0, 0, 0, 0},

{"", "colorspray", "", "", "colorspray's carcass", ICON_COLORSPRAY, 0, -20, {10, 0, 0, 10,
10, -100, -100, -100, 10, 10, -10, 0}, {10, 0, 0, 10, 10, -100, -100, -100,
10, 10, -10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5L*SI, 40, 0, 0, 20*LB,
5L*SECOND, 3, 0, EASY, 0, 0, MEAT_MEAT, 0, 0, 0, 0, 0, COLORSPRAY, 0,
NO_DEFEND_MASTER, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "crocodile", "", "", "crocodile's carcass", ICON_CROCODILE, 0, 0, {10, 0, 0, 30, 10,
-100, -100, -100, 10, 10, 30, 0}, {10, 0, 0, 30, 10, -100, -100, -100, 10, 10,
30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200L*AU, 40, 0, 0, 500L*LB,
2L*SECOND, 2, 0, VERY_DIFFICULT, 0, 0, MEAT_STEAK, 60, 0, 0, 0, 0, CROCODILE,
0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL, NULL,
NULL, NULL, NULL, 0, 0, 0, 0},

{"", "cuddler", "", "", "cuddler's carcass", ICON_CUDDLER, 0, -40, {10, 0, 0, 0, 10,
-100, -100, -100, 10, 0, -20, 0}, {10, 0, 0, 0, 10, -100, -100, -100, 10, 0,
-20, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4L*SI, 30, 0, 0, 10*LB, 10L*SECOND,
5, 0, EASY, 0, 0, MEAT_MEAT, 0, 0, 0, 0, 0, CUDDLER, 0, NO_DEFEND_MASTER, 0,
0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
0, 0, 0, 0},

{"", "deer", "", "", "deer's carcass", ICON_DEER, 0, 0, {30, 0, 0, 10, 10, -100,
-100, -100, 20, 10, 20, 0}, {30, 0, 0, 10, 10, -100, -100, -100, 20, 10, 20,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15L*AU, 40, 0, 0, 60*LB, 2L*SECOND, 3, 0,
DIFFICULT, 0, 0, MEAT_VENISON, 10, 0, 0, 0, 0, DEER, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, HITS|GORES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0,
0},

{"", "dog", "", "", "dog's carcass", ICON_DOG, 0, 0, {10, 0, 0, 10, 10, -100, -100,
-100, 10, 10, 20, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10, 10, 20, 0}, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25L*AU, 40, 0, 0, 50*LB, SECOND, 10, 0, EASY, 0,
0, MEAT_MEAT, 20, 0, 0, 0, 0, DOG, 0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0,
BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "dolphin", "", "", "dolphin's carcass", ICON_DOLPHIN, 0, 0, {10, 0, 0, 20, 10,
-100, -100, -100, 10, 20, 50, 0}, {10, 0, 0, 20, 10, -100, -100, -100, 10, 20,
50, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3000L*AU, 50, 0, 0, 1000L*LB,
5L*SECOND, 5, 0, EASY, 0, 0, MEAT_MEAT, 0, 0, 0, 0, 0, DOLPHIN, 0, WATER_ONLY,
0, 0, 0, 0, 0, 0, 0, 0, RAMS|BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL,
NULL, 0, 0, 0, 0},

{"", "dove", "", "", "dove's carcass", ICON_DOVE, 0, -20, {20, 0, 0, 10, 10,
-100, -100, -100, 10, 10, -50, 0}, {20, 0, 0, 10, 10, -100, -100, -100, 10,
10, -50, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3L*CU, 40, 0, 0, 6*OZ,
2L*SECOND, 10, 0, MODERATE, 0, 0, MEAT_MEAT, 0, 0, 0, 0, 0, DOVE, 0,
FLYING|ABOVE_GROUND|NO_DEFEND_MASTER, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "dragon", "", "", "dragon's carcass", ICON_DRAGON, 30, 0, {20, 0, 0, 30, 10,
-100, -100, -100, 10, 10, 60, 0}, {20, 0, 0, 30, 10, -100, -100, -100, 10, 10,
60, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50000L*AU, 40, 0, 0, 10L*TON,
10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_STEAK, 75, 0, 0, 0, 0, DRAGON, 0,
MISSLE_ATTACK|TERRIFYING|FLYING|ABOVE_GROUND|BELLICOSE, 0, 0, 0, 0, 0, 0, 0,
0, CLAWS|BITES|TRAMPLES, BREATHES_FIRE_ON, NULL, NULL, NULL, NULL, NULL, NULL,
0, 0, 0, 0},

{"", "duck", "", "", "duck's carcass", ICON_DUCK, 0, -20, {10, 0, 0, 10, 10, -100,
-100, -100, 10, 10, -20, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10, 10, -20,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16L*SI, 40, 0, 0, 5*LB, 2L*SECOND, 20, 0,
MODERATE, 0, 0, MEAT_ROAST, 10, 0, 0, 0, 0, DUCK, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "electric eel", "", "", "electric eel's carcass", ICON_ELECTRIC_EEL, 30, 0, {10, 0, 0,
10, 10, -100, -100, -100, 10, 10, 0, 0}, {10, 0, 0, 10, 10, -100, -100, -100,
10, 10, 0, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80L*AU, 40, 0, 0, 40*LB,
5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 40, 0, 0, 0, 0,
ELECTRIC_EEL, 0, WATER_ONLY, 0, 0, 0, 0, 0, 0, 0, 0, SHOCKS, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "elephant", "", "", "elephant's carcass", ICON_ELEPHANT, 0, 0, {0, 0, 0, 20, 10,
-100, -100, -100, 0, 10, 40, 0}, {0, 0, 0, 20, 10, -100, -100, -100, 0, 10,
40, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5000L*AU, 40, 0, 0, 10L*TON,
10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 70, 0, 0, 0, 0, ELEPHANT,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, RAMS|TRAMPLES|GORES, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "fog-thing", "", "", "fog-thing's carcass", ICON_FOG_THING, 0, 0, {20, 0, 0, 10, 10,
-100, -100, -100, 10, 10, 40, 0}, {20, 0, 0, 10, 10, -100, -100, -100, 10, 10,
40, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5000L*AU, 40, 0, 0, TON, 10L*SECOND,
1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 80, 0, 0, 0, 0, FOG_THING, 0,
OBSCURE_VISION|TERRIFYING|BELLICOSE|HIDDEN, 0, 0, 0, 0, 0, 0, 0, 0,
HITS|BEATS|SQUEEZES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0,
0, 0},

{"", "furred serpent", "", "", "furred serpent's carcass", ICON_FURRED_SERPENT, 0, 0, {10, 0,
0, 10, 10, -100, -100, -100, 10, 10, 0, 0}, {10, 0, 0, 10, 10, -100, -100,
-100, 10, 10, 0, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30L*AU, 40, 0, 0, 25*LB,
5L*SECOND, 1, 0, MODERATE, 0, 0, MEAT_MEAT, 20, 0, 0, 0, 0, FURRED_SERPENT, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL,
NULL, NULL, 0, 0, 0, 0},

{"", "garter snake", "", "", "garter snake's carcass", ICON_GARTER_SNAKE, 0, 0, {10, 0, 0,
10, 10, -100, -100, -100, 10, 10, -50, 0}, {10, 0, 0, 10, 10, -100, -100,
-100, 10, 10, -50, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4L*CU, 40, 0, 0, 3*OZ,
2L*SECOND, 1, 0, MODERATE, 0, 0, 0, 10, 0, 0, 0, MEAT_NONE, GARTER_SNAKE, 0,
NO_DEFEND_MASTER, 0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "giant aphid", "", "", "giant aphid's carcass", ICON_GIANT_APHID, 0, 0, {10, 0, 0, 30,
10, -100, -100, -100, 10, 10, 30, 0}, {10, 0, 0, 30, 10, -100, -100, -100, 10,
10, 30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 800L*AU, 40, 0, 0, 600L*LB,
5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 50, 0, 0, 0, 0, GIANT_APHID,
0, BELLICOSE|HIDDEN, 0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "giant crab", "", "", "giant crab's carcass", ICON_GIANT_CRAB, 0, 0, {-10, 0, 0, 70,
-10, -100, -100, -100, 0, -10, 50, 0}, {-10, 0, 0, 70, -10, -100, -100, -100,
0, -10, 50, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10000L*AU, 20, 0, 0, 5L*TON,
10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 30, 0, 0, 0, 0, GIANT_CRAB,
0, WATER_ONLY|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, CLAWS, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "giant firefly", "", "", "giant firefly's carcass", ICON_GIANT_FIREFLY, 0, -30, {10, 0,
0, 10, 10, -100, -100, -100, 10, 10, 0, 0}, {10, 0, 0, 10, 10, -100, -100,
-100, 10, 10, 0, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200L*AU, 40, 0, 0,
50*LB, 5L*SECOND, 4, 0, MODERATE, 0, 0, MEAT_MEAT, 10, 0, 0, 0, 0,
GIANT_FIREFLY, 0, NO_DEFEND_MASTER|HAS_LIGHT_SOURCE, 0, 10, 0, 0, 0, 0, 0, 0,
HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "giant land lobster", "", "", "giant land lobster's carcass", ICON_GIANT_LAND_LOBSTER, 0, 0,
{10, 0, 0, 50, 10, -100, -100, -100, 0, -10, 50, 0}, {10, 0, 0, 50, 10, -100,
-100, -100, 0, -10, 50, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20000L*AU, 20, 0,
0, 30L*TON, 10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_NAME_ALONE, 90, 0, 0,
0, 0, GIANT_LAND_LOBSTER, 0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0,
CLAWS|TRAMPLES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0,
0},

{"", "giant scorpion", "", "", "giant scorpion's carcass", ICON_GIANT_SCORPION, 30, 10, {10,
0, 0, 30, 10, -100, -100, -100, 10, 10, 20, 0}, {10, 0, 0, 30, 10, -100, -100,
-100, 10, 10, 20, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1000L*AU, 40, 0, 0,
50*LB, 5L*SECOND, 3, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 60, 0, 0, 0, 0,
GIANT_SCORPION, 0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, CLAWS|STINGS, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "giant squid", "", "", "giant squid's carcass", ICON_GIANT_SQUID, 0, 0, {0, 0, 0, 30,
10, -100, -100, -100, 10, 10, 60, 0}, {0, 0, 0, 30, 10, -100, -100, -100, 10,
10, 60, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30000L*AU, 40, 0, 0, 20L*TON,
20L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_NAME_ALONE, 40, 0, 0, 0, 0,
GIANT_SQUID, 0, WATER_ONLY|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "giant viper", "", "", "giant viper's carcass", ICON_GIANT_VIPER, 30, 0, {10, 0, 0,
10, 10, -100, -100, -100, 20, 10, 50, 0}, {10, 0, 0, 10, 10, -100, -100, -100,
20, 10, 50, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10000L*AU, 40, 0, 0, 10L*TON,
10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_STEAK, 70, 0, 0, 0, 0,
GIANT_VIPER, 0, 0, TERRIFYING|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, BITES|SQUEEZES,
MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "giant walking stick", "", "", "giant walking stick's carcass", ICON_GIANT_WALKING_STICK, 20,
0, {0, 0, 0, 10, 10, -100, -100, -100, 0, 10, -10, 0}, {0, 0, 0, 10, 10, -100,
-100, -100, 0, 10, -10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40L*AU, 40, 0, 0,
40*LB, 5L*SECOND, 3, 0, DIFFICULT, 0, 0, MEAT_MEAT, 20, 0, 0, 0, 0,
GIANT_WALKING_STICK, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "giant wasp", "", "", "giant wasp's carcass", ICON_GIANT_WASP, 30, 0, {0, 0, 0, 10,
10, -100, -100, -100, 10, 10, 10, 0}, {0, 0, 0, 10, 10, -100, -100, -100, 10,
10, 10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 800L*AU, 40, 0, 0, 60*LB,
4L*SECOND, 2, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 70, 0, 0, 0, 0, GIANT_WASP,
0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, STINGS, MSL_HITS, NULL, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "giant webthrower", "", "", "giant webthrower's carcass", ICON_GIANT_WEBTHROWER, 20, 0,
{10, 0, 0, 20, 10, -100, -100, -100, 20, 20, 25, 0}, {10, 0, 0, 20, 10, -100,
-100, -100, 20, 20, 25, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200L*AU, 50, 0,
0, 350*LB, 10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 45, 0, 0, 0, 0,
GIANT_WEBTHROWER, 0, MISSLE_ATTACK|ENTANGLES|BELLICOSE, 0, 0, 0, 0, 0, 0, 0,
0, HITS, ENTANGLES, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "glower", "", "", "glower's carcass", ICON_GLOWER, 0, 0, {10, 0, 0, 10, 10, -100,
-100, -100, 20, 10, 20, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 20, 10, 20,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20L*AU, 40, 0, 0, 50*LB, 5L*SECOND, 4, 0,
MODERATE, 0, 0, MEAT_MEAT, 5, 0, 0, 0, 0, GLOWER, 0,
NO_DEFEND_MASTER|HAS_LIGHT_SOURCE, 0, 20,
0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0,
0, 0, 0},

{"", "gorilla", "", "", "gorilla's carcass", ICON_GORILLA, 0, 0, {25, 0, 0, 10, 10,
-100, -100, -100, 10, 10, 30, 0}, {25, 0, 0, 10, 10, -100, -100, -100, 10, 10,
30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 400L*AU, 40, 0, 0, 100*LB, 2L*SECOND,
15, 0, DIFFICULT, 0, 0, MEAT_MEAT, 20, 0, 0, 0, 0, GORILLA, 0, BELLICOSE, 0,
0, 0, 0, 0, 0, 0, 0, BEATS|BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL,
NULL, NULL, 0, 0, 0, 0},

{"", "gryphon", "", "", "gryphon's carcass", ICON_GRYPHON, 0, 0, {25, 0, 0, 20, 10,
-100, -100, -100, 20, 20, 30, 0}, {25, 0, 0, 20, 10, -100, -100, -100, 20, 20,
30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 800L*AU, 50, 0, 0, 1000L*LB,
5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_STEAK, 75, 0, 0, 0, 0, GRYPHON, 0,
FLYING|ABOVE_GROUND|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, CLAWS|BITES, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "hawk", "", "", "hawk's carcass", ICON_HAWK, 0, -10, {10, 0, 0, 10, 10, -100,
-100, -100, 10, 10, 0, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10, 10, 0, 0},
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40L*AU, 40, 0, 0, 5*LB, 3L*SECOND, 1, 0,
DIFFICULT, 0, 0, MEAT_MEAT, 40, 0, 0, 0, 0, HAWK, 0, FLYING|ABOVE_GROUND, 0,
0, 0, 0, 0, 0, 0, 0, CLAWS|BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL,
NULL, NULL, 0, 0, 0, 0},

{"", "hedgehog", "", "", "hedgehog's carcass", ICON_HEDGEHOG, 0, 0, {10, 0, 0, 10, 10,
-100, -100, -100, 10, 10, -10, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10,
10, -10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8L*SI, 40, 0, 0, 10*LB,
3L*SECOND, 1, 0, MODERATE, 0, 0, MEAT_MEAT, 10, 0, 0, 0, 0, HEDGEHOG, 0,
NO_DEFEND_MASTER, 0, 0, 0, 0, 0, 0, 0, 0, CLAWS|BITES, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "hippogriff", "", "", "hippogriff's carcass", ICON_HIPPOGRIFF, 0, 0, {20, 0, 0, 20,
10, -100, -100, -100, 10, 10, 40, 0}, {20, 0, 0, 20, 10, -100, -100, -100, 10,
10, 40, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 800L*AU, 40, 0, 0, 250*LB,
10L*SECOND, 4, 0, DIFFICULT, 0, 0, MEAT_MEAT, 20, 0, 0, 0, 0, HIPPOGRIFF, 0,
WATER_ONLY, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL,
NULL, NULL, 0, 0, 0, 0},

{"", "hippopotamus", "", "", "hippopotamus's carcass", ICON_HIPPOPOTAMUS, 0, 0, {0, 0, 0, 20,
10, -100, -100, -100, 0, 10, 30, 0}, {0, 0, 0, 20, 10, -100, -100, -100, 0, 10,
40, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2000L*AU, 40, 0, 0, 2L*TON,
10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 70, 0, 0, 0, 0, HIPPOPOTAMUS,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, RAMS|BITES|TRAMPLES, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "hnakra", "", "", "hnakra's carcass", ICON_HNAKRA, 0, 0, {25, 0, 0, 30, 10, -100,
-100, -100, 25, 20, 50, 0}, {25, 0, 0, 30, 10, -100, -100, -100, 25, 20, 50,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50000L*AU, 50, 0, 0, 5L*TON, 10L*SECOND,
1, 0, VERY_DIFFICULT, 0, 0, MEAT_STEAK, 80, 0, 0, 0, 0, HNAKRA, 0,
TERRIFYING|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "horse", "", "", "horse's carcass", ICON_HORSE, 0, 0, {20, 0, 0, 10, 10, -100,
-100, -100, 10, 10, 30, 0}, {20, 0, 0, 10, 10, -100, -100, -100, 10, 10, 30,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80L*AU, 40, 0, 0, 800L*LB, 5L*SECOND, 30,
0, MODERATE, 0, 0, MEAT_MEAT, 30, 0, 0, 0, 0, HORSE, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "hoverfeather", "", "", "hoverfeather's carcass", ICON_HOVERFEATHER, 0, -10, {20, 0, 0,
10, 10, -100, -100, -100, 10, 10, 0, 0}, {20, 0, 0, 10, 10, -100, -100, -100,
10, 10, 0, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20L*AU, 40, 0, 0, 40*LB,
2L*SECOND, 1, 0, MODERATE, 0, 0, MEAT_MEAT, 10, 0, 0, 0, 0, HOVERFEATHER, 0,
FLYING|ABOVE_GROUND, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "hummingbird", "", "", "hummingbird's carcass", ICON_HUMMINGBIRD, 0, -10, {30, 0, 0,
10, 20, -100, -100, -100, 25, 40, -50, 0}, {30, 0, 0, 10, 20, -100, -100,
-100, 25, 40, -50, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3L*SI, 70, 0, 0, OZ,
SECOND, 1, 0, MODERATE, 0, 0, MEAT_NONE, 0, 0, 0, 0, 0, HUMMINGBIRD, 0,
FLYING|ABOVE_GROUND|NO_DEFEND_MASTER|HIDDEN, 0, 0, 0, 0, 0, 0, 0, 0, HITS,
MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "iceflyer", "", "", "iceflyer's carcass", ICON_ICEFLYER, 0, -10, {10, 0, 0, 10, 10,
-100, -100, -100, 10, 10, 0, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10, 10,
0, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20L*AU, 40, 0, 0, 25*LB, 3L*SECOND, 2,
0, DIFFICULT, 0, 0, MEAT_MEAT, 40, 0, 0, 0, 0, ICEFLYER, 0,
FLYING|ABOVE_GROUND, 0, 0, 0, 0, 0, 0, 0, 0, CLAWS|BITES, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "icestriker", "", "", "icestriker's carcass", ICON_ICESTRIKER, 20, 0, {10, 0, 0, 10,
25, -100, -100, -100, 20, 10, 10, 0}, {10, 0, 0, 10, 25, -100, -100, -100, 20,
10, 10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200L*AU, 40, 0, 0, 85*LB,
4L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 70, 0, 0, 0, 0, ICESTRIKER,
0, FLYING|ABOVE_GROUND|MISSLE_ATTACK|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0,
CLAWS|BITES, SPITS_ACID_ON, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0,
0},

{"", "ironram", "", "", "ironram's carcass", ICON_IRONRAM, 0, 0, {0, 0, 0, 20, 10,
-100, -100, -100, 0, 10, 40, 0}, {0, 0, 0, 20, 10, -100, -100, -100, 0, 10,
40, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5000L*AU, 40, 0, 0, 2L*TON,
10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 70, 0, 0, 0, 0, IRONRAM, 0,
BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, RAMS|TRAMPLES, MSL_HITS, NULL, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "jellyfish", "", "", "jellyfish's carcass", ICON_JELLYFISH, 30, 0, {10, 0, 0, 20,
10, -100, -100, -100, 10, 10, 30, 0}, {10, 0, 0, 20, 10, -100, -100, -100, 10,
10, 30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35L*AU, 40, 0, 0, 3*LB,
5L*SECOND, 2, 0, DIFFICULT, 0, 0, MEAT_NAME_ALONE, 20, 0, 0, 0, 0, JELLYFISH,
0, WATER_ONLY|HIDDEN, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},


{"", "jewel serpent", "", "", "jewel serpent's carcass", ICON_JEWEL_SERPENT, 40, 0, {25, 0,
0, 20, 10, -100, -100, -100, 10, 10, 30, 0}, {25, 0, 0, 20, 10, -100, -100,
-100, 10, 10, 30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10000L*AU, 40, 0, 0,
50*LB, 3L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 40, 0, 0, 0, 0,
JEWEL_SERPENT, 0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, BITES|SQUEEZES, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "jumpcling", "", "", "jumpcling's carcass", ICON_JUMPCLING, 0, 0, {10, 0, 0, 20, 20,
-100, -100, -100, 30, 10, -30, 0}, {10, 0, 0, 20, 20, -100, -100, -100, 30,
10, -30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12L*SI, 40, 0, 0, 5*LB,
2L*SECOND, 3, 0, EASY, 0, 0, MEAT_MEAT, 0, 0, 0, 0, 0, JUMPCLING, 0,
NO_DEFEND_MASTER, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "jumper", "", "", "jumper's carcass", ICON_JUMPER, 0, -10, {50, 0, 0, 10, 10,
-100, -100, -100, 10, 10, 30, 0}, {50, 0, 0, 10, 10, -100, -100, -100, 10, 10,
30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35L*AU, 40, 0, 0, 50*LB, SECOND, 4,
0, MODERATE, 0, 0, MEAT_MEAT, 10, 0, 0, 0, 0, JUMPER, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "Kraken", "", "", "Kraken's carcass", ICON_KRAKEN, 0, 0, {20, 0, 0, 50, 10, -100,
-100, -100, 10, 10, 80, 0}, {20, 0, 0, 50, 10, -100, -100, -100, 10, 10, 80,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1000000L*AU, 40, 0, 0, 70L*TON,
20L*SECOND, 1, 0, EXTREMELY_DIFFICULT, 0, 0, MEAT_MEAT, 90, 0, 0, 0, 0,
KRAKEN, 0, WATER_ONLY|UNIQUE|TERRIFYING|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0,
HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "kriit", "", "", "kriit's carcass", ICON_KRIIT, 20, 0, {10, 0, 0, 10, 30, -100,
-100, -100, 20, 15, 0, 0}, {10, 0, 0, 10, 30, -100, -100, -100, 20, 15, 0, 0},
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 350L*AU, 45, 0, 0, 400*LB, 3L*SECOND, 3, 0,
VERY_DIFFICULT, 0, 0, MEAT_MEAT, 40, 0, 0, 0, 0, KRIIT, 0, MISSLE_ATTACK, 0,
0, 0, 0, 0, 0, 0, 0, CLAWS, SPITS_ACID_ON, NULL, NULL, NULL, NULL, NULL, NULL,
NULL, 0, 0, 0, 0},

{"", "land octopus", "", "", "land octopus's carcass", ICON_LAND_OCTOPUS, 0, 0, {10, 0, 0,
10, 10, -100, -100, -100, 10, 10, 20, 0}, {10, 0, 0, 10, 10, -100, -100, -100,
10, 10, 20, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 700L*AU, 40, 0, 0, 160*LB,
4L*SECOND, 1, 0, DIFFICULT, 0, 0, MEAT_NAME_ALONE, 30, 0, 0, 0, 0,
LAND_OCTOPUS, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, SQUEEZES, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "lavishnatim", "", "", "lavishnatim's carcass", ICON_LAVISHNATIM, 0, -20, {25, 0, 0,
10, 20, -100, -100, -100, 10, 10, -10, 0}, {25, 0, 0, 10, 20, -100, -100,
-100, 10, 10, -10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15L*AU, 40, 0, 0,
300*LB, 5L*SECOND, 2, 0, MODERATE, 0, 0, MEAT_MEAT, 10, 0, 0, 0, 0,
LAVISHNATIM, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "Leviathan", "", "", "Leviathan's carcass", ICON_LEVIATHAN, 40, 0, {20, 0, 0, 40,
10, -100, -100, -100, -10, 10, 80, 0}, {20, 0, 0, 40, 10, -100, -100, -100,
-10, 10, 80, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1000000L*AU, 40, 0, 0,
30L*TON, 15L*SECOND, 1, 0, EXTREMELY_DIFFICULT, 0, 0, MEAT_STEAK, 99, 0, 0, 0,
0, LEVIATHAN, 0, UNIQUE|TERRIFYING|MISSLE_ATTACK|BELLICOSE, 0, 0, 0, 0, 0, 0,
0, 0, CLAWS|BITES|TRAMPLES, BREATHES_FIRE_ON, NULL, NULL, NULL, NULL, NULL,
NULL, NULL, 0, 0, 0, 0},

{"", "lion", "", "", "lion's carcass", ICON_LION, 0, 0, {30, 0, 0, 10, 20,
-100, -100, -100, 30, 10, 30, 0}, {30, 0, 0, 10, 20, -100, -100, -100, 30, 10,
30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1500L*AU, 40, 0, 0, 800L*LB,
5L*SECOND, 30, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 20, 0, 0, 0, 0, LION, 0,
BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, CLAWS|BITES, MSL_HITS, NULL, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "mammoth", "", "", "mammoth's carcass", ICON_MAMMOTH, 0, 0, {0, 0, 0, 20, 10,
-100, -100, -100, 0, 10, 40, 0}, {0, 0, 0, 20, 10, -100, -100, -100, 0, 10,
40, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5000L*AU, 40, 0, 0, 10L*TON,
10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 70, 0, 0, 0, 0, MAMMOTH,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, RAMS|TRAMPLES|GORES, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "mastodon", "", "", "mastodon's carcass", ICON_MASTODON, 0, 0, {0, 0, 0, 20, 10,
-100, -100, -100, 0, 10, 40, 0}, {0, 0, 0, 20, 10, -100, -100, -100, 0, 10,
40, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5000L*AU, 40, 0, 0, 10L*TON,
10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 70, 0, 0, 0, 0, MASTODON,
0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, RAMS|TRAMPLES|GORES, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "mile long snake", "", "", "mile long snake's carcass", ICON_MILE_LONG_SNAKE, 0, 0, {10,
0, 0, 10, 10, -100, -100, -100, 10, 10, 80, 0}, {10, 0, 0, 10, 10, -100, -100,
-100, 10, 10, 80, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100000L*AU, 40, 0, 0,
100L*TON, 15L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 40, 0, 0, 0, 0,
MILE_LONG_SNAKE, 0, TERRIFYING|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0,
BITES|SQUEEZES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0,
0},

{"", "milshh", "", "", "milshh's carcass", ICON_MILSHH, 0, -20, {20, 0, 0, 10, 10,
-100, -100, -100, 30, 20, -20, 0}, {20, 0, 0, 10, 10, -100, -100, -100, 30,
20, -20, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5L*AU, 50, 0, 0, 5*LB,
5L*SECOND, 1, 0, VERY_EASY, 0, 0, 0, 0, 0, 0, 0, MEAT_MEAT, MILSHH, 0,
NO_DEFEND_MASTER, 0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "mimic", "", "", "mimic's carcass", ICON_MIMIC, 0, -10, {10, 0, 0, 10, 10, -100,
-100, -100, 25, 10, -20, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 25, 10, -20,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10L*AU, 40, 0, 0, 2*LB, 5L*SECOND, 1, 0,
EASY, 0, 0, MEAT_MEAT, 1, 0, 0, 0, 0, MIMIC, 0, NO_DEFEND_MASTER, 0, 0, 0, 0,
0, 0, 0, 0, CLAWS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0,
0, 0},

{"", "mirior", "", "", "mirior's carcass", ICON_MIRIOR, 0, -10, {10, 0, 0, 0, 10,
-100, -100, -100, 10, 10, 0, 0}, {10, 0, 0, 0, 10, -100, -100, -100, 10, 10,
0, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1000L*AU, 40, 0, 0, 4*LB, 10L*SECOND,
1, 0, EASY, 0, 0, MEAT_MEAT, 0, 0, 0, 0, 0, MIRIOR, 0, NO_DEFEND_MASTER, 0, 0,
0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0,
0, 0, 0},

{"", "mishraim", "", "", "mishraim's carcass", ICON_MISHRAIM, 0, -10, {10, 0, 0, 10, 10,
-100, -100, -100, 0, 10, 30, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 0, 10,
30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25L*AU, 40, 0, 0, 140*LB, 5L*SECOND,
1, 0, MODERATE, 0, 0, MEAT_MEAT, 10, 0, 0, 0, 0, MISHRAIM, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0,
0},

{"", "monkey", "", "", "monkey's carcass", ICON_MONKEY, 0, -30, {20, 0, 0, 10, 20,
-100, -100, -100, 10, 10, -10, 0}, {20, 0, 0, 10, 20, -100, -100, -100, 10,
10, -10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30L*SI, 40, 0, 0, 24*OZ, SECOND,
2, 0, MODERATE, 0, 0, MEAT_MEAT, 10, 0, 0, 0, 0, MONKEY, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, CLAWS|BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0,
0, 0, 0},

{"", "mouse", "", "", "mouse's carcass", ICON_MOUSE, 0, -10, {10, 0, 0, 10, 10, -100,
-100, -100, 10, 10, -50, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10, 10, -50,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4L*CU, 40, 0, 0, 3*OZ, 2L*SECOND, 1, 0,
MODERATE, 0, 0, MEAT_NONE, 5, 0, 0, 0, 0, MOUSE, 0, NO_DEFEND_MASTER, 0, 0, 0,
0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0,
0, 0, 0},

{"", "muckdweller", "", "", "muckdweller's carcass", ICON_MUCKDWELLER, 0, 0, {30, 0, 0, 10,
10, -100, -100, -100, 10, 10, 30, 0}, {30, 0, 0, 10, 10, -100, -100, -100, 10,
10, 30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1000L*AU, 40, 0, 0, 500L*LB,
10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 80, 0, 0, 0, 0,
MUCKDWELLER, 0, BELLICOSE|HIDDEN, 0, 0, 0, 0, 0, 0, 0, 0, HITS|SQUEEZES,
MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "octopus", "", "", "octopus's carcass", ICON_OCTOPUS, 0, 0, {10, 0, 0, 30, 10,
-100, -100, -100, 10, 10, 40, 0}, {10, 0, 0, 30, 10, -100, -100, -100, 10, 10,
40, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200L*AU, 40, 0, 0, 200*LB,
10L*SECOND, 1, 0, DIFFICULT, 0, 0, MEAT_NAME_ALONE, 40, 0, 0, 0, 0, OCTOPUS,
0, WATER_ONLY, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL,
NULL, NULL, 0, 0, 0, 0},

{"", "ostrich", "", "", "ostrich's carcass", ICON_OSTRICH, 0, 0, {-10, 0, 0, 0, 0,
-100, -100, -100, 0, 30, 25, 0}, {-10, 0, 0, 0, 0, -100, -100, -100, 0, 30,
25, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250L*AU, 60, 0, 0, 75*LB, 3L*SECOND,
1, 0, DIFFICULT, 0, 0, MEAT_NAME_ALONE, 30, 0, 0, 0, 0, OSTRICH, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0,
0, 0, 0},

{"", "owl", "", "", "owl's carcass", ICON_OWL, 0, -10, {10, 0, 0, 10, 10, -100,
-100, -100, 10, 10, 0, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10, 10, 0, 0},
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15L*AU, 40, 0, 0, 3*LB, 5L*SECOND, 1, 0,
DIFFICULT, 0, 0, MEAT_ROAST, 10, 0, 0, 0, 0, OWL, 0, FLYING|ABOVE_GROUND, 0,
0, 0, 0, 0, 0, 0, 0, CLAWS|BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL,
NULL, NULL, 0, 0, 0, 0},

{"", "panther", "", "", "panther's carcass", ICON_PANTHER, 0, 0, {30, 0, 0, 10, 20,
-100, -100, -100, 30, 10, 30, 0}, {30, 0, 0, 10, 20, -100, -100, -100, 30, 10,
30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2000L*AU, 40, 0, 0, 650L*LB,
5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 20, 0, 0, 0, 0, PANTHER, 0,
BELLICOSE|HIDDEN, 0, 0, 0, 0, 0, 0, 0, 0, CLAWS|BITES, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "parrot", "", "", "parrot's carcass", ICON_PARROT, 0, -10, {20, 0, 0, 10, 10,
-100, -100, -100, 10, 25, -30, 0}, {20, 0, 0, 10, 10, -100, -100, -100, 10,
25, -30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5L*AU, 55, 0, 0, 8*OZ,
3L*SECOND, 1, 0, MODERATE, 0, 0, MEAT_ROAST, 10, 0, 0, 0, 0, PARROT, 0,
NO_DEFEND_MASTER, 0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "pegasus", "", "", "pegasus's carcass", ICON_PEGASUS, 0, 0, {20, 0, 0, 10, 10, -100,
-100, -100, 10, 10, 30, 0}, {20, 0, 0, 10, 10, -100, -100, -100, 10, 10, 30,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80L*AU, 40, 0, 0, 1000L*LB, 5L*SECOND, 1,
0, DIFFICULT, 0, 0, MEAT_MEAT, 30, 0, 0, 0, 0, PEGASUS, 0, FLYING|ABOVE_GROUND,
0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL,
NULL, 0, 0, 0, 0},

{"", "pike", "", "", "pike's carcass", ICON_PIKE, 0, 0, {10, 0, 0, -10, 10, -100,
-100, -100, 10, 10, 0, 0}, {10, 0, 0, -10, 10, -100, -100, -100, 10, 10, 0,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2L*AU, 40, 0, 0, 3*LB, 3L*SECOND, 1, 0,
DIFFICULT, 0, 0, MEAT_FILLET, 20, 0, 0, 0, 0, PIKE, 0, WATER_ONLY|BELLICOSE,
0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, 0,
0, 0, 0},

{"", "piranha", "", "", "piranha's carcass", ICON_PIRANHA, 0, 10, {10, 0, 0, -10, 10,
-100, -100, -100, 10, 10, 0, 0}, {10, 0, 0, -10, 10, -100, -100, -100, 10, 10,
0, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40L*AU, 40, 0, 0, 3*LB, SECOND, 30, 0,
VERY_DIFFICULT, 0, 0, MEAT_FILLET, 90, 0, 0, 0, 0, PIRANHA, 0,
WATER_ONLY|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "platypus", "", "", "platypus's carcass", ICON_PLATYPUS, 0, 0, {10, 0, 0, 10, 10,
-100, -100, -100, 10, 10, -10, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10,
10, -10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5L*AU, 40, 0, 0, 10*LB,
5L*SECOND, 1, 0, MODERATE, 0, 0, MEAT_MEAT, 0, 0, 0, 0, 0, PLATYPUS, 0,
NO_DEFEND_MASTER, 0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "poison quilled porcupine", "", "", "poison quilled porcupine's carcass",
ICON_POISON_QUILLED_PORCUPINE, 30, 0, {10, 0, 0, 10, 10, -100, -100, -100, 10, 10, 0, 0}, {10, 0, 0, 10,
10, -100, -100, -100, 10, 10, 0, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 500L*AU,
40, 0, 0, 60*LB, 5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 20, 0, 0,
0, 0, POISON_QUILLED_PORCUPINE, 0, HITS_BACK, 0, 0, 0, 0, 0, 0, 0, 0, BITES,
MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "porcupine", "", "", "porcupine's carcass", ICON_PORCUPINE, 0, 0, {10, 0, 0, 10, 10,
-100, -100, -100, 10, 10, -20, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10,
10, -20, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15L*AU, 40, 0, 0, 5*LB,
3L*SECOND, 1, 0, DIFFICULT, 0, 0, MEAT_MEAT, 10, 0, 0, 0, 0, PORCUPINE, 0,
HITS_BACK, 0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL, NULL,
NULL, NULL, NULL, 0, 0, 0, 0},

{"", "prairie dog", "", "", "prairie dog's carcass", ICON_PRAIRIE_DOG, 0, 0, {10, 0, 0, 10,
10, -100, -100, -100, 10, 10, -15, 0}, {10, 0, 0, 10, 10, -100, -100, -100,
10, 10, -15, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5L*AU, 40, 0, 0, 10*LB,
2L*SECOND, 5, 0, MODERATE, 0, 0, MEAT_MEAT, 10, 0, 0, 0, 0, PRAIRIE_DOG, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL,
NULL, 0, 0, 0, 0},

{"", "pterodactyl", "", "", "pterodactyl's carcass", ICON_PTERODACTYL, 0, 10, {10, 0, 0,
20, 10, -100, -100, -100, 10, 30, 10, 0}, {10, 0, 0, 20, 10, -100, -100, -100,
10, 30, 10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200L*AU, 60, 0, 0, 50*LB,
5L*SECOND, 3, 0, DIFFICULT, 0, 0, MEAT_MEAT, 45, 0, 0, 0, 0, PTERODACTYL, 0,
FLYING|ABOVE_GROUND, 0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "python", "", "", "python's carcass", ICON_PYTHON, 0, 0, {10, 0, 0, 20, 10, -100,
-100, -100, 10, 10, 20, 0}, {10, 0, 0, 20, 10, -100, -100, -100, 10, 10, 20,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 40L*AU, 40, 0, 0, 80*LB, 10L*SECOND, 1,
0, DIFFICULT, 0, 0, MEAT_STEAK, 60, 0, 0, 0, 0, PYTHON, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, BITES|SQUEEZES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0,
0, 0},

{"", "quail", "", "", "quail's carcass", ICON_QUAIL, 0, -20, {20, 0, 0, 10, 10,
-100, -100, -100, 10, 10, -50, 0}, {20, 0, 0, 10, 10, -100, -100, -100, 10,
10, -50, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3L*CU, 40, 0, 0, 8*OZ,
2L*SECOND, 10, 0, MODERATE, 0, 0, MEAT_MEAT, 0, 0, 0, 0, 0, QUAIL, 0,
FLYING|ABOVE_GROUND|NO_DEFEND_MASTER, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "rabbit", "", "", "rabbit's carcass", ICON_RABBIT, 0, -10, {20, 0, 0, 10, 10,
-100, -100, -100, 20, 25, -30, 0}, {20, 0, 0, 10, 10, -100, -100, -100, 20,
25, -30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2L*SI, 55, 0, 0, 5*LB, SECOND,
1, 0, MODERATE, 0, 0, 0, MEAT_ROAST, 0, 0, 0, 0, RABBIT, 0, NO_DEFEND_MASTER,
0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL,
NULL, 0, 0, 0, 0},

{"", "ram", "", "", "ram's carcass", ICON_RAM, 0, 0, {10, 0, 0, 10, 10, -100, -100,
-100, 10, 10, 20, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10, 10, 20, 0}, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35L*AU, 40, 0, 0, 45*LB, 5L*SECOND, 1, 0,
DIFFICULT, 0, 0, MEAT_STEAK, 50, 0, 0, 0, 0, RAM, 0, BELLICOSE, 0, 0, 0, 0, 0,
0, 0, 0, RAMS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0,
0},

{"", "rat", "", "", "rat's carcass", ICON_RAT, 0, 0, {10, 0, 0, -30, 10, -100,
-100, -100, 10, 10, -10, 0}, {10, 0, 0, -30, 10, -100, -100, -100, 10, 10,
-10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7L*CU, 40, 0, 0, 1*LB, 3L*SECOND, 5,
0, DIFFICULT, 0, 0, MEAT_NONE, 50, 0, 0, 0, 0, RAT, 0, BELLICOSE, 0, 0, 0, 0,
0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "rhinoceros", "", "", "rhinoceros's carcass", ICON_RHINOCEROS, 0, 0, {0, 0, 0, 20,
10, -100, -100, -100, 0, 10, 30, 0}, {0, 0, 0, 20, 10, -100, -100, -100, 0, 10,
40, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2000L*AU, 40, 0, 0, 2L*TON,
10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 70, 0, 0, 0, 0, RHINOCEROS,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, GORES|TRAMPLES, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "ricochet", "", "", "ricochet's carcass", ICON_RICOCHET, 0, 0, {30, 0, 0, 10, 10,
-100, -100, -100, 20, 40, 20, 0}, {30, 0, 0, 10, 10, -100, -100, -100, 20, 40,
20, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65L*AU, 70, 0, 0, 40*LB, SECOND, 1,
0, DIFFICULT, 0, 0, 0, MEAT_MEAT, 20, 0, 0, 0, RICOCHET, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0,
0},

{"", "Roc", "", "", "Roc's carcass", ICON_ROC, 0, -10, {0, 0, 0, 10, 10, -100,
-100, -100, 20, -20, 70, 0}, {0, 0, 0, 10, 10, -100, -100, -100, 20, -20, 70,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1000000L*AU, 10, 0, 0, 10L*TON,
15L*SECOND, 1, 0, EXTREMELY_DIFFICULT, 0, 0, MEAT_ROAST, 90, 0, 0, 0, 0, ROC,
0, FLYING|UNIQUE|TERRIFYING|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, BITES|CLAWS,
MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "rock crusher", "", "", "rock crusher's carcass", ICON_ROCK_CRUSHER, 0, 0, {-10, 0, 0,
30, 0, -100, -100, -100, 0, -20, 80, 0}, {-10, 0, 0, 30, 0, -100, -100, -100,
0, -20, 80, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70000L*AU, 10, 0, 0, 80L*TON,
20L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_STEAK, 30, 0, 0, 0, 0,
ROCK_CRUSHER, 0, TERRIFYING|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0,
SQUEEZES|TRAMPLES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0,
0, 0},

{"", "rock thrower", "", "", "rock thrower's carcass", ICON_ROCK_THROWER, 0, 0, {10, 0, 0,
10, 20, -100, -100, -100, 20, 10, 20, 0}, {10, 0, 0, 10, 20, -100, -100, -100,
20, 10, 20, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 150L*AU, 40, 0, 0, 80*LB,
3L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 70, 0, 0, 0, 0,
ROCK_THROWER, 0, MISSLE_ATTACK, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "rodent of unusual size", "", "", "rodent of unusual size's carcass",
ICON_RODENT_OF_UNUSUAL_SIZE, 0, 0, {30, 0, 0, 10, 10, -100, -100, -100, 20, 25, 10, 0}, {30, 0, 0,
10, 10, -100, -100, -100, 20, 25, 10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
35L*AU, 55, 0, 0, 75*LB, 3L*SECOND, 2, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 70,
0, 0, 0, 0, RODENT_OF_UNUSUAL_SIZE, 0, BELLICOSE|HIDDEN, 0, 0, 0, 0, 0, 0, 0, 0,
BITES|CLAWS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "sand trapper", "", "", "sand trapper's carcass", ICON_SAND_TRAPPER, 0, 0, {10, 0, 0,
10, 20, -100, -100, -100, 10, 30, 30, 0}, {10, 0, 0, 10, 20, -100, -100, -100,
10, 30, 30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 400L*AU, 60, 0, 0, 1000L*LB,
5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 70, 0, 0, 0, 0,
SAND_TRAPPER, 0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, SQUEEZES, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "scorpion", "", "", "scorpion's sting", ICON_SCORPION, 30, 0, {10, 0, 0, -20, 10,
-100, -100, -100, 10, 20, -20, 0}, {10, 0, 0, -20, 10, -100, -100, -100, 10,
20, -20, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5L*AU, 50, 0, 0, 2*OZ, SECOND,
2, 0, VERY_DIFFICULT, 0, 0, MEAT_NONE, 50, 0, 0, 0, 0, SCORPION, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, STINGS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0,
0, 0},

{"", "sea serpent", "", "", "sea serpent's carcass", ICON_SEA_SERPENT, 0, 0, {20, 0, 0, 20,
10, -100, -100, -100, 10, 0, 40, 0}, {20, 0, 0, 20, 10, -100, -100, -100, 10,
0, 40, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50000L*AU, 30, 0, 0, 20L*TON,
20L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_STEAK, 80, 0, 0, 0, 0,
SEA_SERPENT, 0, WATER_ONLY|TERRIFYING|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0,
BITES|SQUEEZES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0,
0},

{"", "seal", "", "", "seal's carcass", ICON_SEAL, 0, -10, {0, 0, 0, 20,
10, -100, -100, -100, 0, 10, 30, 0}, {0, 0, 0, 20, 10, -100, -100, -100, 0, 10,
30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1500L*AU, 4, 0, 0, 700L*LB,
10L*SECOND, 1, 0, DIFFICULT, 0, 0, MEAT_MEAT, 70, 0, 0, 0, 0, SEAL,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "shark", "", "", "shark's carcass", ICON_SHARK, 0, 0, {10, 0, 0, 50, 10, -100,
-100, -100, 10, 10, 50, 0}, {10, 0, 0, 50, 10, -100, -100, -100, 10, 10, 50,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2000L*AU, 40, 0, 0, 1000L*LB, 10L*SECOND,
5, 0, VERY_DIFFICULT, 0, 0, MEAT_STEAK, 50, 0, 0, 0, 0, SHARK, 0,
WATER_ONLY|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "shocker", "", "", "shocker's carcass", ICON_SHOCKER, 40, 10, {20, 0, 0, 20, 10,
-100, -100, -100, 10, 10, 30, 0}, {20, 0, 0, 20, 10, -100, -100, -100, 10, 10,
30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 850L*AU, 40, 0, 0, 850L*LB,
5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 60, 0, 0, 0, 0, SHOCKER, 0,
BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, SHOCKS, MSL_HITS, NULL, NULL, NULL, NULL,
NULL, NULL, NULL, 0, 0, 0, 0},

{"", "skunk", "", "", "skunk's carcass", ICON_SKUNK, 0, -10, {10, 0, 0, 10, 10, -100,
-100, -100, 10, 10, -20, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10, 10, -20,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2L*CU, 40, 0, 0, 3*LB, 3L*SECOND, 1, 0,
DIFFICULT, 0, 0, MEAT_MEAT, 30, 0, 0, 0, 0, SKUNK, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "sloth", "", "", "sloth's carcass", ICON_SLOTH, 0, -20, {10, 0, 0, 10, 10, -100,
-100, -100, 10, -20, -15, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 10, -20,
-15, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5L*SI, 10, 0, 0, 25*LB, 20L*SECOND,
2, 0, EASY, 0, 0, MEAT_MEAT, 0, 0, 0, 0, 0, SLOTH, 0, NO_DEFEND_MASTER, 0, 0,
0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
0, 0, 0, 0},

{"", "soft rolling stone", "", "", "soft rolling stone's carcass", ICON_SOFT_ROLLING_STONE, 0,
-30, {0, 0, 0, 20, 0, -100, -100, -100, -30, -10, -30, 0}, {0, 0, 0, 20, 0,
-100, -100, -100, -30, -10, -30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6L*SI,
20, 0, 0, 3*LB, 10L*SECOND, 1, 0, EASY, 0, 0, MEAT_MEAT, 0, 0, 0, 0, 0,
SOFT_ROLLING_STONE, 0, NO_DEFEND_MASTER, 0, 0, 0, 0, 0, 0, 0, 0, HITS,
MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "sparrow", "", "", "sparrow's carcass", ICON_SPARROW, 0, -20, {20, 0, 0, 10, 10,
-100, -100, -100, 10, 10, -50, 0}, {20, 0, 0, 10, 10, -100, -100, -100, 10,
10, -50, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3L*CU, 40, 0, 0, 3*OZ,
2L*SECOND, 10, 0, MODERATE, 0, 0, MEAT_NONE, 0, 0, 0, 0, 0, SPARROW, 0,
FLYING|ABOVE_GROUND|NO_DEFEND_MASTER, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "spinstar", "", "", "spinstar's carcass",  ICON_SPINSTAR, 0, 0, {30, 0, 0, 10, 10,
-100, -100, -100, 10, 10, -30, 0}, {30, 0, 0, 10, 10, -100, -100, -100, 10,
10, -30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15L*AU, 50, 0, 0, 6*OZ, SECOND,
50, 0, MODERATE, 0, 0, MEAT_NONE, 0, 0, 0, 0, 0, SPINSTAR, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0,
0},

{"", "stegosaurus", "", "", "stegosaurus's carcass",  ICON_STEGOSAURUS, 0, 0, {0, 0, 0, 40,
-20, -100, -100, -100, -30, -10, 50, 0}, {0, 0, 0, 40, -20, -100, -100, -100,
-30, -10, 50, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30000L*AU, 20, 0, 0,
15L*TON, 15L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_STEAK, 70, 0, 0, 0, 0,
STEGOSAURUS, 0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, RAMS|TRAMPLES, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "stinging insect", "", "", "stinging insect's carcass", ICON_STINGING_INSECT, 30, -50,
{25, 0, 0, 25, 10, -100, -100, -100, 25, 20, -30, 0}, {25, 0, 0, 25, 10, -100,
-100, -100, 25, 20, -30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4L*SI, 50, 0, 0,
3*OZ, SECOND, 1000, 0, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 95, 0, 0, 0,
STINGING_INSECT, 0, TERRIFYING|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, STINGS,
MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "stoneshell", "", "", "stoneshell's carcass",  ICON_STONESHELL, 0, 0, {10, 0, 0, 80,
10, -100, -100, -100, 10, 10, 10, 0}, {10, 0, 0, 80, 10, -100, -100, -100, 10,
10, 10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15000L*AU, 40, 0, 0, 4L*TON,
10L*SECOND, 1, 0, DIFFICULT, 0, 0, MEAT_MEAT, 40, 0, 0, 0, 0, STONESHELL, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, BEATS, MSL_HITS, NULL, NULL, NULL, NULL, NULL,
NULL, NULL, 0, 0, 0, 0},

{"", "strider", "", "", "strider's carcass", ICON_STRIDER, 0, 0, {25, 0, 0, 25, 10,
-100, -100, -100, 10, 30, 20, 0}, {25, 0, 0, 25, 10, -100, -100, -100, 10, 30,
20, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 250L*AU, 90, 0, 0, 65*LB, SECOND, 2,
0, DIFFICULT, 0, 0, MEAT_MEAT, 35, 0, 0, 0, 0, STRIDER, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0,
0},

{"", "swamp thing", "", "", "swamp thing's carcass", ICON_SWAMP_THING, 0, 0, {20, 0, 0,
10, 10, -100, -100, -100, 10, 10, 50, 0}, {20, 0, 0, 10, 10, -100, -100, -100,
10, 10, 50, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 800L*AU, 40, 0, 0, 500L*LB,
10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 80, 0, 0, 0, 0,
SWAMP_THING, 0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, HITS|SQUEEZES, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "tail spikethrower", "", "", "tail spikethrower's carcass", ICON_TAIL_SPIKETHROWER, 20, 0,
{10, 0, 0, 20, 20, -100, -100, -100, 10, 10, 30, 0}, {10, 0, 0, 20, 20, -100,
-100, -100, 10, 10, 30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 900L*AU, 40, 0,
0, 350*LB, 5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_STEAK, 70, 0, 0, 0, 0,
TAIL_SPIKETHROWER, 0, MISSLE_ATTACK|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0,
BITES|STINGS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "tar baby", "", "", "tar baby's carcass", ICON_TAR_BABY, 0, -10, {-30, 0, 0, 30,
10, -100, -100, -100, 10, 0, 10, 0}, {-30, 0, 0, 30, 10, -100, -100, -100, 10,
0, 10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20L*AU, 30, 0, 0, 20*LB,
5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_DEAD, 20, 0, 0, 0, 0, TAR_BABY, 0,
STICKY, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL,
NULL, NULL, 0, 0, 0, 0},

{"", "Terrask", "", "", "Terrask's carcass", ICON_TERRASK, 0, 0, {10, 0, 0, 80, 10,
-100, -100, -100, 10, 10, 100, 0}, {10, 0, 0, 80, 10, -100, -100, -100, 10,
10, 100, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1000000L*AU, 40, 0, 0, 100L*TON,
30L*SECOND, 1, 0, EXTREMELY_DIFFICULT, 0, 0, MEAT_MEAT, 90, 0, 0, 0, 0,
TERRASK, 0, UNIQUE|TERRIFYING|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0,
BITES|CLAWS|TRAMPLES|RAMS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
0, 0, 0, 0},

{"", "thousand legged roller", "", "", "thousand legged roller's carcass",
ICON_THOUSAND_LEGGED_ROLLER, 0, 0, {25, 0, 0, 10, 10, -100, -100, -100, 20, 30, 30, 0}, {25, 0, 0, 10,
10, -100, -100, -100, 20, 30, 30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
2000L*AU, 60, 0, 0, 250*LB, 3L*SECOND, 3, 0, DIFFICULT, 0, 0, MEAT_MEAT, 5, 0,
0, 0, 0, THOUSAND_LEGGED_ROLLER, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "ticklebug", "", "", "ticklebug's carcass", ICON_TICKLEBUG, 0, 0, {10, 0, 0, 10, 30,
-100, -100, -100, 30, 10, -30, 0}, {10, 0, 0, 10, 30, -100, -100, -100, 30,
10, -30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3L*SI, 40, 0, 0, LB, 3L*SECOND,
1, 0, EASY, 0, 0, MEAT_NONE, 0, 0, 0, 0, 0, TICKLEBUG, 0, NO_DEFEND_MASTER, 0,
0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
0, 0, 0, 0},

{"", "tiger", "", "", "tiger's carcass", ICON_TIGER, 0, 0, {30, 0, 0, 10, 20,
-100, -100, -100, 30, 10, 30, 0}, {30, 0, 0, 10, 20, -100, -100, -100, 30, 10,
30, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2500L*AU, 40, 0, 0, 650L*LB,
5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 20, 0, 0, 0, 0, TIGER, 0,
BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, CLAWS|BITES, MSL_HITS, NULL, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "torpor beast", "", "", "torpor beast's carcass", ICON_TORPOR_BEAST, 40, 0, {10, 0, 0,
10, 10, -100, -100, -100, 10, 10, 10, 0}, {10, 0, 0, 10, 10, -100, -100, -100,
10, 10, 10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 950L*AU, 40, 0, 0, 100*LB,
5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_MEAT, 60, 0, 0, 0, 0,
TORPOR_BEAST, 0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "translucent frog", "", "", "translucent frog's carcass", ICON_TRANSLUCENT_FROG, 0, -10,
{25, 0, 0, 10, 10, -100, -100, -100, 10, 10, 10, 0}, {25, 0, 0, 10, 10, -100,
-100, -100, 10, 10, 10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4L*AU, 40, 0, 0,
8*OZ, 2L*SECOND, 1, 0, MODERATE, 0, 0, MEAT_NONE, 0, 0, 0, 0, 0,
TRANSLUCENT_FROG, 0, NO_DEFEND_MASTER, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "triceratops", "", "", "triceratops's carcass",  ICON_TRICERATOPS, 0, 0, {0, 0, 0, 20,
-20, -100, -100, -100, -30, -10, 50, 0}, {0, 0, 0, 40, -20, -100, -100, -100,
-30, -10, 50, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10000L*AU, 20, 0, 0,
5L*TON, 10L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_STEAK, 70, 0, 0, 0, 0,
TRICERATOPS, 0, BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, RAMS|TRAMPLES|GORES,
MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "trin", "", "", "trin's carcass", ICON_TRIN, 0, -20, {30, 0, 0, 10, 10, -100,
-100, -100, 10, 10, -10, 0}, {30, 0, 0, 10, 10, -100, -100, -100, 10, 10, -10,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15L*SI, 40, 0, 0, 15*LB, 3L*SECOND, 30,
0, MODERATE, 0, 0, MEAT_MEAT, 10, 0, 0, 0, 0, TRIN, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "trout", "", "", "trout's carcass", ICON_TROUT, 0, 0, {10, 0, 0, -20, 10, -100,
-100, -100, 10, 10, -10, 0}, {10, 0, 0, -20, 10, -100, -100, -100, 10, 10,
-10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8L*SI, 40, 0, 0, 2*LB, 2L*SECOND, 5,
0, MODERATE, 0, 0, MEAT_FILLET, 20, 0, 0, 0, 0, TROUT, 0, WATER_ONLY, 0, 0, 0,
0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0,
0},

{"", "turtle", "", "", "turtle's carcass", ICON_TURTLE, 0, 0, {-10, 0, 0, 60, 0, -100,
-100, -100, 0, -30, 10, 0}, {-10, 0, 0, 60, 0, -100, -100, -100, 0, -30, 10,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 50L*AU, 5, 0, 0, 100*LB, 10L*SECOND, 1,
0, MODERATE, 0, 0, MEAT_MEAT, 20, 0, 0, 0, 0, TURTLE, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, HITS, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "tyrannosaurus rex", "", "", "tyrannosaurus rex's carcass", ICON_TYRANNOSAURUS_REX, 0, 0,
{-10, 0, 0, 10, 10, -100, -100, -100, 0, -10, 60, 0}, {-10, 0, 0, 10, 10,
-100, -100, -100, 0, -10, 60, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 70000L*AU,
20, 0, 0, 40L*TON, 15L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_STEAK, 95, 0,
0, 0, 0, TYRANNOSAURUS_REX, 0, TERRIFYING|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0,
TRAMPLES|CLAWS|BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0,
0, 0, 0},

{"", "velociraptor", "", "", "velociraptor's carcass", ICON_VELOCIRAPTOR, 0, 10, {10, 0, 0,
20, 10, -100, -100, -100, 10, 30, 10, 0}, {10, 0, 0, 20, 10, -100, -100, -100,
10, 30, 10, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 200L*AU, 60, 0, 0, 200*LB,
5L*SECOND, 3, 0, DIFFICULT, 0, 0, MEAT_MEAT, 45, 0, 0, 0, 0, VELOCIRAPTOR, 0,
FLYING|ABOVE_GROUND, 0, 0, 0, 0, 0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "walrus", "", "", "walrus's carcass", ICON_WALRUS, 0, -10, {0, 0, 0, 20,
10, -100, -100, -100, 0, 10, 30, 0}, {0, 0, 0, 20, 10, -100, -100, -100, 0, 10,
40, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2500L*AU, 4, 0, 0, 1500L*LB,
15L*SECOND, 1, 0, DIFFICULT, 0, 0, MEAT_MEAT, 70, 0, 0, 0, 0, WALRUS,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, BITES|GORES, MSL_HITS, NULL,
NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "warm fuzzy", "", "", "warm fuzzy's carcass", ICON_WARM_FUZZY, 0, -30, {10, 0, 0, 10,
10, -100, -100, -100, 30, 0, -20, 0}, {10, 0, 0, 10, 10, -100, -100, -100, 30,
0, -20, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7L*SI, 30, 0, 0, 3*LB,
10L*SECOND, 1, 0, EASY, 0, 0, MEAT_MEAT, 0, 0, 0, 0, 0, WARM_FUZZY, 0,
NO_DEFEND_MASTER, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS, NULL, NULL, NULL,
NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "wind hummer", "", "", "wind hummer's carcass", ICON_WIND_HUMMER, 30, 0, {50, 0, 0,
10, 10, -100, -100, -100, 10, 20, -40, 0}, {50, 0, 0, 10, 10, -100, -100,
-100, 10, 20, -40, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45L*AU, 50, 0, 0, LB,
SECOND, 1, 0, DIFFICULT, 0, 0, MEAT_NONE, 40, 0, 0, 0, 0, WIND_HUMMER, 0,
FLYING|ABOVE_GROUND|HIDDEN|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, HITS, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0},

{"", "wolf", "", "", "wolf's carcass", ICON_WOLF, 0, 0, {10, 0, 0, 10, 20, -100,
-100, -100, 10, 10, 20, 0}, {10, 0, 0, 10, 20, -100, -100, -100, 10, 10, 20,
0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 45L*AU, 40, 0, 0, 50*LB, 3L*SECOND, 30,
0, DIFFICULT, 0, 0, MEAT_MEAT, 30, 0, 0, 0, 0, WOLF, 0, BELLICOSE, 0, 0, 0, 0,
0, 0, 0, 0, BITES, MSL_HITS, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0,
0},

{"", "wyvern", "", "", "wyvern's carcass", ICON_WYVERN, 30, 0, {20, 0, 0, 20, 10,
-100, -100, -100, 10, 10, 25, 0}, {20, 0, 0, 20, 10, -100, -100, -100, 10, 10,
25, 0}, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1000L*AU, 40, 0, 0, 200*LB,
5L*SECOND, 1, 0, VERY_DIFFICULT, 0, 0, MEAT_STEAK, 80, 0, 0, 0, 0, WYVERN, 0,
FLYING|ABOVE_GROUND|BELLICOSE, 0, 0, 0, 0, 0, 0, 0, 0, CLAWS|STINGS, MSL_HITS,
NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 0} };
