/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2005 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include <string.h>
#include "tms.h"

#ifdef CODE_SEGMENT
#pragma segment EFFECT1_C
#endif

char *shop_choice[9] =
    {
    "Browse through the inventory.",
    "Haggle over the price of an item in the shop.",
    "Purchase an item.",
    "Haggle over the price of an item you wish to sell.",
    "Sell an item.",
    "Have an item identified.",
    "Request that the shop try to acquire an item.",
    "Look at your inventory.",
    "Exit the shop."
    };

char *hospice_choice[5] =
    {
    "Rest here and receive care for a day.",
    "Rest here and receive care until you are well.",
    "Rest here and receive care until you and all your followers are well.",
    "Make a donation of 10 gold sovereigns.",
    "Exit."
    };

long space_effect(struct small_creature *c, long x, long y)
    {
    long result, i;
    result = 1;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    if (flag_check(current_level->flags, IS_CITY))
        if (flag_check(current_level->space[x][y].flags,
          OTHER_IS_LOCATION_TYPE))
            for(i = 0; i < NUM_LOCATION_TYPES; ++i)
                if (current_level->location[i].identity ==
                  current_level->space[x][y].other)
                    if (!(flag_check(current_level->location
                      [i].flags, LOCATION_KNOWN)))
                        {
                        flag_set(&current_level->location[i].flags,
                          LOCATION_KNOWN);
                        current_level->location[i].x = x;
                        current_level->location[i].y = y;
                        }
    switch(current_level->space[x][y].property)
        {
        case P_ADVENTURERS_GUILD:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                p_adventurers_guild(c);
                }
        break;
        case P_BED:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                p_bed(c);
                }
        break;
        case P_COLLECTION_BOX:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                }
            p_collection_box(c);
        break;
        case P_DEEP_WATER:
            p_deep_water(c, x, y);
        break;
        case P_DRY_TREE:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                }
            p_dry_tree(c, x, y);
        break;
        case P_ENTRANCE: case P_EXIT: case P_STAIRWELL_UP: case
        P_STAIRWELL_DOWN:
            if (c == player)
                change_level(x, y);
        break;
        case P_FINAL_TEST:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                p_final_test(c);
                }
        break;
        case P_FIRE:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                p_fire(c);
                }
        break;
        case P_FRUIT_TREE:
            p_fruit_tree(c, x, y);
        break;
        case P_GREEN_TREE:
            p_green_tree(c, x, y);
        break;
        case P_HEDGE:
            p_hedge(c);
        break;
        case P_HOUSE:
            p_house();
        break;
        case P_INN_ENTRANCE:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                result = p_inn_entrance(c);
                }
        break;
        case P_INSCRIPTION:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                }
            p_inscription(c);
        break;
        case P_MAPMAKER:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                p_mapmaker(c);
                }
        break;
        case P_MEDIC:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                if (c == player)
                    p_medic(c);
                }
        break;
        case P_MENTOR:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                }
            if (c == player)
                p_mentor();
        break;
        case P_NORTHERN_POOL:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                if (c == player)
                    p_northern_pool(c);
                }
        break;
        case P_PEAK:
            result = p_peak(c);
        break;
        case P_RESTAURANT:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                p_restaurant(c);
                }
        break;
        case P_RUBBLE:
            p_rubble(c);
        break;
        case P_SHALLOW_WATER:
            p_shallow_water(c, x, y);
        break;
        case P_SHOP:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                p_shop(c, current_level->space[c->x][c->y].special->shop,
                  current_level->space[c->x][c->y].sign);
                }
        break;
        case P_PRAYER_TABLE:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                p_prayer_table(c);
                }
        break;
        case P_TAVERN:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                p_tavern(c);
                }
        break;
        case P_TAVERN_SEAT:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                p_tavern_seat(c);
                }
        break;
        case P_TINKERERS_GUILD:
            if (c != NULL)
                {
                flag_reset(&c->flags, CONTROL_MOVE);
                flag_reset(&c->flags, SHIFT_MOVE);
                p_tinkerers_guild(c);
                }
        break;
        }
    return result;
    }

void p_deep_water(struct small_creature *c, long x, long y)
    {
    char message[256], title[256];
    long skill_value, weight;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    if (!(flag_check(c->flags, ABOVE_GROUND)))
        if (find_vehicle(c) == NULL || !(flag_check(find_vehicle(c)->flags2,
          I_TRAVEL_WATER)))
                {
                fatigue(c, min(UNITS_PER_SECOND * current_level->scale / 5,
                  MINUTE));
                if (!(flag_check(current_level->space[x][y].flags, SALT_WATER)))
                    drink_water(c);
                if (!(c->extended_creature == NULL))
                    {
                    skill_value = c->extended_creature->skills->av[SWIMMING];
                    weight = c->extended_creature->curr_weight;
                    }
                else
                    {
                    skill_value = VERY_DIFFICULT;
                    weight = 0;
                    }
                if (skill_check(c, skill_value, weight/100 + 2 * ONE_NOTCH *
                  (current_level == countryside),
                  SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE) > 0)
                    {
                    if (c == player)
                        {
                        if (!(flag_check(c->flags, ABOVE_GROUND)))
                            pmsg("You swim in.");
                        else if (flag_check(c->flags, ABOVE_GROUND))
                            pmsg("You fly above the water.");
                        }
                    }
                else
                    {
                    if (!(flag_check(c->flags, ABOVE_GROUND)) &&
                      !(flag_check(c->flags, WATER_ONLY)))
                        {
                        if (!(c->name == NULL))
                            strncpy(title, c->name->text, 255);
                        else if (!(c->extended_creature == NULL))
                            strncpy(title, c->extended_creature->title, 255);
                        else
#ifdef HAS_SNPRINTF
                            snprintf(title, 255, "The %s",
                              master_creatures[c->identity]->species);
#else
                            sprintf(title, "The %s",
                              master_creatures[c->identity]->species);
#endif
                        title[255] = '\0';
#ifdef HAS_SNPRINTF
                        snprintf(message, 255, "%s ", title);
#else
                        sprintf(message, "%s ", title);
#endif
                        if (c == player)
                            strncat(message, "are", 255);
                        else
                            strncat(message, "is", 255);
                        strncat(message, " drowning!", 255);
                        message[255] = '\0';
                        pmsg(message);
                        if (creature_damage(c, 0, CREATURE_DAMAGE_WAKE_UP, 0))
                            {
                            if (!(c->name == NULL))
                                strncpy(title, c->name->text, 255);
                            else if (!(c->extended_creature == NULL))
                                strncpy(title, c->extended_creature->title, 255);
                            else
#ifdef HAS_SNPRINTF
                                snprintf(title, 255, "The %s",
                                master_creatures[c->identity]->species);
#else
                                sprintf(title, "The %s",
                                master_creatures[c->identity]->species);
#endif
                            title[255] = '\0';
#ifdef HAS_SNPRINTF
                            snprintf(message, 255, "%s drowned!", title);
#else
                            sprintf(message, "%s drowned!", title);
#endif
                            message[255] = '\0';
                            pmsg(message);
                                    creature_death(c);
                            }
                        }
                    }
                }
    }

long p_peak(struct small_creature *c)
    {
    long result;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    if (!(flag_check(c->flags, ABOVE_GROUND)))
        {
        take_time(c, MINUTE);
        fatigue(c, SECOND);
        if (!(c->extended_creature == NULL))
            result = skill_check(c, c->extended_creature->skills->av[CLIMBING], MODERATE,
              SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE);
        else
            result = skill_check(c, DIFFICULT, MODERATE,
              SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE);
        if (result >= 1)
            {
            if (c == player)
                pmsg("You climb along...");
            }
        else if (result == 0)
            {
            if (c == player)
                pmsg("Hmm...  how do you get up there, anyway?");
            }
        else
            if (creature_damage(c, -30, CREATURE_DAMAGE_WAKE_UP, 2))
                creature_death(c);
        return result;
        }
    else
        return 1;
    }

/* It takes more time to walk through sand.  */

void p_sand(struct small_creature *c)
    {
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    if (!(flag_check(c->flags, ABOVE_GROUND)))
        take_time(c, SECOND);
    }

void p_shallow_water(struct small_creature *c, long x, long y)
    {
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    if (!(flag_check(c->flags, ABOVE_GROUND)))
        {
        if (c == player)
            pmsg("You wade in...");
        if (!(flag_check(current_level->space[x][y].flags, SALT_WATER)))
        drink_water(c);
        }
    }

void p_shop(struct small_creature *c, struct shop_struct *s, long sign_id)
    {
    char message[256], message2[1024], temp[256], temp2[256];
    struct ilist *curr_ilist;
    struct small_creature *curr_creature;
    struct small_item *curr_item;
    struct text_struct *text;
    long my_continue, foo, success_haggling, i, offer,
      success, selection_char, which;
    selection_char = 0;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
    check_pointer((struct pointer_struct *) s);
#endif
    if (flag_check(s->flags, NOT_STOCKED))
        stock_shop(s);
    my_continue = 1;
    if (my_daylight())
        {
        if ((game_variables->current_quest == WRESTLED_BLACKSMITH) &&
          (current_level->race == TUZ) &&
          ((s->merchandise == ARMOR_NORMAL) ||
          (s->merchandise == ARMOR_FINE) ||
          (s->merchandise == WEAPON_NORMAL) ||
          (s->merchandise == WEAPONSMITH_FINE)))
            p_wrestle_blacksmith();
        if (!(c->extended_creature == NULL))
            while (my_continue)
                {
                game_variables->fs_messages_printed = 0;
#ifdef GTK
                find_string(sign_id, temp);
                sprintf(temp2, "    %s.", temp);
                sprintf(message2, "You are inside a shop. A sign overhead reads:\n\n\t%s.\n\nDo you wish to:", temp);
                text = NULL;
                switch(menu_choice(message2, shop_choice, 9) + 'a')
#else
                window_clear();
                fs_pmsg("You are inside a shop. A sign overhead reads:");
                fs_pmsg("");
                find_string(sign_id, temp);
                sprintf(temp2, "    %s.", temp);
                fs_pmsg(temp);
                fs_pmsg("");
                fs_pmsg("You may:");
                fs_pmsg("");
                fs_pmsg("a: browse through the inventory");
                fs_pmsg("b: haggle over the price of an item in the shop");
                fs_pmsg("c: purchase an item");
                fs_pmsg("d: haggle over the price of an item which you wish to sell.");
                fs_pmsg("e: sell an item");
                fs_pmsg("f: have an item identified (1 gold)");
                fs_pmsg("g: request that the shop try to acquire an item.");
                fs_pmsg("h: exit the shop");
                fs_pmsg("i: look at your inventory");
                fs_pmsg("");
                switch(tgetc())
#endif
                    {
                    case 'a':
#ifdef GTK
                        if (!(s->items == NULL))
                            compile_text_from_ilist(&text, s->items,
                              LIST_PRICES);
                        else if (!(s->creatures == NULL))
                            compile_text_from_clist(&text, s->creatures,
                              LIST_PRICES);
                        display_text_struct_in_window(text);
                        free_text_struct(text);
#else
                        window_clear();
                        foo = 'a';
                        game_variables->fs_messages_printed = 0;
                        if (!(s->items == NULL))
                            print_ilist_internal(s->items, 0, &foo,
                              LETTER_ITEMS|FULLSCREEN|LIST_PRICES);
                        else if (!(s->creatures == NULL))
                            print_clist(s->creatures,
                              LETTER_ITEMS|FULLSCREEN|LIST_PRICES);
                        fs_anykey();
#endif
                    break;
                    case 'b':
                        fs_pmsg("");
                        foo = 'a';
                        if (!(s->items == NULL))
                            {
#ifdef GTK
                            curr_item = select_item(&s->items, LIST_PRICES);
#else
                            fs_pmsg("Which item?");
                            selection_char = tgetc();
                            curr_item = find_item(&s->items, selection_char, 0);
#endif
                            if (curr_item == NULL)
                                fs_pmsg("That is not a valid item.");
                            else
                                {
                                if (flag_check(curr_item->flags2, HAGGLED))
                                    fs_pmsg("You have already haggled over the price of that item.");
                                else
                                    {
                                    flag_set(&curr_item->flags2, HAGGLED);
                                    success_haggling = min(4,
                                      skill_check(c,
                                        c->extended_creature->skills->av[HAGGLING],
                                        MODERATE,
                                        SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE));
                                    if (success_haggling <= 0)
                                        fs_pmsg("You aren't able to bring the price down at all.");
                                    else
                                        {
                                        for(i=0; i < success_haggling; ++i)
                                            curr_item->price = (curr_item->price *
                                              100) / (100 + s->markup);
                                        curr_item->price =
                                          random_adjust(curr_item->price);
                                        money_string(curr_item->price, temp);
#ifdef HAS_SNPRINTF
                                        snprintf(message, 255, "You haggle the price down to %s.", temp);
#else
                                        sprintf(message, "You haggle the price down to %s.", temp);
#endif
                                        message[255] = '\0';
                                        fs_pmsg(message);
                                        }
                                    }
                                }
                            }
                        else if (!(s->creatures == NULL))
                            {
                            /* ## */
#ifdef GTK
                            curr_creature = extract_creature(&s->creatures, 0);
#else
                            fs_pmsg("Which creature?");
                            selection_char = tgetc();
                            curr_creature = find_creature(s->creatures, (long) selection_char);
#endif
                            if (curr_creature == NULL)
                                fs_pmsg("That is not a valid creature.");
                            else
                                {
                                if (flag_check(curr_creature->flags, C_HAGGLED))
                                    fs_pmsg("You have already haggled over the price of that creature.");
                                else
                                    {
                                    flag_set(&curr_creature->flags, C_HAGGLED);
                                    success_haggling = min(4, skill_check(c,
                                      c->extended_creature->skills->av[HAGGLING], MODERATE,
                                      SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE));
                                    if (success_haggling <= 0)
                                        fs_pmsg("You aren't able to bring the price down at all.");
                                    else
                                        {
                                        for(i=0; i < success_haggling; ++i)
                                            curr_creature->price =
                                              (curr_creature->price * 100) / (100 +
                                              s->markup);
                                        curr_creature->price =
                                          random_adjust(curr_creature->price);
                                        money_string(curr_creature->price, temp);
#ifdef HAS_SNPRINTF
                                        snprintf(message, 255, "You haggle the price down to %s.", temp);
#else
                                        sprintf(message, "You haggle the price down to %s.", temp);
#endif
                                        message[255] = '\0';
                                        fs_pmsg(message);
                                        }
                                    }
                                }
                            }
                        fs_anykey();
                    break;
                    case 'c':
                        fs_pmsg("");
                        if (!(s->items == NULL))
                            {
#ifdef GTK
                            curr_item = select_item(&s->items, LIST_PRICES);
#else
                            fs_pmsg("Which item?");
                            selection_char = tgetc();
                            foo = 'a';
                            curr_item = find_item(&s->items, selection_char, 0);
#endif
                            if (curr_item == NULL)
                                fs_pmsg("That is not a valid item.");
                            else
                                {
                                if (!(deduct_amount(c, curr_item->price)))
                                    fs_pmsg("You don't quite have enough money.");
                                else
                                    {
                                    foo = 'a';
                                    flag_reset(&curr_item->flags2, HAGGLED);
                                    extract_item(&s->items, 'a', &foo,
                                      selection_char, EXTRACT_REMOVE_ITEM);
                                    find_and_remove_item(curr_item,
                                      &s->items);
                                    add_item(&c->extended_creature->pack, curr_item);
                                    if (c==player)
                                        {
                                        window_clear();
                                        pmsg("You put it in your pack...");
                                        }
                                    calc_ready(c);
                                    }
                                }
                            }
                        else if (!(s->creatures == NULL))
                            {
#ifdef GTK
                            selection_char = new_tgetc("Which creature?");
#else
                            fs_pmsg("Which creature?");
                            selection_char = tgetc();
#endif
                            curr_creature = find_creature(s->creatures,
                              selection_char);
                            if (curr_creature == NULL)
                                fs_pmsg("That is not a valid creature.");
                            else
                                {
                                if (!(deduct_amount(c, curr_creature->price)))
                                    fs_pmsg("You don't quite have enough money.");
                                else
                                    {
                                    flag_reset(&curr_creature->flags, C_HAGGLED);
                                    curr_creature = extract_creature(&s->creatures,
                                      selection_char);
                                    make_follow(curr_creature, c);
                                    add_creature(current_level, curr_creature,
                                      c->x, c->y);
                                    window_clear();
                                    pmsg("Sold!");
                                    }
                                }
                            }
                        fs_anykey();
                    break;
            case 'd':
#ifdef GTK
                curr_item = select_item(&c->extended_creature->pack, LIST_PRICES);
#else
                fs_pmsg("");
                fs_pmsg("Which item (from your pack)?");
                selection_char = tgetc();
                foo = 'a';
                curr_item = find_item(&c->extended_creature->pack, selection_char,
                  EXTRACT_RECURSIVE);
#endif
                if (curr_item == NULL)
                    fs_pmsg("That is not a valid item.");
                else
                    if (flag_check(curr_item->flags2, HAGGLED))
                        fs_pmsg("You have already haggled over the price of that item.");
                    else
                        {

/*
 *
 * Shops will only pay half as much for items which are not identified.
 *
 */

                        offer = 1 + (((curr_item->value * (100 -
                          s->buyback))/100) * (100 - s->buyback))/100/(1 +
                          flag_check(curr_item->flags, IDENTIFIED));
                        money_string(offer, temp);
                        curr_item->price = offer;
#ifdef HAS_SNPRINTF
                        snprintf(message, 255, "The shopkeeper offers you %s for it.", temp);
#else
                        sprintf(message, "The shopkeeper offers you %s for it.", temp);
#endif
                        message[255] = '\0';
                        fs_pmsg(message);
                        flag_set(&curr_item->flags2, HAGGLED);
                        success_haggling = min(4,
                          skill_check(c, c->extended_creature->skills->av[HAGGLING],
                          MODERATE, SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE));
                        if (success_haggling <= 0)
                            fs_pmsg("You aren't able to bring the price up at all.");
                        else
                            {
                            for(i=0; i < success_haggling; ++i)
                                curr_item->price = (curr_item->price * 100)
                                  / (100 - s->buyback);
                            curr_item->price =
                              random_adjust(curr_item->price);
                            money_string(curr_item->price, temp);
#ifdef HAS_SNPRINTF
                            snprintf(message, 255,
                              "You haggle the price up to %s.", temp);
#else
                            sprintf(message,
                              "You haggle the price up to %s.", temp);
#endif
                            message[255] = '\0';
                            fs_pmsg(message);
                            flag_set(&curr_item->flags2, HAGGLED);
                            }
                        }
                fs_anykey();
            break;
            case 'e':
                fs_pmsg("");
#ifdef GTK
                curr_item = select_item(&c->extended_creature->pack,
                  LIST_PRICES|EXTRACT_RECURSIVE);
#else
                fs_pmsg("Which item (from your pack)?");
                selection_char = tgetc();
                foo = 'a';
                curr_item = find_item(&c->extended_creature->pack, selection_char,
                  EXTRACT_RECURSIVE);
#endif
                if (curr_item == NULL)
                    fs_pmsg("That is not a valid item.");
                else
                    if (!(flag_check(curr_item->flags2, HAGGLED)))
                        pmsg("You have not haggled over that item");
                    else
                        {
                        curr_item = extract_item(&c->extended_creature->pack, 'a',
                          &foo, selection_char, EXTRACT_REMOVE_ITEM);
                        find_and_remove_item(curr_item, &c->extended_creature->pack);
                        curr_ilist = (struct ilist *) calloc(1, sizeof(struct
                          ilist));
                        curr_ilist->me = curr_ilist;
                        curr_ilist->next = s->items;
                        curr_ilist->current = curr_item;
                        s->items = curr_ilist;
                        if (curr_item)
                            offer = curr_item->price;
                        else
                            offer = 1;
/*
 *
 * Shops always give the highest value of coin which they can.
 *
 */
                        c->extended_creature->au += offer/AU;
                        offer = offer - AU * (offer/AU);
                        c->extended_creature->el += offer/EL;
                        offer = offer - EL * (offer/EL);
                        c->extended_creature->si += offer/SI;
                        offer = offer - SI * (offer/SI);
                        c->extended_creature->cu += offer/CU;
                        fs_pmsg("Sold!");
                        }
                fs_anykey();
            break;
            case 'f':
                window_clear();
                if (deduct_amount(c, SI))
                    {
                    fs_pmsg("Which item?");
                    curr_item = get_item(c, EXTRACT_RECURSIVE);
                    identify(curr_item);
                    item_desc(curr_item, temp);
                    sprintf(temp2, "Identified as a %s.", temp);
                    pmsg(temp2);
                    }
                else
                    pmsg("You don't have the cash.");
                fs_anykey();
            break;
            case 'g':
                window_clear();
                which = item_parse(I_ALL_ITEMS);
                if (which != NONE)
                    {
                    if ((flag_check(s->flags, CAN_ACQUIRE_ANYTHING)) ||
                      (found_in_distribution(which, s->merchandise,
                      DISTRIBUTION_ITEM)))
                        {
                        pmsg("Let me see if we can find that...");
                        success = skill_check(c, c->extended_creature->skills->av
                          [ACQUISITION], orig_items[which]->acq_diff,
                          SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE);
                        if (success > 0)
                            {
                            curr_item = generate_item(current_level, which);
                            if (success > 1)
                                {
                                if (flag_check(curr_item->flags, POOR_QUALITY))
                                    small_item_make_normal(curr_item);
                                if (success > 2)
                                    small_item_make_fine(curr_item);
                                }
                            curr_item->price = random_adjust((((curr_item->
                              value * (100 + s->markup))/100)*(100 +
                              s->markup)) / 100);
                            flag_set(&curr_item->flags, IDENTIFIED);
                            curr_ilist = (struct ilist *) calloc(1,
                              sizeof(struct ilist));
                            curr_ilist->me = curr_ilist;
                            curr_ilist->current = curr_item;
                            curr_ilist->next = NULL;
                            append_ilist(&s->items, curr_ilist);
                            pmsg("I think we've found what you're looking for!");
                            }
                        else
                            pmsg("I'm sorry; we attempted and were unable to locate it.");
                        pass_days(1);
                        }
                    else
                        pmsg("I'm sorry, but we cannot locate that for you.");
                    }
                fs_anykey();
            break;
            case 'h':
                print_inventory(c);
            break;
            case 'q': case 'x': case ESCAPE: case 'i':
                my_continue = 0;
            break;
            }
        }
    window_clear();
    }
    else
        pmsg("The shop is closed for the night.");
    }

void p_medic(struct small_creature *c)
    {
    long my_continue;
    struct clist *traverse;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    if (c == player)
        {
#ifdef GTK
        switch (menu_choice(
          "You have a entered a medical hospice which cares for the sick and wounded.\nWould you like to:",
          hospice_choice, 9) + 'a')
#else
        window_clear();
        fs_pmsg("You have entered a medical hospice which cares for the wounded.  Would you");
        fs_pmsg("like to:");
        fs_pmsg("");
        fs_pmsg("a: rest here and receive care for a day");
        fs_pmsg("b: rest here and receive care until you are well");
        fs_pmsg("c: rest here and receive care until you and all your followers are well");
        fs_pmsg("d: make a donation of 10 gold sovereigns");
        fs_pmsg("e: exit");
        fs_pmsg("");
        fs_pmsg("");
        switch(tgetc())
#endif
            {
            case 'a':
                window_clear();
                rest_one_day(c);
                if (!(c->followed_by == NULL))
                    for(traverse = c->followed_by; (!(traverse == NULL));
                      traverse = traverse->next)
        if (traverse->current != NULL)
                        rest_one_day(traverse->current);
                pass_days(1);
                pmsg("You have rested a day.");
            break;
            case 'b':
                window_clear();
                my_continue = 1;
                while (my_continue)
                    {
                    rest_one_day(c);
                    if (!(c->followed_by == NULL))
                        for(traverse = c->followed_by; (!(traverse == NULL));
                          traverse = traverse->next)
        if (traverse->current != NULL)
                            rest_one_day(traverse->current);
                    pass_days(1);
                    if (!(c->extended_creature == NULL))
                        my_continue = (c->extended_creature->stati->time[STATUS_WOUNDED]
                          > 0);
                    else
                        my_continue = (c->wounded > 0);
                    }
                pmsg("You are ready to continue.");
            break;
            case 'c':
                window_clear();
                my_continue = 1;
                while (my_continue)
                    {
                    my_continue = 0;
                    rest_one_day(c);
                    if (!(c->extended_creature == NULL))
                        my_continue = (my_continue ||
                          (c->extended_creature->stati->time[STATUS_WOUNDED] > 0));
                    else
                        my_continue = (my_continue || (c->wounded > 0));
                    if (!(c->followed_by == NULL))
                        for(traverse = c->followed_by; (!(traverse == NULL));
                          traverse = traverse->next)
        if (traverse->current != NULL)
                            {
                            rest_one_day(traverse->current);
                            if (!(traverse->current->extended_creature == NULL))
                                my_continue = (my_continue ||
                                  (traverse->current->extended_creature->stati->time
                                  [STATUS_WOUNDED] > 0));
                            else
                                my_continue = (my_continue ||
                                  (traverse->current->wounded > 0));
                            }
                    pass_days(1);
                    }
                pmsg("You and your followers are ready to continue.");
            break;
            case 'd':
                p_donation(c);
            break;
            }
        fs_anykey();
        window_clear();
        update_window();
        }
    }

/* Give a creature one day's rest, under medical care.  Do not advance time at
all.  */

void rest_one_day(struct small_creature *c)
    {
    long success;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    if (!(c->extended_creature == NULL))
        {
        if (c->extended_creature->stati->time[STATUS_WOUNDED] > 0)
            {
            success = skill_check(c, c->extended_creature->attributes[CO], MODERATE, 0);
            c->extended_creature->stati->time[STATUS_WOUNDED] = max(0,
                c->extended_creature->stati->time[STATUS_WOUNDED] - success);
            c->extended_creature->stati->time[STATUS_HEALABLE] = max(0,
                c->extended_creature->stati->time[STATUS_HEALABLE] - success);
            c->extended_creature->stati->time[STATUS_HEALABLE_ANTIDOTE] = max(0,
                c->extended_creature->stati->time[STATUS_HEALABLE_ANTIDOTE] - success);
            calc_ready(c);
            }
        }
        else
        {
        if (c->wounded > 0)
            {
            success = min(skill_check(c, 0, MODERATE, 0), c->wounded);
            c->wounded -= success;
            c->att += 3 * success;
            c->def += 2 * success;
            c->dmg += success;
            c->hv += success;
            c->sp += success;
            }
        }
    }

void p_mentor(void)
    {
    long new_quest, quest_completed;
    char player_answer[256], message[256];
    struct ilist *this_ilist;
    struct small_item *this_item;
    player->nextaction = game_variables->elapsed_units;
    flag_set(&game_variables->quests_completed, SENT_ON_QUEST);
    flag_set(&game_variables->quests_completed, WAS);
    new_quest = game_variables->current_quest;
    quest_completed = flag_check(game_variables->quests_completed,
    game_variables->current_quest);
    sprintf(message, "%d", game_variables->current_quest);
    switch(game_variables->current_quest)
        {
        case SENT_ON_QUEST:
            if (quest_completed)
                {
                read_file(FILE_QUESTMASTER_INTRO);
                /* gain_ep(player, 1); */
                gain_ep(player, 1);
                new_quest = DRANK_LAKE;
                }
            else
                pmsg("Huh?  Weirdness in p_quest_master()!");
        break;
        case DRANK_LAKE:
            if (quest_completed)
                {
                read_file(FILE_QUEST_WRESTLED_BLACKSMITH);
                /* gain_ep(player, 2); */
                gain_ep(player, 1);
                new_quest = WRESTLED_BLACKSMITH;
                }
            else
                {
                pmsg("The old man says, \"Remember, your quest is to drink from the pool hidden in");
                nocap_pmsg("the Ice Peaks.\"");
                }
        break;
        case WRESTLED_BLACKSMITH:
            if (quest_completed)
                {
                read_file(FILE_QUEST_ANSWERED_RIDDLE);
                /* gain_ep(player, 3); */
                gain_ep(player, 1);
                new_quest = ANSWERED_RIDDLE;
                }
            else
                pmsg("The old man says, \"The land of the Tuz is beckoning...\"");
        break;
        case ANSWERED_RIDDLE:
#ifdef GTK
            if (tms_confirm("The old man asks, \"Do you know the answer to the riddle yet?\""))
#else
            pmsg("The old man asks, \"Do you know the answer to the riddle yet?\"");
            if (confirm_silent())
#endif
                {
#ifdef GTK
                new_tgets("\"What is it?\"", player_answer, NULL);
#else
                pmsg("\"What is it?\"");
                tgets(player_answer);
#endif
                /* We are trying to find an answer equivalent to "the letter 'h'" */
                if ((strcnt(player_answer, "h") && (strlen(player_answer) <= 3))
                  || (strcnt(player_answer, "letter")))
                    {
                    read_file(FILE_QUEST_TAMED_ANIMAL);
                    /* gain_ep(player, 4); */
                    gain_ep(player, 1);
                    new_quest = TAMED_ANIMAL;
                    }
                else
                    pmsg("The old man says, \"I'm sorry, but that's not the answer.\"");
                }
            else
                {
#ifdef GTK
                if (tms_confirm("\"Would you like for me to repeat the riddle?\""))
#else
                pmsg("\"Would you like for me to repeat the riddle?\"");
                if (confirm_silent())
#endif
                    read_file(FILE_RIDDLE_LETTER_H);
                else
                    pmsg("\"Well, I'm waiting for when you do have the answer.\"");
                }
        break;
        case TAMED_ANIMAL:
            if (quest_completed)
                {
                read_file(FILE_QUEST_NAMED_CHILD);
                /* gain_ep(player, 5); */
                gain_ep(player, 1);
                new_quest = NAMED_CHILD;
                }
            else
                pmsg("\"If you are gentle and patient, the small animals will come to you.\"");
        break;
        case NAMED_CHILD:
            if (quest_completed)
                {
                read_file(FILE_QUEST_WAS);
                /* gain_ep(player, 6); */
                gain_ep(player, 1);
                new_quest = WAS;
                }
            else
                pmsg("\"Go on, and find a child to name.\"");
        break;
        case WAS:
            if (quest_completed)
                {
                read_file(FILE_QUEST_GUESSED_JANRA);
                /* gain_ep(player, 7); */
                gain_ep(player, 1);
                new_quest = GUESSED_JANRA;
                }
            else
                pmsg("\"The Shal are a very simple people to understand.\"");
        break;
        case GUESSED_JANRA:
#ifdef GTK
            if (tms_confirm("\"Would you like to play the game with a Janra now?\""))
#else
            pmsg("\"Would you like to play the game with a Janra now?\"");
            if (confirm_silent())
#endif
                janra_guess();
#ifdef GTK
            if (tms_confirm("The old man asks, \"Do you know what the pattern is yet?\""))
#else
            pmsg("The old man asks, \"Do you know what the pattern is yet?\"");
                if (confirm_silent())
#endif
                    {
#ifdef GTK
                    new_tgets("The old man asks, \"What is it?\"", player_answer, NULL);
#else
                    pmsg("The old man asks, \"What is it?\"");
                    tgets(player_answer);
#endif
                    if (((strcnt(player_answer, "no") && strcnt(player_answer,
                      "pattern")) || strcnt(player_answer, "order") ||
                      strcnt(player_answer, "structure") ||
                      strcnt(player_answer, "sense")) || strcnt(player_answer,
                      "none") || strcnt(player_answer, "nothing") ||
                      strcnt(player_answer, "mu") || strcnt(player_answer,
                      "randomness") || strcnt(player_answer, "chaos") ||
              strcnt(player_answer, "random"))
                        {
                        read_file(FILE_QUEST_GAVE_GIFT);
                        /* gain_ep(player, 8); */
                        gain_ep(player, 1);
                        new_quest = GAVE_GIFT;
                        }
                    else
                        pmsg("\"That is not the correct answer.\"");
                    }
                else
                    pmsg("The Janra are a crazy bunch, I know.");
        break;
        case GAVE_GIFT:
            pmsg("\"What do you wish to give me?\"");
            this_item = select_item(&player->extended_creature->pack, EXTRACT_REMOVE_ITEM);
            if (this_item != NULL)
                {
                pmsg("Oh, and you might like some gold...");
                add_amount(player, this_item->value * 7);
                morewait();
                calc_ready(player);
                free_item(this_item);
                flag_set(&game_variables->quests_completed, GAVE_GIFT);
                read_file(FILE_QUEST_SERPENT_JEWEL);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = SERPENT_JEWEL;
                }
        break;
        case SERPENT_JEWEL:
            if (quest_completed)
                {
                read_file(FILE_QUEST_MECHANICAL_PUZZLE_II);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = MECHANICAL_PUZZLE_II;
            if (board_game(PUZZLE_BOARD_SURROUND_OPPONENT))
                {
                read_file(FILE_QUEST_WON_ARCHERY);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = WON_ARCHERY;
                /* Give player manual of skill in fencing with a rapier.  */
                }
                /* Give player fine rapier with special name and value.  */
                }
            else
                pmsg("\"Those serpents may be found in the forests of Rhog.\"");
        break;
        case MECHANICAL_PUZZLE_II:
            if (board_game(PUZZLE_BOARD_SURROUND_OPPONENT))
                {
                read_file(FILE_QUEST_WON_ARCHERY);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = WON_ARCHERY;
                /* Give player manual of skill in fencing with a rapier.  */
                }
            else
                pmsg("\"This game yet awaits you. It is simple, once it is understood.\"");
        break;
        case WON_ARCHERY:
            if (quest_completed)
                {
                read_file(FILE_QUEST_MECHANICAL_PUZZLE);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = EXPLORED_OCEAN;
                /* Give player fine quality bow and quiver of arrows.  */
                }
            else
        {
                pmsg("\"It may take a while to become that proficient in using your bow.\"");
        pmsg("\"But do find the adventurer's guild at Cansomiltrama, where three races meet.\"");
        }
        break;
        case EXPLORED_MISTRELLI:
            if (quest_completed)
                {
                read_file(FILE_QUEST_MECHANICAL_PUZZLE);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = EXPLORED_OCEAN;
                /* Give player manual of skill in using longbow.  */
            if (peg_game(PUZZLE_PEG_ALL_BUT_LAST_DOWN))
                {
                read_file(FILE_QUEST_EXPLORED_OCEAN);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = EXPLORED_OCEAN;
                /* Give player suit of feather chain mail.  */
                }
                }
            else
#ifdef GTK
                if (tms_confirm("\"Would you like for me to repeat the riddle?\""))
#else
                pmsg("\"Would you like for me to repeat the riddle?\"");
                if (confirm_silent())
#endif
                    read_file(FILE_RIDDLE_DIAMOND_CHALICE);
                else
                    pmsg("\"Secrets, secrets, many, many secrets.\"");
        break;
        case MECHANICAL_PUZZLE:
            if (quest_completed)
                {
                read_file(FILE_QUEST_EXPLORED_OCEAN);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = EXPLORED_OCEAN;
                /* Give player suit of feather chain mail.  */
                }
            else if (peg_game(PUZZLE_PEG_ALL_BUT_LAST_DOWN))
                {
                read_file(FILE_QUEST_EXPLORED_OCEAN);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = EXPLORED_OCEAN;
                /* Give player suit of feather chain mail.  */
                }
                /* pmsg("\"Keep searching, and you will find the mansion.\""); */
        break;
        case EXPLORED_OCEAN:
            if (quest_completed)
                {
                read_file(FILE_QUEST_PETTED_DOLPHIN);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = PETTED_DOLPHIN;
                /* Give player a calculator.  */
                }
            else
                pmsg("\"Deep are the depths of the ocean.\"");
        break;
        case CHOSEN_QUEST:
            /* The player has chosen his own quest.  */
            read_file(FILE_QUEST_MECHANICAL_PUZZLE_III);
            /* gain_ep(player, 8); */
            gain_ep(player, 1);
            new_quest = MECHANICAL_PUZZLE_III;
            /* Give the player a gem.  */
            if (board_game(PUZZLE_BOARD_COMPLETE_SQUARE))
                {
                read_file(FILE_QUEST_PETTED_DOLPHIN);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = PETTED_DOLPHIN;
                add_permanent_status(player, STATUS_MIRACLE_PROVIDENCE, 1);
                }
            else
                pmsg("\"Persevere. You will master this game.\"");
        break;
        case MECHANICAL_PUZZLE_III:
            if (board_game(PUZZLE_BOARD_COMPLETE_SQUARE))
                {
                read_file(FILE_QUEST_PETTED_DOLPHIN);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = PETTED_DOLPHIN;
                add_permanent_status(player, STATUS_MIRACLE_PROVIDENCE, 1);
                }
            else
                pmsg("\"Persevere. You will master this game.\"");
        break;
        case PETTED_DOLPHIN:
            if (quest_completed)
                {
                read_file(FILE_QUEST_MISSING_LETTERS);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = MISSING_LETTERS;
                add_permanent_status(player, STATUS_MIRACLE_PROVIDENCE, 1);
                }
            else
                pmsg("\"The dolphin are not too hard to find.\"");
        break;
        case MISSING_LETTERS:
#ifdef GTK
            if (tms_confirm("The old man says, \"Do you know what it is?\""))
#else
            pmsg("The old man says, \"Do you know what it is?\"");
            if (confirm_silent())
#endif
                {
#ifdef GTK
                new_tgets("\"Well, what is it?\"", player_answer, NULL);
#else
                pmsg("\"Well, what is it?\"");
                tgets(player_answer);
#endif
                if (strcnt(player_answer, "rats"))
                    {
                    read_file(FILE_QUEST_MAN_WITHOUT_EYES);
                    /* gain_ep(player, 8); */
                    gain_ep(player, 1);
                    new_quest = MAN_WITHOUT_EYES;
                    add_permanent_status(player, STATUS_MIRACLE_PROVIDENCE, 1);
                    }
                else
                    pmsg("The old man shakes his head, and says, \"I'm sorry, but that is not the answer.\"");
                }
            else
                {
#ifdef GTK
                if (tms_confirm("\"Would you like for me to repeat the riddle?\""))
#else
                pmsg("\"Would you like for me to repeat the riddle?\"");
                if (confirm_silent())
#endif
                    read_file(FILE_RIDDLE_MISSING_LETTERS);
                else
                    pmsg("\"Look closely, very closely.\"");
                }
        break;
        case MAN_WITHOUT_EYES:
#ifdef GTK
            if (tms_confirm("The old man says, \"Do you know what the answer is?\""))
#else
            pmsg("The old man says, \"Do you know what the answer is?\"");
            if (confirm_silent())
#endif
                {
#ifdef GTK
                new_tgets("\"Well, what is it?\"", player_answer, NULL);
#else
                pmsg("\"Well, what is it?\"");
                tgets(player_answer);
#endif
                if (strcnt(player_answer, "one") || (strcnt(player_answer,
                  "some") && (strcnt(player_answer, "plums") ||
                  (strcnt(player_answer, "not") && (strcnt(player_answer, "all")
                  || strcnt(player_answer, "both"))))))
                    {
                    read_file(FILE_QUEST_CONTRADICTION);
                    /* gain_ep(player, 8); */
                    gain_ep(player, 1);
                    new_quest = CONTRADICTION;
                    add_permanent_status(player, STATUS_MIRACLE_PROVIDENCE, 1);
                    }
                else
                    pmsg("The old man says, \"I'm sorry, but that is not the answer.\"");
                }
            else
                {
                pmsg("\"Think about the Urvanovestilli knack for subtlety.\"");
                morewait();
                read_file(FILE_QUEST_MAN_WITHOUT_EYES);
                }
        break;
        case CONTRADICTION:
#ifdef GTK
            if (tms_confirm("The old man says, \"Do you know the answer?\""))
#else
            pmsg("The old man says, \"Do you know the answer?\"");
            if (confirm_silent())
#endif
                {
#ifdef GTK
                new_tgets("\"Well, what is it?\"", player_answer, NULL);
#else
                pmsg("\"Well, what is it?\"");
                tgets(player_answer);
#endif
                if (strcnt(player_answer, "impossible") || strcnt(player_answer,
                  "nothing") || strcnt(player_answer, "contradiction"))
                    {
                    read_file(FILE_QUEST_DOZEN_GIANT_SCORPIONS);
                    /* gain_ep(player, 8); */
                    gain_ep(player, 1);
                    new_quest = DOZEN_GIANT_SCORPIONS;
                    add_permanent_status(player, STATUS_MIRACLE_PROVIDENCE, 1);
                    }
                else
                    pmsg("The old man says, \"I'm sorry, but that is not the answer.\"");
                }
            else
                read_file(FILE_QUEST_CONTRADICTION);
        break;
        case DOZEN_GIANT_SCORPIONS:
            if (quest_completed)
                {
                read_file(FILE_QUEST_SLEW_ROC);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = SLEW_ROC;
                add_permanent_status(player, STATUS_MIRACLE_PROVIDENCE, 1);
                }
            else
                {
                pmsg("\"Can you even slay twelve giant scorpions?\"");
#ifdef HAS_SNPRINTF
                snprintf(message, 255, "(You have %ld scorpions still to slay.)", 12 -
                  game_variables->scorpion_stings_found);
#else
                sprintf(message, "(You have %ld scorpions still to slay.)", 12 -
                  game_variables->scorpion_stings_found);
#endif
                message[255] = '\0';
                pmsg(message);
                }
        break;
        case SLEW_ROC:
            if (quest_completed)
                {
                read_file(FILE_QUEST_SLEW_KRAKEN);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = SLEW_KRAKEN;
                this_item = generate_item(current_level, BOOK);
                if (flag_check(this_item->flags, POOR_QUALITY))
                    small_item_make_normal(this_item);
                if (this_item->writing != NULL)
                    {
                    free_text_struct(this_item->writing);
                    this_item->writing = NULL;
                    }
                flag_reset(&this_item->flags2, WRITING_IS_FILENAME);
                flag_set(&this_item->flags, CAN_WRITE_ON);
                this_item->name = ST_SMALL_JOURNAL;
                this_ilist = (struct ilist *) calloc(1, sizeof(struct ilist));
                this_ilist->me = this_ilist;
                this_ilist->current = this_item;
                this_ilist->next = NULL;
                append_ilist(&player->extended_creature->pack, this_ilist);
                acquire_item(player, PEN);
                }
            else
                pmsg("\"The mightiest of birds yet awaits you.\"");
        break;
        case SLEW_KRAKEN:
            if (quest_completed)
                {
                read_file(FILE_QUEST_SLEW_BEHEMOTH);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = SLEW_BEHEMOTH;
                acquire_item(player, BOOK);
                }
            else
                pmsg("\"The monster of the deep you have not slain.\"");
        break;
        case SLEW_BEHEMOTH:
            if (quest_completed)
                {
                read_file(FILE_QUEST_SLEW_LEVIATHAN);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = SLEW_LEVIATHAN;
                acquire_item(player, RING);
                }
            else
                pmsg("\"The Behemoth yet awaits you.\"");
        break;
        case SLEW_LEVIATHAN:
            if (quest_completed)
                {
                read_file(FILE_QUEST_SLEW_TERRASK);
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                current_level->space[player->x][player->y].special =
                  new_special();
                current_level->space[player->x][player->y].special->level_type
                  = LEVEL_FINAL_QUEST;
                flag_set(&current_level->space[player->x][player->y].special->
                  level_flags, LOAD);
                change_level(player->x, player->y);
                new_quest = SLEW_TERRASK;
                acquire_item(player, JANRA_BALL);
                }
            else
                pmsg("\"The Leviathan you have not yet slain.\"");
        break;
        case SLEW_TERRASK:
            printf("Slew Terrask.\n");
            quest_completed = TRUE;
            if (quest_completed)
                {
                /*
                flag_set(&game_variables->quests_completed, SLEW_TERRASK);
                change_level(player->x, player->y);
                */
                /* read_file(FILE_QUESTS_COMPLETED); */
                /* gain_ep(player, 8); */
                gain_ep(player, 1);
                new_quest = FINAL_QUEST;
                current_level->space[player->x][player->y].special =
                  new_special();
                current_level->space[player->x][player->y].special->level_type
                  = LEVEL_FINAL_QUEST;
                flag_set(&current_level->space[player->x][player->y].special->
                  level_flags, LOAD);
                change_level(player->x, player->y);
                }
            else
                pmsg("\"There is yet one monster which awaits you. The Terrask.\"");
        break;
        case FINAL_QUEST:
            printf("In final_quest.");
            if (quest_completed)
                {
                read_file(FILE_QUESTS_COMPLETED);
                /*
                pmsg("Would you like to read the Roster of Heroes?");
                if (confirm_silent())
                    read_file(FILE_BOOK_ROSTER_OF_HEROES);
                pmsg("Writing on the Roster of Heroes...");
                write_on_roster();
                */
                /* gain_ep(player, 8); */
                gain_ep(player, 7);
                new_quest = NONE;
                }
            else
                {
                if (player != NULL)
                    {
                    flag_reset(&player->flags, CONTROL_MOVE);
                    flag_reset(&player->flags, SHIFT_MOVE);
                    change_level(player->x, player->y);
                    }
                }
        break;
        case NONE:
#ifdef GTK
            if (tms_confirm("Use the device laboratory?"))
#else
            pmsg("Use the device laboratory?");
            if (confirm_silent())
#endif
                make_item(player, TINKERING);
#ifdef GTK
            if (tms_confirm("Use the chemical laboratory?"))
#else
            pmsg("Use the chemical laboratory?");
            if (confirm_silent())
#endif
                make_item(player, CHEMISTRY);
        break;
        default:
            pmsg("Error!  Inappropriate quest value sent to p_quest_master()!");
            pmsg("I hope your game's not trashed!");
        break;
        }
    game_variables->current_quest = new_quest;
    if (status_check(player, STATUS_TIRED) > 0)
        {
        pmsg("You are allowed to rest.");
        go_to_sleep(player);
        /* I am assuming code to have player wake up.  */
        while (flag_check(player->flags, SLEEPING))
            pass_time(HOUR);
        }
    if (status_check(player, STATUS_HUNGRY) > 0)
        {
        pmsg("You are given something to eat.");
        status_add(player, STATUS_HUNGRY, -100);
        pass_time(HOUR);
        }
    if (status_check(player, STATUS_THIRSTY) > 0)
        {
        pmsg("You are given something to drink.");
        status_add(player, STATUS_THIRSTY, -100);
        pass_time(MINUTE);
        }
    }

void p_adventurers_guild(struct small_creature *c)
    {
    char player_input[256], message[256];
    long which_skill, skill_ep, left_over;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    if (c->extended_creature != NULL)
        {
        if ((flag_check(current_level->flags, IS_CITY)) &&
          (current_level->environment_name ==
          ST_THE_URVANOVESTILLI_CITY_CANSOMILTRAMA) &&
          (game_variables->current_quest == WON_ARCHERY))
            {
#ifdef GTK
            if (tms_confirm("\"Would you like to participate in our archery tournament?\""))
#else
            pmsg("Would you like to participate in our archery tournament?");
            if (confirm_silent())
#endif
                archery_tournament(c);
            }
#ifdef GTK
        if (tms_confirm("\"Welcome to the adventurer's guild; training offered in all skills.\nWould you like to train?\""))
#else
        pmsg("Welcome to the adventurer's guild; training offered in all skills.");
        pmsg("Would you like to train?");
        if (confirm_silent())
#endif
            {
            which_skill = skill_parse();
            if (skill_check(c, c->extended_creature->skills->av[ACQUISITION],
              c->extended_creature->skills->bv[which_skill],
              SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE))
                {
                pmsg("You find a trainer.");
#ifdef HAS_SNPRINTF
                snprintf(message, 255, "How many points do you wish to train (max %ld)?",
                  c->extended_creature->study_points);
#else
                sprintf(message, "How many points do you wish to train (max %ld)?",
                  c->extended_creature->study_points);
#endif
                message[255] = '\0';
#ifdef GTK
                new_tgets(message, player_input, NULL);
#else
                pmsg(message);
                tgets(player_input);
#endif
#ifdef MAC_68k
                skill_ep = strtol(player_input, NULL, 10);
#else
                sscanf(player_input, "%ld", &skill_ep);
#endif
                if ((skill_ep < 1) || (skill_ep > c->extended_creature->study_points))
                    pmsg("Aborted.");
                else
                    {
                    c->extended_creature->unspent_ep += skill_ep;
                    c->extended_creature->study_points -= skill_ep;
                    left_over = (allocate_experience_internal(c, which_skill,
                      skill_ep));
                    if (left_over > 0)
                        {
                        nocap_pmsg("(Not all of the stated experience was allocated; the unallocated experience was");
                        nocap_pmsg("not sufficient to reach the next level beyond the level reached by the");
                        nocap_pmsg("experience which was allocated.)");
                        c->extended_creature->unspent_ep -= left_over;
                        c->extended_creature->study_points += left_over;
                        }
                    calc_ready(c);
                    pass_days(MONTH * skill_ep - left_over);
                    pmsg("You are ready to continue.  It is customary to give a gift to your mentor to");
#ifdef HAS_SNPRINTF
                    snprintf(message, 255, "pay for his time and troubles; a customary amount would be %ld gold.", (skill_ep - left_over) * 100);
#else
                    sprintf(message, "pay for his time and troubles; a customary amount would be %ld gold.", (skill_ep - left_over) * 100);
#endif
                    message[255] = '\0';
                    nocap_pmsg(message);
                    p_donation(c);
                    }
                }
            else
                {
                pass_time(DAY);
                pmsg("The guild was unable to locate a mentor sufficiently advanced to train you.");
                }
            }
        }
    }

