/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2005 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include <gtk/gtk.h>
#include <unistd.h>
#include "tms.h"

#define ENTRY_TEXT_LENGTH 256

char currently_pressed_key;
struct request_queue_struct *user_requests;
GtkAccelGroup *gtk_accelerators;
GtkAdjustment *scrolled_window_vertical_adjustment;
GdkPixbuf **master_icons;
GtkTextBuffer *pmsg_buffer;
GtkTextIter pmsg_iterator;
GtkWidget *main_window, *window_contents, *window_contents_container,
  *window_message_vbox, *entry, *view, *pmsg_text_view, *menu, *menu_window,
  *puzzle_window, *scrolled_window;
static GtkWidget **pmsg_labels;
static long during_idle_function, menu_and_item_selected, user_clicked_value,
  user_has_clicked, player_max_health, puzzle_clicked_x_and_y;

#ifdef GTK

GtkItemFactoryEntry menu_entries[] =
    {
    { "/_File", "<ALT>F", NULL, 0, "<Branch>" },
    /*
    { "/File/_New Game", "<ALT>N", menu_file_new_game, 0, "<Item>" },
    { "/File/_Open Game", "<ALT>O", menu_file_open_game, 0, "<Item>" },
    */
    { "/File/Save Game (S)", NULL, menu_file_save_game, 0, "<Item>" },
    /*
    { "/File/_End Game", "<ALT>E", menu_file_end_game, 0, "<Item>" },
    */
    { "/File/Quit The Minstrel's Song (Q)", NULL,
      menu_file_quit_the_minstrels_song, 0, "<Item>" },
    { "/_Movement", "<ALT>M", NULL, 0, "<Branch>" },
    { "/Movement/Left (4)", NULL, menu_movement_left, 0, "<Item>" },
    { "/Movement/Right (6)", NULL, menu_movement_right, 0, "<Item>" },
    { "/Movement/Up (2)", NULL, menu_movement_up, 0, "<Item>" },
    { "/Movement/Down (8)", NULL, menu_movement_down, 0, "<Item>" },
    { "/Movement/Up and Left (1)", NULL, menu_movement_up_and_left, 0,
      "<Item>" },
    { "/Movement/Up and Right (3)", NULL, menu_movement_up_and_right, 0,
      "<Item>" },
    { "/Movement/Down and Left (7)", NULL, menu_movement_down_and_left, 0,
      "<Item>" },
    { "/Movement/Down and Right (9)", NULL, menu_movement_down_and_right, 0,
      "<Item>" },
    { "/Movement/Alternate and Expanded", NULL, NULL, 0, "<Branch>" },
    { "/Movement/Alternate and Expanded/Left (h)", NULL, menu_movement_left, 0,
      "<Item>" },
    { "/Movement/Alternate and Expanded/Right (l)", NULL, menu_movement_right,
      0, "<Item>" },
    { "/Movement/Alternate and Expanded/Up (k)", NULL, menu_movement_up, 0,
      "<Item>" },
    { "/Movement/Alternate and Expanded/Down (j)", NULL, menu_movement_down, 0,
      "<Item>" },
    { "/Movement/Alternate and Expanded/Up and Left (y)", NULL,
      menu_movement_up_and_left, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Up and Right (u)", NULL,
      menu_movement_up_and_right, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Down and Left (b)", NULL,
      menu_movement_down_and_left, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Down and Right (n)", NULL,
      menu_movement_down_and_right, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Jog Left (Control-H)", NULL,
      menu_movement_jog_left, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Jog Right (Control-L)", NULL,
      menu_movement_jog_right, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Jog Up (Control-K)", NULL,
      menu_movement_jog_up, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Jog Down (Control-J)", NULL,
      menu_movement_jog_down, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Jog Up and Left (Control-Y)",
      NULL, menu_movement_jog_up_and_left, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Jog Up and Right (Control-U)",
      NULL, menu_movement_jog_up_and_right, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Jog Down and Left (Control-B)",
      NULL, menu_movement_jog_down_and_left, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Jog Down and Right (Control-N)",
      NULL, menu_movement_jog_down_and_right, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Run Left (H)", NULL,
      menu_movement_run_left, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Run Right (L)", NULL,
      menu_movement_run_right, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Run Up (K)", NULL,
      menu_movement_run_up, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Run Down (J)", NULL,
      menu_movement_run_down, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Run Up and Left (Y)", NULL,
      menu_movement_run_up_and_left, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Run Up and Right (U)", NULL,
      menu_movement_run_up_and_right, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Run Down and Left (B)", NULL,
      menu_movement_run_down_and_left, 0, "<Item>" },
    { "/Movement/Alternate and Expanded/Run Down and Right (N)", NULL,
      menu_movement_run_down_and_right, 0, "<Item>" },
    { "/_Actions", "<ALT>A", NULL, 0, "<Branch>" },
    { "/Actions/Activate an Item (a)", NULL, menu_actions_activate_an_item, 0,
      "<Item>" },
    { "/Actions/Activate Your Location (@)", NULL,
      menu_actions_activate_your_location, 0, "<Item>" },
    { "/Actions/Clean an Animal's Carcass", NULL,
      menu_actions_clean_an_animals_carcass, 0, "<Item>" },
    { "/Actions/Close a Door (C)", NULL, menu_actions_close_a_door, 0, "<Item>"
      },
    { "/Actions/Close an Item (c)", NULL, menu_actions_close_an_item, 0,
      "<Item>" },
    { "/Actions/Cover with Poison", NULL, menu_actions_cover_with_poison, 0,
      "<Item>" },
    { "/Actions/Dismount Your Steed", NULL, menu_actions_dismount_your_steed,
      0, "<Item>" },
    { "/Actions/Drink (Quaff) a Liquid (q)", NULL,
      menu_actions_drink_quaff_a_liquid, 0, "<Item>" },
    { "/Actions/Drop an Item (d)", NULL, menu_actions_drop_an_item, 0, "<Item>"
      },
    { "/Actions/Drop Money", NULL, menu_actions_drop_money, 0, "<Item>" },
    { "/Actions/Eat (Munch) food (m)", NULL, menu_actions_eat_munch_food, 0,
      "<Item>" },
    { "/Actions/Enter or Exit a Level (>)", NULL,
      menu_actions_enter_or_exit_a_level, 0, "<Item>" },
    { "/Actions/Examine an Item in Your Possession More Closely (x)", NULL,
      menu_actions_examine_an_item_in_your_possession_more_closely, 0,
      "<Item>" },
    { "/Actions/Examine Your Surroundings More Closely (X)", NULL,
      menu_actions_examine_your_surroundings_more_closely, 0, "<Item>" },
    { "/Actions/Fill an Item with Oil", NULL,
      menu_actions_fill_an_item_with_oil, 0, "<Item>" },
    { "/Actions/Fill an Item with Water", NULL,
      menu_actions_fill_an_item_with_water, 0, "<Item>" },
    { "/Actions/Fire or Throw a Missle Weapon (f)", NULL,
      menu_actions_fire_or_throw_a_missle_weapon, 0, "<Item>" },
    { "/Actions/Fly or Land (F)", NULL, menu_actions_fly_or_land, 0, "<Item>"
      },
    { "/Actions/Gather Fruit or Wood from a Tree", NULL,
      menu_actions_gather_fruit_or_wood_from_a_tree, 0, "<Item>" },
    { "/Actions/Give a Name to Another Creature", NULL,
      menu_actions_give_a_name_to_another_creature, 0, "<Item>" },
    { "/Actions/Give an Item to Another Creature", NULL,
      menu_actions_give_a_name_to_another_creature, 0, "<Item>" },
    { "/Actions/Go to Sleep (G)", NULL, menu_actions_go_to_sleep, 0, "<Item>"
      },
    { "/Actions/Insert One Item into Another", NULL,
      menu_actions_insert_one_item_into_another, 0, "<Item>" },
    { "/Actions/Jump (Vault) from One Location to Another (v)", NULL,
      menu_actions_jump_vault_from_one_location_to_another, 0, "<Item>" },
    { "/Actions/Mount a Steed", NULL, menu_actions_mount_a_steed, 0, "<Item>"
      },
    { "/Actions/Move to a City Location (M)", NULL,
      menu_actions_move_to_a_city_location, 0, "<Item>" },
    { "/Actions/Open a Door (O)", NULL, menu_actions_open_a_door, 0, "<Item>" },
    { "/Actions/Open an Item (o)", NULL, menu_actions_open_an_item, 0, "<Item>"
      },
    { "/Actions/Pet an Animal", NULL, menu_actions_pet_an_animal, 0, "<Item>"
      },
    { "/Actions/Push a Creature in a Direction", NULL,
      menu_actions_push_a_creature_in_a_direction, 0, "<Item>", },
    { "/Actions/Read an Item (r)", NULL, menu_actions_read_an_item, 0, "<Item>"
      },
    { "/Actions/Rest a Moment (.)", NULL, menu_actions_rest_a_moment, 0,
      "<Item>" },
    { "/Actions/Rest or Wait for a While (,)", NULL,
      menu_actions_rest_or_wait_for_a_while, 0, "<Item>" },
    { "/Actions/Remove an Item from a Container", NULL,
      menu_actions_remove_an_item_from_a_container, 0, "<Item>" },
    { "/Actions/Remove (Unequip) an Item in Use (E)", NULL,
      menu_actions_unequip_ie_remove_an_item_in_use, 0, "<Item>" },
    { "/Actions/Search (Inspect) the Surrounding Area (I)", NULL,
      menu_actions_search_inspect_the_surrounding_area, 0, "<Item>" },
    { "/Actions/Start Running", NULL, menu_actions_start_running, 0, "<Item>"
      },
    { "/Actions/Start Using (Equip) an Item (e)", NULL,
      menu_actions_equip_ie_start_using_an_item, 0, "<Item>" },
    { "/Actions/Start Walking", NULL, menu_actions_start_walking, 0, "<Item>"
      },
    { "/Actions/Swap Places with a Creature", NULL,
      menu_actions_swap_places_with_a_creature, 0, "<Item>" },
    { "/Actions/Take a Nap", NULL, menu_actions_take_a_nap, 0, "<Item>" },
    { "/Actions/Talk to Another Person (t)", NULL,
      menu_actions_talk_to_another_person, 0, "<Item>" },
    { "/_Skills", "<ALT>S", NULL, 0, "<Branch>" },
    { "/Skills/Animal Handling", NULL, menu_skills_animal_handling, 0,
      "<Item>", },
    { "/Skills/Chemistry", NULL, menu_skills_chemistry, 0, "<Item>", },
    { "/Skills/Fishing", NULL, menu_skills_fishing, 0, "<Item>" },
    { "/Skills/Geography", NULL, menu_skills_geography, 0, "<Item>" },
    { "/Skills/Guess Actions", NULL, menu_skills_guess_actions, 0, "<Item>" },
    { "/Skills/Herbalism", NULL, menu_skills_herbalism, 0, "<Item>" },
    { "/Skills/Medicine", NULL, menu_skills_medicine, 0, "<Item>" },
    /*
    { "/Skills/Music (Flute)", NULL, menu_skills_music_flute, 0, "<Item>" },
    { "/Skills/Music (Harp)", NULL, menu_skills_music_harp, 0, "<Item>" },
    { "/Skills/Music (Lute)", NULL, menu_skills_music_lute, 0, "<Item>" },
    { "/Skills/Music (Organ)", NULL, menu_skills_music_organ, 0, "<Item>" },
    { "/Skills/Music (Singing)", NULL, menu_skills_music_singing, 0, "<Item>"
      },
    */
    { "/Skills/Navigation", NULL, menu_skills_navigation, 0, "<Item>" },
    /*
    { "/Skills/Repair", NULL, menu_skills_repair, 0, "<Item>" },
    */
    { "/Skills/Technology Identification", NULL,
      menu_skills_technology_identification, 0, "<Item>" },
    { "/Skills/Tinkering", NULL, menu_skills_tinkering, 0, "<Item>" },
    { "/Skills/Tracking", NULL, menu_skills_tracking, 0, "<Item>" },
    { "/_Prayers", "<ALT>P", NULL, 0, "<Branch>" },
    { "/Prayers/Aegis of God", NULL, menu_prayers_aegis_of_God, 0, "<Item>" },
    { "/Prayers/Divine Sustenance", NULL, menu_prayers_divine_sustenance, 0,
      "<Item>" },
    { "/Prayers/Favor with Man", NULL, menu_prayers_favor_with_man, 0, "<Item>"
      },
    { "/Prayers/Fire from Heaven", NULL, menu_prayers_fire_from_heaven, 0,
      "<Item>" },
    { "/Prayers/Flying", NULL, menu_prayers_flying, 0, "<Item>" },
    { "/Prayers/Guardian Angel", NULL, menu_prayers_guardian_angel, 0, "<Item>"
      },
    { "/Prayers/Healing", NULL, menu_prayers_healing, 0, "<Item>" },
    { "/Prayers/Increase Attribute", NULL, menu_prayers_increase_attribute, 0,
      "<Item>" },
    { "/Prayers/Increase Faith", NULL, menu_prayers_increase_faith, 0, "<Item>"
      },
    { "/Prayers/Increase Skill", NULL, menu_prayers_increase_skill, 0, "<Item>"
      },
    { "/Prayers/Persuasion", NULL, menu_prayers_persuasion, 0, "<Item>" },
    { "/Prayers/Providence", NULL, menu_prayers_providence, 0, "<Item>" },
    /*
    { "/Prayers/Raise Dead", NULL, menu_prayers_raise_dead, 0, "<Item>" },
    */
    { "/Prayers/Restoration", NULL, menu_prayers_restoration, 0, "<Item>" },
    { "/Prayers/Reveal Terrain", NULL, menu_prayers_reveal_terrain, 0, "<Item>"
      },
    /*
    { "/Prayers/Sanctuary", NULL, menu_prayers_sanctuary, 0, "<Item>" },
    */
    { "/Prayers/Shining Light", NULL, menu_prayers_shining_light, 0, "<Item>" },
    /*
    { "/Prayers/Walk on Water", NULL, menu_prayers_walk_on_water, 0, "<Item>" },
    */
    { "/_Other", "<ALT>O", NULL, 0, "<Branch>" },
    { "/Other/Allocate Experience (A)", NULL, menu_other_allocate_experience, 0,
      "<Item>" },
    { "/Other/Become Combat Happy", NULL, menu_other_become_bellicose, 0,
      "<Item>" },
    { "/Other/Charity Contact Information", NULL, menu_other_charity_contact, 0,
      "<Item>" },
    { "/Other/Display an Inventory of Items in Your Possession (i)", NULL,
      menu_other_display_an_inventory_of_items_in_your_possession, 0, "<Item>"
      },
    { "/Other/Display License Statement", NULL,
      menu_other_display_license_statement, 0, "<Item>" },
    { "/Other/Display Skill Values", NULL, menu_other_display_skill_values, 0,
      "<Item>" },
    { "/Other/Make the Display Taller (+)", NULL,
      menu_other_make_the_display_taller, 0, "<Item>" },
    { "/Other/Make the Display Shorter (_ _ )", NULL,
      menu_other_make_the_display_shorter, 0, "<Item>" },
    { "/Other/Make the Display Narrower (-)", NULL,
      menu_other_make_the_display_narrower, 0, "<Item>" },
    { "/Other/Make the Display Wider (=)", NULL,
      menu_other_make_the_display_wider, 0, "<Item>" },
    /*
    { "/Other/Set Options (O)", NULL, menu_other_set_options, 0, "<Item>" },
    { "/Other/Set Your Haste Level", NULL, menu_other_set_your_haste_level, 0,
      "<Item>" },
    */
    { "/_Role Play", "<ALT>H", NULL, 0, "<Branch>" },
    { "/Role Play/Espiriticthus: The Cultures", NULL,
      menu_role_play_espiriticthus_the_cultures, 0, "<Item>" },
    { "/Role Play/Game Master's Introduction", NULL,
      menu_role_play_game_masters_introduction, 0, "<Item>" },
    { "/Role Play/A Mathematical Model", NULL,
      menu_role_play_a_mathematical_model, 0, "<Item>" },
    { "/Role Play/Player's Introduction", NULL,
      menu_role_play_players_introduction, 0, "<Item>" }
    };

#ifdef UNDEFINED
GtkWidget* bottom_panel(void)
    {
    char text[256];
    GtkWidget *current_label, *result;
    result = gtk_vbox_new(FALSE, 0);
    sprintf(text, "The ground, in the Urvanovestilli city Standrilnatrella.");
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "12:00 PM, Friday, October 18, winter, year 862");
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, " ");
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    gtk_widget_show(result);
    return result;
    }
#endif

char dequeue_keystroke(void)
    {
    char result;
    struct queue_struct *remaining_input;
    if (keyboard_input != NULL)
        {
        remaining_input = keyboard_input->next;
        result = keyboard_input->current;
        free(keyboard_input);
        keyboard_input = remaining_input;
        return result;
        }
    else
        return 0;
    }

void enqueue_keystroke(char keystroke)
    {
    struct queue_struct *traverse, *new_queue_element;
    new_queue_element = (struct queue_struct *) calloc(1, sizeof(struct
      queue_struct));
    new_queue_element->current = keystroke;
    new_queue_element->next = NULL;
    if (keyboard_input == NULL)
        {
        keyboard_input = new_queue_element;
        }
    else
        {
        for(traverse = keyboard_input; traverse->next != NULL; traverse =
          traverse->next)
            my_noop();
        traverse->next = new_queue_element;
        }
    }

void enqueue_keystrokes(char *keystrokes)
    {
    int i;
    for(i = 0; i < strlen(keystrokes); ++i)
        {
        enqueue_keystroke(keystrokes[i]);
        }
    }

GtkWidget *get_main_window_contents(long rows, long columns)
    {
    GtkWidget *hbox1, *hbox2, *vbox1, *vbox2, *left, *dungeon, *bottom,
      *spacer_icon;
    char spacer_filename[256];
    sprintf(spacer_filename, "%s/icons/spacer.png", LIB_DIR);
    vbox1 = gtk_vbox_new(FALSE, 0);
    spacer_icon = gtk_image_new_from_file(spacer_filename);
    gtk_box_pack_start(GTK_BOX(vbox1), spacer_icon, FALSE, FALSE, 0);
    hbox1 = gtk_hbox_new(FALSE, 0);
    left = left_panel();
    gtk_widget_show(left);
    gtk_box_pack_start(GTK_BOX(hbox1), left, FALSE, FALSE, 0);
    spacer_icon = gtk_image_new_from_file(spacer_filename);
    gtk_widget_show(spacer_icon);
    gtk_box_pack_start(GTK_BOX(hbox1), spacer_icon, FALSE, FALSE, 0);
    gtk_widget_show(hbox1);
    gtk_box_pack_start(GTK_BOX(vbox1), hbox1, FALSE, FALSE, 0);
    vbox2 = gtk_vbox_new(FALSE, 0);
    /*
    gtk_box_pack_start(GTK_BOX(vbox1), vbox2, FALSE, FALSE, 0);
    */
    gtk_widget_show(vbox2);
    dungeon = dungeon_map(window_dungeon_columns(), window_dungeon_lines(), 0);
    gtk_widget_show(dungeon);
    hbox2 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(hbox2), dungeon, FALSE, FALSE, 0);
    gtk_widget_show(hbox2);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox2, FALSE, FALSE, 0);
    gtk_box_pack_start(GTK_BOX(hbox1), vbox2, FALSE, FALSE, 0);
    gtk_widget_show(dungeon);
    spacer_icon = gtk_image_new_from_file(spacer_filename);
    gtk_widget_show(spacer_icon);
    gtk_box_pack_start(GTK_BOX(vbox2), spacer_icon, FALSE, FALSE, 0);
    bottom = bottom_panel();
    gtk_box_pack_start(GTK_BOX(vbox2), bottom, FALSE, FALSE, 0);
    gtk_widget_show(bottom);
    gtk_widget_show(vbox1);
    return vbox1;
    }

void gtk_specific_init(void)
    {
    GtkItemFactory *factory;
    GtkWidget *hbox1, *vbox1, *root_menu, *spacer_icon, *main_window;
    char spacer_filename[256];
    long i;
    entry_text = calloc(ENTRY_TEXT_LENGTH, sizeof(char));
    /*
    new_read_file("motd.txt");
    */
    pmsg_labels = (GtkWidget **) calloc(NUMBER_OF_PMSG_MESSAGES,
      sizeof(GtkWidget *));
    for(i = 0; i < NUMBER_OF_PMSG_MESSAGES; ++i)
        pmsg_labels[i] = NULL;
    master_icons = (GdkPixbuf **) calloc(LAST_ICON + 1,
      sizeof(GdkPixbuf *));
    during_idle_function = 0;
    for(i = 0; i < FIRST_ICON; ++i)
        master_icons[i] = load_icon(FIRST_ICON);
    for(i = FIRST_ICON; i <= LAST_ICON; ++i)
        master_icons[i] = load_icon(i);
    main_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    g_signal_connect(G_OBJECT(main_window), "delete_event",
      G_CALLBACK(quit_tms), NULL);
    g_signal_connect(G_OBJECT(main_window), "destroy",
      G_CALLBACK(quit_tms), NULL);
    g_signal_connect(G_OBJECT(main_window), "key_press_event",
      G_CALLBACK(key_pressed), NULL);
    g_signal_connect(G_OBJECT(main_window), "key_release_event",
      G_CALLBACK(key_released), NULL);
    gtk_accelerators = gtk_accel_group_new();
    factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>",
      gtk_accelerators);
    gtk_item_factory_create_items(factory, 125, menu_entries, NULL);
    gtk_window_add_accel_group(GTK_WINDOW(main_window), gtk_accelerators);
    vbox1 = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(main_window), vbox1);
    root_menu = gtk_item_factory_get_widget(factory, "<main>");
    gtk_widget_show(root_menu);
    hbox1 = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(hbox1), root_menu, FALSE, FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox1), hbox1, FALSE, FALSE, 0);
    gtk_widget_show(vbox1);
    sprintf(spacer_filename, "%s/icons/spacer.png", LIB_DIR);
    spacer_icon = gtk_image_new_from_file(spacer_filename);
    gtk_widget_show(spacer_icon);
    gtk_widget_show(hbox1);
    
    scrolled_window = gtk_scrolled_window_new(NULL, NULL);
    scrolled_window_vertical_adjustment =
      gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW(scrolled_window));
    gtk_container_set_border_width(GTK_CONTAINER(scrolled_window), 0);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
      GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
    /* */
    window_message_vbox = gtk_vbox_new(FALSE, 0);
    gtk_widget_show(window_message_vbox);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_window),
      window_message_vbox);
    /* */
    gtk_box_pack_start(GTK_BOX(vbox1), scrolled_window, FALSE,
      FALSE, 0);
    gtk_widget_show(scrolled_window);

    pmsg_buffer = gtk_text_buffer_new(NULL);
    pmsg_text_view =
      gtk_text_view_new_with_buffer(GTK_TEXT_BUFFER(pmsg_buffer));
    gtk_widget_show(GTK_WIDGET(pmsg_text_view));
    gtk_widget_show(scrolled_window);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
      GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(
      scrolled_window), pmsg_text_view);
    spacer_icon = gtk_image_new_from_file(spacer_filename);
    gtk_widget_show(spacer_icon);

    window_contents_container = vbox1;
    gtk_window_set_title(GTK_WINDOW(main_window), "The Minstrel's Song: Main");
    gtk_widget_show(GTK_WIDGET(main_window));
    };

void key_pressed(GtkWidget *widget, GdkEvent *generic_event, gpointer
  callback_data)
    {
    GdkEventKey *event;
    event = (GdkEventKey *) generic_event;
    if (strlen(event->string) > 0)
        {
        currently_pressed_key = event->string[0];
        enqueue_keystroke(currently_pressed_key);
        }
    }

void key_released(GtkWidget *widget, GdkEvent *generic_event, gpointer
  callback_data)
    {
    GdkEventKey *event;
    event = (GdkEventKey *) generic_event;
    currently_pressed_key = 0;
    }

GtkWidget* left_panel(void)
    {
    long ag = 0, agm = 0, al = 0, alm = 0, ch = 0, chm = 0, co = 0, com = 0,
      de = 0, dem = 0, in = 0, inm = 0, kn = 0, knm = 0, me = 0, mem = 0,
      pe = 0, pem = 0, sp = 0, spm = 0, st = 0, stm = 0, wi = 0, wim = 0, att =
      0, dmg = 0, def = 0, hv = 0, hvm = 0, wgt = 0;
    char text[256];
    GtkWidget *current_label, *result;
    ag = max(1, player->extended_creature->attributes[AG] + 10);
    agm = max(1, player->extended_creature->perm_attributes[AG] + 10);
    al = max(1, player->extended_creature->attributes[AL] + 10);
    alm = max(1, player->extended_creature->perm_attributes[AL] + 10);
    ch = max(1, player->extended_creature->attributes[CH] + 10);
    chm = max(1, player->extended_creature->perm_attributes[CH] + 10);
    co = max(1, player->extended_creature->attributes[CO] + 10);
    com = max(1, player->extended_creature->perm_attributes[CO] + 10);
    de = max(1, player->extended_creature->attributes[DE] + 10);
    dem = max(1, player->extended_creature->perm_attributes[DE] + 10);
    in = max(1, player->extended_creature->attributes[IN] + 10);
    inm = max(1, player->extended_creature->perm_attributes[IN] + 10);
    /*
    inm = player->extended_creature->perm_attributes[IN] ;
    */
    kn = max(1, player->extended_creature->attributes[KN] + 10);
    knm = max(1, player->extended_creature->perm_attributes[KN] + 10);
    me = max(1, player->extended_creature->attributes[ME] + 10);
    mem = max(1, player->extended_creature->perm_attributes[ME] + 10);
    pe = max(1, player->extended_creature->attributes[PE] + 10);
    pem = max(1, player->extended_creature->perm_attributes[PE] + 10);
    sp = max(1, player->extended_creature->attributes[SPEED] + 10);
    spm = max(1, player->extended_creature->perm_attributes[SPEED] + 10);
    st = max(1, player->extended_creature->attributes[ST] + 10);
    stm = max(1, player->extended_creature->perm_attributes[ST] + 10);
    wi = max(1, player->extended_creature->attributes[WI] + 10);
    wim = max(1, player->extended_creature->perm_attributes[WI] + 10);
    att = max(1, player->att + 10);
    dmg = max(1, player->dmg + 10);
    def = max(1, player->def + 10);
    player_max_health = max(player_max_health, player->extended_creature->phv);
    hvm = max(1, player_max_health + 10);
    hv = max(1, player_max_health + 10 -
      player->extended_creature->stati->time[STATUS_WOUNDED]);
    wgt = player->extended_creature->curr_weight / LB;
    result = gtk_vbox_new(FALSE, 0);
    sprintf(text, "Ability to learn: %ld/%ld", al, alm);
    current_label = gtk_label_new(text);
    gtk_widget_show(current_label);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Agility: %ld/%ld", ag, agm);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    gtk_widget_show(result);
    sprintf(text, "Charisma: %ld/%ld", ch, chm);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Constitution: %ld/%ld", co, com);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Dexterity: %ld/%ld", de, dem);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Intelligence: %ld/%ld", in, inm);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Knowledge: %ld/%ld", kn, knm);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Memory: %ld/%ld", me, mem);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Perception: %ld/%ld", pe, pem);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Speed: %ld/%ld", sp, spm);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Strength: %ld/%ld", st, stm);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Willpower: %ld/%ld", wi, wim);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    current_label = gtk_label_new("");
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Attack: %ld", att);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Damage: %ld", dmg);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Defense: %ld", def);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Health Value: %ld/%ld", hv, hvm);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    sprintf(text, "Weight Carried: %ld", wgt);
    current_label = gtk_label_new(text);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(result), current_label, FALSE, FALSE, 0);
    return result;
    }

GdkPixbuf *load_icon(long icon_id)
    {
    char filename[256];
    sprintf(filename, "%s/icons/%ld.png", LIB_DIR, icon_id);
    /*
    return gtk_image_new_from_file(filename);
    */
    return gdk_pixbuf_new_from_file(filename, NULL);
    }

GtkWidget *lookup_icon(long icon_id)
    {
    return gtk_image_new_from_pixbuf(master_icons[icon_id]);
    /*
    return gtk_image_new_from_pixbuf(load_icon(icon_id));
    return load_icon(icon_id);
    */
    }

long menu_choice(char *prompt, char **strings, long length)
    {
    char prompt_with_newline[1024];
    GtkWidget *button, *label;
    if (length == 0)
        return -1;
    sprintf(prompt_with_newline, "\n%s\n", prompt);
    menu_window = gtk_dialog_new_with_buttons(
      "The Minstrel's Song: A Choice", NULL, GTK_DIALOG_MODAL, NULL);
    label = gtk_label_new(prompt_with_newline);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(menu_window)->vbox), label, TRUE,
      TRUE, 0);
    gtk_widget_show(label);

    button = gtk_button_new_with_label("Select...");
    gtk_widget_show(button);
    gtk_box_pack_end(GTK_BOX(GTK_DIALOG(menu_window)->action_area), button, TRUE,
      TRUE, 0);
    menu = menu_from_strings(strings, length, 0);
    g_signal_connect_swapped(G_OBJECT(button), "clicked",
      G_CALLBACK(menu_choice_popup), menu);
    /*
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(menu_window)->vbox), menu, TRUE,
      TRUE, 0);
    */
    gtk_widget_show(menu_window);
    gtk_dialog_run(GTK_DIALOG(menu_window));
    user_has_clicked = 0;
    return menu_and_item_selected;
    }

long menu_choice_popup(GtkWidget *menu)
    {
    gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, 0,
      gtk_get_current_event_time());
    return 1;
    }

GtkWidget *menu_from_strings(char **strings, long length, long offset)
    {
    GtkWidget *result, *current;
    long i;
    result = gtk_menu_new();
    for(i = 0; i < length; ++i)
        {
        current = gtk_menu_item_new_with_label(strings[i]);
        gtk_menu_shell_append(GTK_MENU_SHELL(result), current);
        gtk_widget_show(current);
        g_signal_connect_swapped(G_OBJECT(current), "activate",
          G_CALLBACK(menu_item_selected), (gpointer) i + offset);
        }
    return result;
    }

gulong menu_item_selected(gpointer data, GtkWidget *widget)
    {
    menu_and_item_selected = (long) data;
    gtk_widget_destroy(menu);
    gtk_widget_destroy(menu_window);
    return 1;
    }

void new_pmsg(char* original_message)
    {
    char message[256];
    GtkWidget *current_label;
    long i;
    strcpy(message, original_message);
    if (message[0] >= 'a' && message[0] <= 'z')
        message[0] += 'A' - 'a';
    if (pmsg_labels[0] != NULL)
        gtk_widget_destroy(pmsg_labels[0]);
    for (i = 0; i < NUMBER_OF_PMSG_MESSAGES - 1; ++i)
        pmsg_labels[i] = pmsg_labels[i + 1];
    current_label = gtk_label_new(message);
    g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
    pmsg_labels[NUMBER_OF_PMSG_MESSAGES - 1] = current_label;
    gtk_widget_show(current_label);
    gtk_box_pack_start(GTK_BOX(window_message_vbox), current_label, FALSE,
       FALSE, 0);
    gtk_widget_show(scrolled_window);
#ifdef UNDEFINED
    GtkTextMark *mark;
    /*
    iterator = NULL;
    */
    gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(pmsg_buffer), "\n",
      strlen("\n"));
    gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(pmsg_buffer), message,
      strlen(message));
    mark = gtk_text_buffer_get_insert(GTK_TEXT_BUFFER(pmsg_buffer));
    gtk_text_view_scroll_to_mark(GTK_TEXT_VIEW(pmsg_text_view), mark, 0.0, 1,
      0.0f, 1.0f);
    /*
    gtk_text_view_get_iter_at_location(GTK_TEXT_VIEW(pmsg_text_view),
      &iterator, 0, 0);
    while (gtk_text_view_forward_display_line(GTK_TEXT_VIEW(pmsg_text_view),
      &iterator))
        my_noop();
    gtk_text_view_scroll_to_iter(GTK_TEXT_VIEW(pmsg_text_view), &iterator,
      0.0f, 1, 0.0f, 1.0f);
    */
#endif
    }

void clear_pmsg(void)
    {
    int i;
    for(i = 0; i < NUMBER_OF_PMSG_MESSAGES; ++i)
        new_pmsg("");
    }

void display_text_struct_in_window(struct text_struct *t)
    {
    display_text_struct_in_window_with_title(t, "Information");
    }

void display_text_struct_in_window_with_title(struct text_struct *t, char
  *title)
    {
    GtkWidget *current_label;
    GtkWidget *window, *my_scrolled_window, *vbox, *button;
    struct text_struct *traverse;
    char full_title[256];
    user_clicked_value = 1;
    user_has_clicked = 0;
    sprintf(full_title, "The Minstrel's Song: %s", title);
    window = gtk_dialog_new_with_buttons(full_title, NULL, GTK_DIALOG_MODAL,
      NULL);
    gtk_window_set_title(GTK_WINDOW(window), full_title);
    gtk_container_set_border_width(GTK_CONTAINER(window), 0);
    gtk_widget_set_size_request(window, 550, 300);
    my_scrolled_window = gtk_scrolled_window_new(NULL, NULL);
    gtk_container_set_border_width(GTK_CONTAINER(my_scrolled_window), 10);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(my_scrolled_window),
      GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    gtk_box_pack_start(GTK_BOX (GTK_DIALOG(window)->vbox), my_scrolled_window,
      TRUE, TRUE, 0);
    vbox = gtk_vbox_new(FALSE, 0);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(my_scrolled_window),
      vbox);
    gtk_widget_show(my_scrolled_window);
    gtk_widget_show(vbox);
    for(traverse = t; traverse != NULL; traverse = traverse->next)
        {
        current_label = gtk_label_new(traverse->text);
        g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
        gtk_widget_show(current_label);
        gtk_box_pack_start(GTK_BOX(vbox), current_label, FALSE, FALSE,
          0);
        }
    button = gtk_button_new_with_label("Close");
    g_signal_connect_swapped(G_OBJECT(button), "clicked",
      G_CALLBACK(gtk_widget_destroy), G_OBJECT(window));
    GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->action_area), button, TRUE,
      TRUE, 0);
    gtk_widget_grab_default(button);
    gtk_widget_show(button);
    gtk_widget_show(window);
    gtk_dialog_run(GTK_DIALOG(window));
    }

long dungeon_map_clicked(void *long_as_pointer)
    {
    long dungeon_x_and_y = 0;
    dungeon_x_and_y = (long) long_as_pointer;
    cursor->x = dungeon_x_and_y % MAX_X;
    cursor->y = dungeon_x_and_y / MAX_X;
    gtk_widget_destroy(dungeon_targeting_window);
    return 1;
    }

void new_read_file(char *filename)
    {
    char real_filename[256], this_line[256];
    long my_continue, i;
    FILE *infile;
    GtkWidget *current_label;
    GtkWidget *window, *my_scrolled_window, *vbox, *button;
    user_clicked_value = 1;
    user_has_clicked = 0;
    strncpy(real_filename, LIB_DIR, 255);
    strncat(real_filename, filename, max(0, 255 - strlen(real_filename) -
      strlen(filename)));
    real_filename[255] = '\0';
    infile = fopen(real_filename, "r");
    if (!(infile))
        {
        pmsg("Attempt failed to open file:");
        pmsg(real_filename);
        }
    else
        {
        window = gtk_dialog_new_with_buttons("The Minstrel's Song: The Story Unfolds...", NULL,
          GTK_DIALOG_MODAL, NULL);
        gtk_container_set_border_width(GTK_CONTAINER(window), 0);
        gtk_widget_set_size_request(window, 550, 300);
        my_scrolled_window = gtk_scrolled_window_new(NULL, NULL);
        gtk_container_set_border_width(GTK_CONTAINER(my_scrolled_window), 10);
        gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(my_scrolled_window),
          GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
        gtk_box_pack_start(GTK_BOX (GTK_DIALOG(window)->vbox), my_scrolled_window,
          TRUE, TRUE, 0);
        vbox = gtk_vbox_new(FALSE, 0);
        gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(my_scrolled_window),
          vbox);
        gtk_widget_show(my_scrolled_window);
        gtk_widget_show(vbox);
        my_continue = TRUE;
        while (my_continue)
            {
            my_continue = ((my_continue) && (fgets(this_line, 256, infile)));
            this_line[255] = '\0';
            if (my_continue)
                {
                for(i = 0; i < strlen(this_line); ++i)
                    if (this_line[i] == '\n')
                        this_line[i] = '\0';
                current_label = gtk_label_new(this_line);
                g_object_set(G_OBJECT(current_label), "xalign", 0.0f, NULL);
                gtk_widget_show(current_label);
                gtk_box_pack_start(GTK_BOX(vbox), current_label, FALSE, FALSE,
                  0);
                }
            }
        button = gtk_button_new_with_label("Close");
        g_signal_connect_swapped(G_OBJECT(button), "clicked",
          G_CALLBACK(gtk_widget_destroy), G_OBJECT(window));
        GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
        gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->action_area), button, TRUE,
          TRUE, 0);
        gtk_widget_grab_default(button);
        gtk_widget_show(button);
        gtk_widget_show(window);
        gtk_dialog_run(GTK_DIALOG(window));
        fclose(infile);
        }
    }

char *new_read_string(char *prompt)
    {
    return NULL;
    }

char new_tgetc(char *prompt)
    {
    char prompt_with_newline[1024];
    GtkWidget *button, *label, *window;
    sprintf(prompt_with_newline, "\n%s\n", prompt);
    window = gtk_dialog_new_with_buttons("The Minstrel's Song: Question", NULL,
      GTK_DIALOG_MODAL, NULL);
    label = gtk_label_new(prompt_with_newline);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), label, TRUE, TRUE,
      0);
    gtk_widget_show(label);
    entry = gtk_entry_new();
    gtk_widget_show(entry);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), entry, TRUE, TRUE,
      0);
    button = gtk_button_new_with_label("OK");
    gtk_widget_show(button);
    g_signal_connect_swapped(G_OBJECT(button), "clicked",
      G_CALLBACK(user_entered_string), window);
    /*
    if (default_value)
        gtk_widget_grab_default(button);
    */
    gtk_box_pack_end(GTK_BOX(GTK_DIALOG(window)->action_area), button, FALSE,
      FALSE, 0);
    button = gtk_button_new_with_label("Cancel");
    gtk_widget_show(button);
    g_signal_connect_swapped(G_OBJECT(button), "clicked",
      G_CALLBACK(user_cancelled_string), window);
    /*
    if (!default_value)
        gtk_widget_grab_default(button);
    */
    gtk_box_pack_end(GTK_BOX(GTK_DIALOG(window)->action_area), button, FALSE,
      FALSE, 0);
    gtk_widget_show(window);
    /*
    while (!user_has_clicked)
        usleep(20);
    */
    gtk_dialog_run(GTK_DIALOG(window));
    user_has_clicked = 0;
    return entry_text[0];
    }

long new_tgets(char *prompt, char *output, char *default_value)
    {
    GtkWidget *button, *label, *window;
    window = gtk_dialog_new_with_buttons("The Minstrel's Song: Question", NULL,
      GTK_DIALOG_MODAL, NULL);
    label = gtk_label_new(prompt);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), label, TRUE, TRUE,
      0);
    gtk_widget_show(label);
    entry = gtk_entry_new();
    if (default_value != NULL)
        gtk_entry_set_text(GTK_ENTRY(entry), default_value);
    gtk_widget_show(entry);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), entry, TRUE, TRUE,
      0);
    button = gtk_button_new_with_label("OK");
    gtk_widget_show(button);
    g_signal_connect_swapped(G_OBJECT(button), "clicked",
      G_CALLBACK(user_entered_string), window);
    /*
    if (default_value)
        gtk_widget_grab_default(button);
    */
    gtk_box_pack_end(GTK_BOX(GTK_DIALOG(window)->action_area), button, FALSE,
      FALSE, 0);
    button = gtk_button_new_with_label("Cancel");
    gtk_widget_show(button);
    g_signal_connect_swapped(G_OBJECT(button), "clicked",
      G_CALLBACK(user_cancelled_string), window);
    /*
    if (!default_value)
        gtk_widget_grab_default(button);
    */
    gtk_box_pack_end(GTK_BOX(GTK_DIALOG(window)->action_area), button, FALSE,
      FALSE, 0);
    gtk_widget_show(window);
    /*
    while (!user_has_clicked)
        usleep(20);
    */
    gtk_dialog_run(GTK_DIALOG(window));
    user_has_clicked = 0;
    strncpy(output, entry_text, ENTRY_TEXT_LENGTH);
    return user_clicked_value;
    }

long puzzle_space_clicked(void *long_as_pointer)
    {
    puzzle_clicked_x_and_y = (long) long_as_pointer;
    gtk_widget_destroy(puzzle_window);
    return 1;
    }

void update_main_window(void)
    {
    }

void user_cancelled_string(GtkWidget *window)
    {
    user_has_clicked = 1;
    user_clicked_value = 0;
    entry_text[0] = '\0';
    gtk_widget_destroy(window);
    }

void user_cancelled_targeting(GtkWidget *window)
    {
    targeting_cancelled = 1;
    gtk_widget_destroy(window);
    }

void remove_main_window_contents(void)
    {
    gtk_widget_destroy(window_contents);
    }

void show_main_window_contents(void)
    {
    if (player != NULL)
        {
        window_contents = get_main_window_contents(window_dungeon_columns(),
          window_dungeon_lines());
        gtk_widget_show(window_contents);
        gtk_box_pack_start(GTK_BOX(window_contents_container), window_contents,
          FALSE, FALSE, 0);
        }
    }

void update_main_window_contents(void)
    {
    GtkWidget *new_window_contents;
    if (player != NULL && !flag_check(game_variables->flags, IN_BETWEEN_GAMES))
        {
        new_window_contents = get_main_window_contents(window_dungeon_columns(),
          window_dungeon_lines());
        gtk_widget_show(new_window_contents);
        remove_main_window_contents();
        gtk_box_pack_start(GTK_BOX(window_contents_container),
        new_window_contents, FALSE, FALSE, 0);
        window_contents = new_window_contents;
        }
    }

void user_clicked_no(GtkWidget *window)
    {
    user_has_clicked = 1;
    user_clicked_value = 0;
    gtk_widget_destroy(window);
    }
    
void user_clicked_yes(GtkWidget *window)
    {
    user_has_clicked = 1;
    user_clicked_value = 1;
    gtk_widget_destroy(window);
    }

void user_entered_string(GtkWidget *window)
    {
    user_has_clicked = 1;
    user_clicked_value = 1;
    strncpy(entry_text, gtk_entry_get_text(GTK_ENTRY(entry)),
      ENTRY_TEXT_LENGTH);
    entry_text[ENTRY_TEXT_LENGTH - 1] = '\0';
    gtk_widget_destroy(window);
    }

long tms_confirm(char *prompt)
    {
    return tms_confirm_positive(prompt);
    }

long tms_confirm_negative(char *prompt)
    {
    GtkWidget *button, *label, *window;
    window = gtk_dialog_new_with_buttons("The Minstrel's Song: Question", NULL,
      GTK_DIALOG_MODAL, NULL);
    label = gtk_label_new(prompt);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), label, TRUE, TRUE,
      0);
    gtk_widget_show(label);
    button = gtk_button_new_with_label("Yes");
    gtk_widget_show(button);
    g_signal_connect_swapped(G_OBJECT(button), "clicked",
      G_CALLBACK(user_clicked_yes), window);
    /*
    if (default_value)
        gtk_widget_grab_default(button);
    */
    gtk_box_pack_end(GTK_BOX(GTK_DIALOG(window)->action_area), button, FALSE,
      FALSE, 0);
    button = gtk_button_new_with_label("No");
    gtk_widget_show(button);
    g_signal_connect_swapped(G_OBJECT(button), "clicked",
      G_CALLBACK(user_clicked_no), window);
    /*
    if (!default_value)
        gtk_widget_grab_default(button);
    */
    gtk_box_pack_end(GTK_BOX(GTK_DIALOG(window)->action_area), button, FALSE,
      FALSE, 0);
    gtk_widget_show(window);
    /*
    while (!user_has_clicked)
        usleep(20);
    */
    gtk_dialog_run(GTK_DIALOG(window));
    user_has_clicked = 0;
    return user_clicked_value;
    }

long tms_confirm_positive(char *prompt)
    {
    GtkWidget *button, *label, *window;
    window = gtk_dialog_new_with_buttons("The Minstrel's Song: Question", NULL,
      GTK_DIALOG_MODAL, NULL);
    label = gtk_label_new(prompt);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), label, TRUE, TRUE,
      0);
    gtk_widget_show(label);
    button = gtk_button_new_with_label("Yes");
    gtk_widget_show(button);
    g_signal_connect_swapped(G_OBJECT(button), "clicked",
      G_CALLBACK(user_clicked_yes), window);
    /*
    if (default_value)
        gtk_widget_grab_default(button);
    */
    gtk_box_pack_end(GTK_BOX(GTK_DIALOG(window)->action_area), button, FALSE,
      FALSE, 0);
    button = gtk_button_new_with_label("No");
    gtk_widget_show(button);
    g_signal_connect_swapped(G_OBJECT(button), "clicked",
      G_CALLBACK(user_clicked_no), window);
    /*
    if (!default_value)
        gtk_widget_grab_default(button);
    */
    gtk_box_pack_end(GTK_BOX(GTK_DIALOG(window)->action_area), button, FALSE,
      FALSE, 0);
    gtk_widget_show(window);
    gtk_dialog_run(GTK_DIALOG(window));
    user_has_clicked = 0;
    return user_clicked_value;
    }

gint tms_idle(void *data)
    {
    if (!during_idle_function)
        {
        if (!(flag_check(game_variables->flags, IN_BETWEEN_GAMES)))
            {
            during_idle_function = 1;
            if (!(flag_check(game_variables->flags, IN_BETWEEN_GAMES)))
                {
                update_world();
                update_main_window_contents();
                }
            else
                {
                if (!(flag_check(game_variables->flags, DURING_INIT)))
                    {
                    end_game();
#ifdef MAC_68k
                    window_clear();
#endif
                    pmsg("Please select an option under the file menu.");
                    }
#ifdef MAC_68k
                event_check();
                Delay(1, 0);
#endif
                }
            during_idle_function = 0;
            }
        }
    return 1;
    }

long display_puzzle_state_and_get_next_move(char
  puzzle_contents[MAX_PUZZLE_X][MAX_PUZZLE_Y])
    {
    GtkWidget *current_icon, *event, *table;
    long i, j;
    current_icon = NULL;
    puzzle_window = gtk_dialog_new_with_buttons(
      "The Minstrel's Song: A Puzzle", NULL, GTK_DIALOG_MODAL, NULL);
    table = gtk_table_new(MAX_PUZZLE_X, MAX_PUZZLE_Y, FALSE);
    for(j = 0; j < MAX_PUZZLE_Y; ++j)
        for(i = 0; i < MAX_PUZZLE_X; ++i)
            {
            switch(puzzle_contents[i][j])
                {
                case C_PUZZLE_AVAILABLE:
                    current_icon = lookup_icon(ICON_PUZZLE_AVAILABLE);
                break;
                case C_PUZZLE_PLAYER:
                    current_icon = lookup_icon(ICON_PUZZLE_PLAYER);
                break;
                case C_PUZZLE_OPPONENT:
                    current_icon = lookup_icon(ICON_PUZZLE_OPPONENT);
                break;
                }
            event = gtk_event_box_new();
            gtk_container_add(GTK_CONTAINER(event), current_icon);
            gtk_event_box_set_visible_window(GTK_EVENT_BOX(event), FALSE);
            gtk_event_box_set_above_child(GTK_EVENT_BOX(event), TRUE);
            g_signal_connect_swapped(G_OBJECT(event), "button_press_event",
              G_CALLBACK(puzzle_space_clicked), (void *)
              (j * MAX_PUZZLE_Y + i));
            gtk_table_attach_defaults(GTK_TABLE(table),
              event, i, i + 1, j, j + 1);
            gtk_widget_show(event);
            gtk_widget_show(current_icon);
            }
    gtk_widget_show(table);
    gtk_box_pack_end(GTK_BOX(GTK_DIALOG(puzzle_window)->vbox), table,
      TRUE, TRUE, 0);
    gtk_widget_show(puzzle_window);
    gtk_dialog_run(GTK_DIALOG(puzzle_window));
    return puzzle_clicked_x_and_y;
    }

long display_peg_state_and_get_next_move(long peg_contents[NUM_PEGS])
    {
    GtkWidget *current_icon, *event, *table;
    long i;
    current_icon = NULL;
    puzzle_window = gtk_dialog_new_with_buttons(
      "The Minstrel's Song: A Puzzle", NULL, GTK_DIALOG_MODAL, NULL);
    table = gtk_table_new(NUM_PEGS, 1, FALSE);
    for(i = 0; i < NUM_PEGS; ++i)
        {
        if (peg_contents[i] == PEG_UP)
            current_icon = lookup_icon(ICON_PUZZLE_PEG_UP);
        else
            current_icon = lookup_icon(ICON_PUZZLE_PEG_DOWN);
        event = gtk_event_box_new();
        gtk_container_add(GTK_CONTAINER(event), current_icon);
        gtk_event_box_set_visible_window(GTK_EVENT_BOX(event), FALSE);
        gtk_event_box_set_above_child(GTK_EVENT_BOX(event), TRUE);
        g_signal_connect_swapped(G_OBJECT(event), "button_press_event",
          G_CALLBACK(puzzle_space_clicked), (void *) (i));
        gtk_table_attach_defaults(GTK_TABLE(table),
          event, i, i + 1, 0, 1);
        gtk_widget_show(event);
        gtk_widget_show(current_icon);
        }
    gtk_widget_show(table);
    gtk_box_pack_end(GTK_BOX(GTK_DIALOG(puzzle_window)->vbox), table,
      TRUE, TRUE, 0);
    gtk_widget_show(puzzle_window);
    gtk_dialog_run(GTK_DIALOG(puzzle_window));
    return puzzle_clicked_x_and_y;
    }

long quit_tms(void *ignored)
    {
    if (tms_confirm("Quit the Minstrel's Song:\nAre you sure?"))
        {
        exit(0);
        return FALSE;
        }
    else
        return TRUE;
    }

void report_attr(struct small_creature *c)
    {
    }

#endif
