/**********************************************************************/
/* The Minstrel's Song is (c) 1998 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.            */
/**********************************************************************/

#include "tms.h"
#include <math.h>

#ifdef CODE_SEGMENT
#pragma segment LEVEL3B_C
#endif

struct small_creature *make_random_creature(long ctype)
    {
    long type, age_class, gender, garbage, temp;
    struct small_creature *result;
    result = NULL;
    if (ctype<=LAST_ANIMAL)
	{
	temp=trandom()%10;
	if (temp<3)
	    age_class=CHILD;
	else if (temp<6)
	    age_class=YOUNG_ADULT;
	else if (temp<8)
	    age_class=MIDDLE_AGED;
	else if (temp<9)
	    age_class=OLD;
	else
	    age_class=ANCIENT;
	gender=trandom()%2;
	result=creature_create(ctype, age_class, gender);
	}
    else 
	{
	switch(ctype)
	    {
	    case JEC_ENCOUNTER:
		random_select(jec_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case NORKRIN_ENCOUNTER:
		random_select(norkrin_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case SHAL_ENCOUNTER:
		random_select(shal_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case TUZ_ENCOUNTER:
		random_select(tuz_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case URVANOVESTILLI_ENCOUNTER:
		random_select(urvanovestilli_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case YEDIDIA_ENCOUNTER:
		random_select(yedidia_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case SEA_ENCOUNTER:
		random_select(sea_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case FISHING_ENCOUNTER:
		random_select(fishing_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case LEVEL_1_ENCOUNTER:
		random_select(level_1_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case LEVEL_2_ENCOUNTER:
		random_select(level_2_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case LEVEL_3_ENCOUNTER:
		random_select(level_3_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case LEVEL_4_ENCOUNTER:
		random_select(level_4_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case LEVEL_5_ENCOUNTER:
		random_select(level_5_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case LAND_SPECIAL_ENCOUNTER:
		random_select(land_special_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    case SEA_SPECIAL_ENCOUNTER:
		random_select(sea_special_encounter, &type, &garbage);
		result = make_random_creature(type);
	    break;
	    default:
#ifdef MAC_68k
		pmsg("Error: monster creation type out of range.");
#else
		perror("Error: monster creation type out of range.");
#endif
	    break;
	    }
	}
    return result;
    }
