/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2005 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include "tms.h"

struct queue_struct *menu_input;

#ifdef MAC_68k
/*
#include <unix.h>
#include <utime.h>
#include <console.h>
*/
#include <time.h>
#include <AppleEvents.h>
#include <Devices.h>
#include <Events.h>
#include <MacTypes.h>
#include <MacWindows.h>
#include <QuickDraw.h>

pascal OSErr MyHandleOAPP(AppleEvent *theAppleEvent, AppleEvent *reply,
  long handlerRefcon);
pascal OSErr MyHandleODOC(AppleEvent *theAppleEvent, AppleEvent *reply,
  long handlerRefcon);
pascal OSErr MyHandlePDOC(AppleEvent *theAppleEvent, AppleEvent *reply,
  long handlerRefcon);
pascal OSErr MyHandleQUIT(AppleEvent *theAppleEvent, AppleEvent *reply,
  long handlerRefcon);
WindowPtr TheWindow;
pascal void TEInit(void);
pascal void InitDialogs(void *ignored);

#if TARGET_API_MAC_68k_CARBON
#define GETWINDOW(a) GetWindowPort(a)
#define NewAEEventHandlerProc(userRoutine)            (AEEventHandlerUPP)
NewAEEventHandlerUPP((AEEventHandlerProcPtr) userRoutine)
#define GETPORTBOUNDS(port, bounds) GetPortBounds(port, bounds)
#define GETQDGLOBALSCREENBITS(bitmapp)  GetQDGlobalsScreenBits(bitmapp)
#else
#define GETWINDOW(a) (a)
#define GETPORTBOUNDS(port, boundRp)    (*(boundRp) = port->portRect)
#define GETQDGLOBALSCREENBITS(bitmapp)  (*(bitmapp) = qd.screenBits)
#endif

#else

#include <sys/types.h>
#include <sys/time.h>

#endif

#ifdef CODE_SEGMENT
#pragma segment MAC_68kHDEP_C
#endif

#ifdef GTK

void append_icon(struct tile **the_tile, long icon_id)
	{
	struct tile *traverse;
	if (*the_tile == NULL)
		*the_tile = new_tile(icon_id);
	else if ((*the_tile)->next == NULL)
		(*the_tile)->next = new_tile(icon_id);
	else
		{
		for(traverse = *the_tile; traverse->next != NULL; traverse
		  = traverse->next);
		traverse->next = new_tile(icon_id);
		}
	}

void prepend_icon(struct tile **the_tile, long icon_id)
	{
	struct tile *the_new_tile;
    the_new_tile = new_tile(icon_id);
    the_new_tile->next = *the_tile;
    *the_tile = the_new_tile;
	}

void clear(void)
    {
    window_clear();
    }

long find_icon(struct small_creature *the_creature)
	{
	if (the_creature->extended_creature != NULL)
		return the_creature->extended_creature->icon;
	else
		return master_creatures[the_creature->identity]->icon;
	}

void menu_push_char(char c)
    {
    struct queue_struct *traverse, *new_queue_element;
    new_queue_element = (struct queue_struct *) calloc(1, sizeof(struct
      queue_struct));
    new_queue_element->current = c;
    new_queue_element->next = NULL;
    if (menu_input == NULL)
	menu_input = new_queue_element;
    else if (menu_input->next == NULL)
	menu_input->next = new_queue_element;
    else
	{
	for(traverse = menu_input; traverse->next != NULL; traverse =
	  traverse->next)
        my_noop();
	traverse->next = new_queue_element;
	}
    }

char menu_pop_char(void)
    {
    char result;
    struct queue_struct *temp;
    result = menu_input->current;
    temp = menu_input;
    menu_input = menu_input->next;
    free(temp);
    return result;
    }

void menu_push_string(char *input_string)
    {
    char message[256];
    long i;
    if (strlen(input_string) > 0)
    	{
    	if (strlen(input_string) == 1)
    		{
    		sprintf(message, "Keyboard shortcut to that menu item: hit '%c'.", input_string[0]);
    		pmsg(message);
    		}
    	else
    		{
    		sprintf(message, "Keyboard equivalent to that menu item: hit '%c'.", input_string[0]);
    		pmsg(message);
    		strcpy(message, "Then type '");
    		for(i = 1; i < strlen(input_string) - 1; ++i)
    			{
    			message[strlen(message) + 1] = 0;
    			message[strlen(message)] = input_string[i];
    			}
    		strcat(message, "', and hit return.");
    		pmsg(message);
    		}
		for(i = 0; i < strlen(input_string); ++i)
	    	menu_push_char(input_string[i]);
	    }
    }

void refresh(void)
    {
    ;
    }

#endif

long window_dungeon_columns(void)
    {
#ifdef GTK
    /*
    return 31;
    */
    return game_variables->window_dungeon_columns;
#else
    return ((window_boundary(WINDOW_DUNGEON, WINDOW_MAX_X) -
      window_boundary(WINDOW_DUNGEON, WINDOW_MIN_X)) *
      ONE_CHARACTER_WIDTH) / ONE_TILE_WIDTH;
#endif
    }

long window_dungeon_lines(void)
    {
#ifdef GTK
    /*
    return 21;
    */
    return game_variables->window_dungeon_lines;
#else
    return ((window_boundary(WINDOW_DUNGEON, WINDOW_MAX_Y) -
      window_boundary(WINDOW_DUNGEON, WINDOW_MIN_Y)) *
      ONE_CHARACTER_HEIGHT) / ONE_TILE_HEIGHT;
#endif
    }


/* not yet ported to other systems */

void tsrandom(void)
    {
#ifndef MAC_68k
    struct timeval tp;
    gettimeofday(&tp, NULL);
/*  srandom(1); */
#ifdef USE_RAND
    srand(tp.tv_sec);
#else
    srandom(tp.tv_sec);
#endif
#endif
    }

long trandom(void)
    {
#ifdef USE_RAND
    return abs(rand())%32768L;
#else
    return abs(random())%32768L;
#endif
    }

#ifdef MAC_68k
QDGlobals qd;

void init_machdep(void)
    {
	WindowPtr TheWindow;
	Handle menuBarHandle;
	MenuHandle appleMenu;
    short monacoID
    if (game_variables != NULL)
        {
        /*
        DebugStr("\pShort-circuiting...");
        */
    	return;
        }
#if  ! (defined (TARGET_API_MAC_68k_CARBON) && TARGET_API_MAC_68k_CARBON)
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);
	FlushEvents(everyEvent, 0);
#endif
	InitCursor();
	TheWindow = GetNewWindow(128, 0L, (WindowPtr) - 1L);
	SetWTitle(TheWindow, "\pThe Minstrel's Song");
	SetPort(GETWINDOW(TheWindow));
    getFNum("\pMonaco", &monacoID);
	TextFont(monacoID);
	TextSize(12);
	menuBarHandle = (Handle) GetNewMBar(128);
	SetMenuBar(menuBarHandle);
	appleMenu = GetMenuHandle(128);
	AppendResMenu(appleMenu, 'DRVR');
	DrawMenuBar();
#if __PowerPC__
	AEInstallEventHandler(kCoreEventClass, kAEOpenApplication, NewAEEventHandlerProc(MyHandleOAPP), 0,
	  false);
	AEInstallEventHandler(kCoreEventClass, kAEOpenDocuments, NewAEEventHandlerProc(MyHandleODOC), 0,
	  false);
	AEInstallEventHandler(kCoreEventClass, kAEPrintDocuments, NewAEEventHandlerProc(MyHandlePDOC), 0,
	  false);
	AEInstallEventHandler(kCoreEventClass, kAEQuitApplication, NewAEEventHandlerProc(MyHandleQUIT), 0,
	  false);
#endif /* __PowerPC__ */
    machdep_init_screens();
    tsrandom();
    event_check();
    }

#endif

#ifdef GTK
void init_machdep(void)
    {
    machdep_init_screens();
    }
#endif

void machdep_init_screens(void)
    {
    long i, j;
    screen_image = (char *) calloc(window_columns() * window_lines(),
      sizeof(char));
    screen_image_changed = (long *) calloc(window_columns() * window_lines(),
      sizeof(long));
    game_variables->old_window_columns = window_columns();
    game_variables->old_window_lines = window_lines();
    for(i = 0; i < game_variables->old_window_columns; ++i)
	for(j = 0; j < game_variables->old_window_lines; ++j)
	    {
	    screen_image[i * game_variables->old_window_lines + j] = ' ';
	    screen_image_changed[i * game_variables->old_window_lines + j] = TRUE;
	    }
    }

long window_lines(void)
    {
#ifdef GTK
    /* To implement later; now it's effectively a bug. */
    return 0;
#endif
#ifdef MAC_68k
    GrafPtr port;
    Rect r;
    GetPort(&port);
    GETPORTBOUNDS(port, &r);
    return (r.bottom - r.top) / ONE_CHARACTER_HEIGHT;
#endif
    /*
	return (qd.thePort->portRect.bottom - qd.thePort->portRect.top) / ONE_CHARACTER_HEIGHT;
    */
    }

long window_columns(void)
    {
#ifdef GTK
    /* To implement later; now it's effectively a bug. */
    return 0;
#endif
#ifdef MAC_68k
    GrafPtr port;
    Rect r;
    GetPort(&port);
    GETPORTBOUNDS(port, &r);
    return (r.right - r.left) / ONE_CHARACTER_WIDTH;
#endif
    /*
	return (qd.thePort->portRect.right - qd.thePort->portRect.left) / ONE_CHARACTER_WIDTH;
    */
    }

long window_boundary(long window_id, long boundary_id)
    {
    switch(window_id)
	{
	case WINDOW_BOTTOM_PANEL:
	    switch(boundary_id)
		{
		case WINDOW_MAX_X:
		    return window_columns() - 1;
		break;
		case WINDOW_MAX_Y:
		    return window_lines() - 1;
		break;
		case WINDOW_MIN_X:
		    return 13;
		break;
		case WINDOW_MIN_Y:
		    return window_lines() - 3;
		break;
		default:
#ifdef GTK
		    pmsg("Error: out of range window boundary in window_boundary()");
#else
		    perror("Error: out of range window boundary in window_boundary()");
#endif
		break;
		}
	break;
	case WINDOW_DUNGEON:
	    switch(boundary_id)
		{
		case WINDOW_MAX_X:
		    return window_columns() - 1;
		break;
		case WINDOW_MAX_Y:
		    return window_lines() - 5;
		break;
		case WINDOW_MIN_X:
		    return 13;
		break;
		case WINDOW_MIN_Y:
		    return 6;
		break;
		default:
#ifdef GTK
		    pmsg("Error: out of range window boundary in window_boundary()");
#else
		    perror("Error: out of range window boundary in window_boundary()");
#endif
		break;
		}
	break;
	case WINDOW_LEFT_PANEL:
	    switch(boundary_id)
		{
		case WINDOW_MAX_X:
		    return 10;
		break;
		case WINDOW_MAX_Y:
		    return 23;
		break;
		case WINDOW_MIN_X:
		    return 0;
		break;
		case WINDOW_MIN_Y:
		    return 6;
		break;
		default:
#ifdef GTK
		    pmsg("Error: out of range window boundary in window_boundary()");
#else
		    perror("Error: out of range window boundary in window_boundary()");
#endif
		break;
		}
	break;
	case WINDOW_PUZZLE:
	    switch(boundary_id)
		{
		case WINDOW_MAX_X:
		    return window_columns() - 1;
		break;
		case WINDOW_MAX_Y:
		    return window_lines() - 1;
		break;
		case WINDOW_MIN_X:
		    return 0;
		break;
		case WINDOW_MIN_Y:
		    return 6;
		break;
		default:
#ifdef GTK
		    pmsg("Error: out of range window boundary in window_boundary()");
#else
		    perror("Error: out of range window boundary in window_boundary()");
#endif
		break;
		}
	break;
	case WINDOW_STDSCR:
	    switch(boundary_id)
		{
		case WINDOW_MAX_X:
		    return window_columns() - 1;
		break;
		case WINDOW_MAX_Y:
		    return window_lines() - 1;
		break;
		case WINDOW_MIN_X:
		    return 0;
		break;
		case WINDOW_MIN_Y:
		    return 0;
		break;
		default:
#ifdef GTK
		    pmsg("Error: out of range window boundary in window_boundary()");
#else
		    perror("Error: out of range window boundary in window_boundary()");
#endif
		break;
		}
	break;
	case WINDOW_TOP_TEXT:
	    switch(boundary_id)
		{
		case WINDOW_MAX_X:
		    return window_columns() - 1;
		break;
		case WINDOW_MAX_Y:
		    return 5;
		break;
		case WINDOW_MIN_X:
		    return 0;
		break;
		case WINDOW_MIN_Y:
		    return 0;
		break;
		default:
#ifdef GTK
		    pmsg("Error: out of range window boundary in window_boundary()");
#else
		    perror("Error: out of range window boundary in window_boundary()");
#endif
		break;
		}
	break;
	default:
#ifdef GTK
	    pmsg("Error, out of range window ID in window_boundary()!");
#else
	    perror("Error, out of range window ID in window_boundary()!");
#endif
	break;
	}
    return -1; /* Error if we get here.  */
    }

void window_add_character(long window_id, long x, long y, char this_character)
    {
    if ((0 <= x) &&
      (window_boundary(window_id, WINDOW_MAX_X) - window_boundary(window_id,
      WINDOW_MIN_X) >= x) &&
      (0 <= y) &&
      (window_boundary(window_id, WINDOW_MAX_Y) - window_boundary(window_id,
      WINDOW_MIN_Y) >= y))
	{
	window_assign_character(x + window_boundary(window_id, WINDOW_MIN_X),
	   y + window_boundary(window_id, WINDOW_MIN_Y), this_character);
	}
    }

/* Scroll one line.  */

void window_scroll(long window_id)
    {
    long i, j;
    /* The <= in one case, and < in another, are intentional.  */
    for(i = window_boundary(window_id, WINDOW_MIN_X); i <=
      window_boundary(window_id, WINDOW_MAX_X); ++i)
	{
	for(j = window_boundary(window_id, WINDOW_MIN_Y); j <
	  window_boundary(window_id, WINDOW_MAX_Y); ++j)
	    {
	    window_assign_character(i, j, screen_image[i * window_lines() + j +
	      1]);
	    }
	window_assign_character(i, window_boundary(window_id, WINDOW_MAX_Y),
	  ' ');
	}
    }

/*
 *
 * Put all non-newline characters of a string on a specified line, and clear to
 * the end of line in the window.
 *
 */

void window_puts(long window_id, long line_id, char *message)
    {
    long i, pos;
    for(pos = i = 0; i <= window_boundary(window_id, WINDOW_MAX_X) -
      window_boundary(window_id, WINDOW_MIN_X); ++i)
	{
	if (((pos < strlen(message)) && (message[pos] != '\n')) && (message[pos] !=
	'\t'))
	    window_assign_character(i + window_boundary(window_id,
	      WINDOW_MIN_X), window_boundary(window_id, WINDOW_MIN_Y) +
	      line_id, message[pos]);
	else if ((pos < strlen(message)) && (message[pos] == '\t'))
	    {
	    window_assign_character(i + window_boundary(window_id,
	      WINDOW_MIN_X), window_boundary(window_id, WINDOW_MIN_Y) +
	      line_id, ' ');
	    for(++i; (i % 8 != 0) && (i <= window_boundary(window_id,
	      WINDOW_MAX_X) - window_boundary(window_id, WINDOW_MIN_X)); ++i)
		window_assign_character(i + window_boundary(window_id,
		  WINDOW_MIN_X), window_boundary(window_id, WINDOW_MIN_Y) +
		  line_id, ' ');
	    }
	else
	    window_assign_character(i + window_boundary(window_id,
	      WINDOW_MIN_X), window_boundary(window_id, WINDOW_MIN_Y) +
	      line_id, ' ');
	++pos;
	}
    }

void window_move_cursor(long window_id, long x, long y)
    {
    long dummy;
#ifdef TMS_CURSES
    move(y + window_boundary(window_id, WINDOW_MIN_Y), x +
      window_boundary(window_id, WINDOW_MIN_X));
#endif
#ifdef GTK
    dummy = window_id;
    dummy = x;
    dummy = y;
#endif
    }

void window_clear()
    {
#ifndef GTK
#ifdef MAC_68k
    Rect theRect;
#endif
    long i, j;
#ifdef MAC_68k
    if (!TheWindow) return;
#endif
    for(i = 0; i < window_columns(); ++i)
	for(j = 0; j < window_lines(); ++j)
	    window_assign_character(i, j, ' ');
    for(i = 0; i < window_columns(); ++i)
	for(j = 0; j < window_lines(); ++j)
		screen_image_changed[i * window_lines() + j] = 0;
#ifdef MAC_68k
	SetRect(&theRect, 0, 0, ONE_CHARACTER_WIDTH * (window_columns() + 1),
	  ONE_CHARACTER_HEIGHT * (window_lines() + 1));
	EraseRect(&theRect);
#endif
#endif
    }

void window_refresh()
    {
#ifndef GTK
    unsigned char message[256] = "";
#ifdef MAC_68k
    Rect theRect;
#endif
    long i, j, k, l, changed, continuous;
    changed = FALSE;
	for(j = 0; j < window_lines(); ++j)
    for(i = 0; i < window_columns(); ++i)
	    {
	    if (screen_image_changed[i * window_lines() + j])
		{
		/* The machine dependent code to actually display a */
		/* character in a specified position.  */
#ifdef TMS_CURSES
		mvaddch(j, i, screen_image[i * window_lines() + j]);
#endif
#ifdef MAC_68k
		/* We want to print as long of a continuous string as we can at once.  */
		continuous = TRUE;
		message[0] = message[1] = 0;
		for(l = k = i; k < window_columns(); ++k)
			if ((continuous) && ((screen_image_changed[k * window_lines() + j])
			  || ((k + 1 < window_columns()) && (screen_image_changed[(k + 1) *
			  window_lines() + k]))))
				{
				message[max(1, strlen((char *) message)) + 1] = 0;
				message[max(1, strlen((char *) message))] = (unsigned char) screen_image[k * window_lines() + j];
				++message[0];
				l = k;
				screen_image_changed[k * window_lines() + j] = FALSE;
				}
			else
				continuous = FALSE;
#ifdef MAC_68k
		SetRect(&theRect, ONE_CHARACTER_WIDTH*i,
		  ONE_CHARACTER_HEIGHT*j + 1, ONE_CHARACTER_WIDTH*(l + 1),
		  ONE_CHARACTER_HEIGHT * (j + 1) + 1);
		EraseRect(&theRect);
		MoveTo(ONE_CHARACTER_WIDTH*i, ONE_CHARACTER_HEIGHT*(j + 1) - 2);
		DrawString(message);
#endif
		i = l;
#endif
		changed = TRUE;
		}
#ifndef MAC_68k
	    screen_image_changed[i * window_lines() + j] = FALSE;
#endif
	    }
    if (changed)
	{
#ifdef TMS_CURSES
    	window_refresh();
#endif
	}
#endif
    }

void window_resize(void)
    {
    /* What is appropriate to resizing the window.  */
    long i, j;
    char *old_screen_image;
    old_screen_image = screen_image;
    free(screen_image_changed);
    screen_image = (char *) calloc(window_lines() * window_columns(),
      sizeof(char));
    screen_image_changed = (long *) calloc(window_lines() * window_columns(),
      sizeof(long));
    for(i = 0; i < window_lines() * window_columns(); ++i)
	{
	screen_image[i] = ' ';
	screen_image_changed[i] = TRUE;
	}
	for(i = 0; i < min(window_columns(), game_variables->old_window_columns); ++i)
		for(j = 0; j < min(window_lines(), game_variables->old_window_lines); ++j)
			screen_image[i * window_lines() + j] = old_screen_image[i *
			  game_variables->old_window_lines + j];
	game_variables->old_window_lines = window_lines();
	game_variables->old_window_columns = window_columns();
	free(old_screen_image);
    if (!(flag_check(game_variables->flags, DURING_INIT)))
	update_window();
	window_refresh();
    }

void window_assign_character(long x, long y, char new_character)
    {
    if (screen_image[x * window_lines() + y] != new_character)
	screen_image_changed[x * window_lines() + y] = TRUE;
    screen_image[x * window_lines() + y] = new_character;
    }

void window_touch(long window_id)
    {
    long i, j;
    for(i = window_boundary(window_id, WINDOW_MIN_X); i <=
      window_boundary(window_id, WINDOW_MAX_X); ++i)
	for(j = window_boundary(window_id, WINDOW_MIN_Y); j <=
	  window_boundary(window_id, WINDOW_MAX_Y); ++j)
	    screen_image_changed[i * window_lines() + j] = TRUE;
    }

#ifdef MAC_68k
void event_check(void)
	{
	union four_letter_integer open_document_event_class, open_document_event_id;
	EventRecord theEvent;
	WindowPtr whichWindow;
	Rect windowRect;
	short newHeight;
	short newWidth;
	short thePart;
	short theMenu;
	short theMenuItem;
	long menuAndItem;
	long newSize;
	long x_pos, y_pos, x_diff, y_diff, i, theEventWhere;
	char myKey, message[256];
	void *myBuff = NULL;
	long myErr;
    BitMap screenBits;
    GrafPtr port;
    Rect portRect;
    if (!TheWindow) return;
	if (!(WaitNextEvent(everyEvent, &theEvent, 0L, 0L)))
		return;
	strcpy(open_document_event_class.fli_char, "aevt");
	strcpy(open_document_event_id.fli_char, "odoc");
	game_variables->modulus = 0L;
	switch(theEvent.what)
		{
		case keyDown:
			myKey = (char) theEvent.message;
			if (theEvent.modifiers & cmdKey)
				{
				menuAndItem = MenuKey(myKey);
				/* theMenu = HiWord(menuAndItem);
				theMenuItem = LoWord(menuAndItem); */
                theMenu = menuAndItem >> 16;
                theMenuItem = (menuAndItem << 16) >> 16;
				handle_menu_item(theMenu, theMenuItem);
				HiliteMenu(0);
				window_touch(WINDOW_STDSCR);
				window_refresh();		
				}
			else
				{
				if ((myKey) == 18) /* ^R -- refresh */
					{
					window_touch(WINDOW_STDSCR);
					window_refresh();
					}
				menu_push_char(myKey);
				}
		break;
		case mouseDown:
			thePart = FindWindow(theEvent.where, &whichWindow);
			switch(thePart)
				{
				case inDrag:
                    GETQDGLOBALSCREENBITS(&screenBits);
					DragWindow(whichWindow, theEvent.where,
					  &screenBits.bounds);
				break;
				case inGoAway:
					pmsg("This window is only closed when the application quits.");
					pmsg("Quit The Minstrel's Song: are you sure?");
					if (confirm_silent())
						{
						if (!(flag_check(game_variables->flags, IN_BETWEEN_GAMES)))
							{
							pmsg("Save game before quitting?");
							if (confirm_silent())
								save("TMS Save File");
							}
						exit(0);
						}
				break;
				case inGrow:
					SetRect( &windowRect, 100, 50, 640, 800 );
					newSize = GrowWindow( whichWindow, theEvent.where, &windowRect );
					if (newSize) {
                            /* newHeight = HiWord(newSize);
                            newWidth = LoWord(newSize); */
                            newHeight = newSize >> 16;
                            newWidth = (newSize << 16) >> 16;
							SizeWindow( whichWindow, newWidth, newHeight, true );
							}
					window_resize();
				break;
				case inMenuBar:
					menuAndItem = MenuSelect(theEvent.where);
					if (menuAndItem > 0)
						{
						/* theMenu = HiWord(menuAndItem);
						theMenuItem = LoWord(menuAndItem); */
                        theMenu = menuAndItem >> 16;
                        theMenuItem = (menuAndItem << 16) >> 16;
						handle_menu_item(theMenu, theMenuItem);
						}
					HiliteMenu(0);
					window_touch(WINDOW_STDSCR);
					window_refresh();
				break;
				case inZoomIn:
				case inZoomOut:
					if (TrackBox(whichWindow, theEvent.where, thePart))
						{
						ZoomWindow( whichWindow, thePart, 0 );
						}
					window_resize();
				break;
				case inContent:
                    GetPort(&port);
                    GETPORTBOUNDS(port, &portRect);
				    x_pos = ((theEvent.where.h - qd.thePort->portRect.left - 3) / ONE_CHARACTER_WIDTH);
				    y_pos = ((theEvent.where.v - qd.thePort->portRect.top) / ONE_CHARACTER_HEIGHT) - 3;
				    if (flag_check(game_variables->flags, DURING_PUZZLE))
				    	{
				    	if ((window_boundary(WINDOW_PUZZLE, WINDOW_MIN_X) <= x_pos) &&
					      (window_boundary(WINDOW_PUZZLE, WINDOW_MAX_X) >= x_pos) &&
					      (window_boundary(WINDOW_PUZZLE, WINDOW_MIN_Y) <= y_pos) &&
					      (window_boundary(WINDOW_PUZZLE, WINDOW_MAX_Y) >= y_pos))
					      	{
					      	x_diff = x_pos - window_boundary(WINDOW_PUZZLE, WINDOW_MIN_X);
					      	y_diff = y_pos - window_boundary(WINDOW_PUZZLE, WINDOW_MIN_Y);
					      	for(i = 0; i <= abs(x_diff) + abs(y_diff); ++i)
					      		if (i > 0)
					      			switch(((i * x_diff) / (abs(x_diff) + abs(y_diff))
				    	  			  - ((i - 1) * x_diff) / (abs(x_diff) + abs(y_diff))
				      				  + 3 * ((i * y_diff) / (abs(x_diff) + abs(y_diff))
				      				  - ((i - 1) * y_diff) / (abs(x_diff) + abs(y_diff)))))
				      				  	{
				      			  		case -4:
				      			  			menu_push_char('y');
					      			  	break;
					      			  	case -3:
					      			  		menu_push_char('k');
					      			  	break;
					      			  	case -2:
				    	  			  		menu_push_char('u');
				      				  	break;
				      				  	case -1:
				      				  		menu_push_char('h');
				      			  		break;
					      			  	case 0:
					      			  		/* Do nothing.  */
					      			  	break;
					      			  	case 1:
					      			  		menu_push_char('l');
				    	  			  	break;
				      				  	case 2:
				      				  		menu_push_char('b');
				      				  	break;
				      			  		case 3:
				      			  			menu_push_char('j');
					      			  	break;
					      			  	case 4:
					      			  		menu_push_char('n');
					      			  	break;
					      			  	}
				    	  	menu_push_char('.');
				    		}
				    	}
				    else if ((window_boundary(WINDOW_DUNGEON, WINDOW_MIN_X) <= x_pos) &&
				      (window_boundary(WINDOW_DUNGEON, WINDOW_MAX_X) >= x_pos) &&
				      (window_boundary(WINDOW_DUNGEON, WINDOW_MIN_Y) <= y_pos) &&
				      (window_boundary(WINDOW_DUNGEON, WINDOW_MAX_Y) >= y_pos))
				      	{
				      	x_diff = x_pos - (window_boundary(WINDOW_DUNGEON, WINDOW_MAX_X)
				      	  + window_boundary(WINDOW_DUNGEON, WINDOW_MIN_X))/2 +
				      	  player->x - game_variables->display_center_x;
				      	y_diff = y_pos - (window_boundary(WINDOW_DUNGEON, WINDOW_MAX_Y)
				      	  + window_boundary(WINDOW_DUNGEON, WINDOW_MIN_Y))/2 +
				      	  player->y - game_variables->display_center_y;
				      	for(i = 0; i <= abs(x_diff) + abs(y_diff); ++i)
				      		if (i > 0)
				      			switch(((i * x_diff) / (abs(x_diff) + abs(y_diff))
				      			  - ((i - 1) * x_diff) / (abs(x_diff) + abs(y_diff))
				      			  + 3 * ((i * y_diff) / (abs(x_diff) + abs(y_diff))
				      			  - ((i - 1) * y_diff) / (abs(x_diff) + abs(y_diff)))))
				      			  	{
				      			  	case -4:
				      			  		menu_push_char('y');
				      			  	break;
				      			  	case -3:
				      			  		menu_push_char('k');
				      			  	break;
				      			  	case -2:
				      			  		menu_push_char('u');
				      			  	break;
				      			  	case -1:
				      			  		menu_push_char('h');
				      			  	break;
				      			  	case 0:
				      			  		/* Do nothing.  */
				      			  	break;
				      			  	case 1:
				      			  		menu_push_char('l');
				      			  	break;
				      			  	case 2:
				      			  		menu_push_char('b');
				      			  	break;
				      			  	case 3:
				      			  		menu_push_char('j');
				      			  	break;
				      			  	case 4:
				      			  		menu_push_char('n');
				      			  	break;
				      			  	}
				      	if (flag_check(game_variables->flags, DURING_EXAMINE))
				      		menu_push_char('.');		  
				      	}
				break;
				}
		break;
		case osEvt:
			window_touch(WINDOW_STDSCR);
			window_refresh();
		break;
		/* This case partially taken from MacZoop */
		case kHighLevelEvent:
			memcpy(&theEventWhere, &theEvent.where, 4);
			if ((open_document_event_class.fli_long == theEvent.message) &&
			  (open_document_event_id.fli_long == theEventWhere )) /* It's an open doc request */
			  	{
		/*	if (AcceptHighLevelEvent(&myTarg, &myRefCon, myBuff, &myLength) == bufferIsSmall)
				{
				myBuff = malloc(myLength);
				AcceptHighLevelEvent(&myTarg, &myRefCon, myBuff, &myLength);
				}*/
			myErr = AEProcessAppleEvent(&theEvent);
			if (myErr)
				{
				sprintf(message, "AEProcessAppleEvent returned error %ld.", myErr);
				pmsg(message);
				}
				}
/*			sprintf(message, "1Error id %ld", AEGetParamDesc( &theAEDesc, keyDirectObject, typeAEList, &docList));
			sprintf(message, "2Error id %ld", GotRequiredParams( &theEvent));
			sprintf(message, "3Error id %ld", GotRequiredParams( &theAEDesc));
*/ /*			pmsg(message);
			 AECountItems( &docList, &n );
			 sprintf(message, " n is %ld", n);
			 pmsg(message);
			if (n > 0)
				{
			 AEGetNthPtr( &docList,
												1, 
												typeFSS, 
												&keyWrd,
												&retType, 
												&aFile, 
												sizeof( FSSpec ), 
												&actualSize );
				// FSpGetFInfo( &aFile, &fi );
				//init_restore(message);
				free(myBuff);		
				}
			else
				{
				AEGetParamPtr((struct AEDesc *) &theEvent, keyDirectObject, typeFSS, &retType, &aFile, sizeof(FSSpec), &actualSize);
				if (actualSize == 0)
					pmsg("Actual size equals zero.");
				sprintf(message, "The filename is %d characters long.", aFile.name[0]);
				pmsg(message);
				fs_anykey();
				for(i = 0; i < aFile.name[0]; ++i)
					message[i] = aFile.name[i + 1];
				message[i] = 0;
				pmsg(message);
				/ *else
					init_restore((char *) aFile.name);
				}
				}*/
		break;
	}
	}

void handle_menu_item(short theMenu, short theMenuItem)
	{
/* Commented out as unneeded and depracated: */

    /*

	Str255 itemName;

    */

	long i;
	char save_filename[256];
						switch(theMenu)
							{
							case 128: /* Apple menu */

/* Commented out as unneeded and depracated: */

/*
								switch(theMenuItem)
									{
									case 1:
										read_file(FILE_MOTD);
									break;
									default:
										appleMenu = GetMenuHandle(128);
										GetMenuItemText(appleMenu, theMenuItem, itemName);
										OpenDeskAcc(itemName);
									break;
									}
*/
							break;
							case 129: /* File menu */
								switch(theMenuItem)
									{
									case 1: /* New game... */
										if (!(flag_check(game_variables->flags,
										  IN_BETWEEN_GAMES)))
										    pmsg("You must save or end the game before starting a new one.");
										else
											{
											flag_reset(&game_variables->flags, 
											  IN_BETWEEN_GAMES);
											init();
											}
									break;
									case 2: /* Open game... */
										if (!(flag_check(game_variables->flags,
										  IN_BETWEEN_GAMES)))
										    pmsg("You must save or end the game before opening another one.");
										else
											{
											flag_reset(&game_variables->flags, 
											  IN_BETWEEN_GAMES);
											pmsg("Please enter the name of the savefile you wish to restore.");
											tgets(save_filename);
											init_restore(save_filename);
											}
									break;
									case 3: /* Save game... */
										menu_push_char('S');
									break;
									case 4: /* End game... */
										pmsg("End current game: are you sure?");
										if (confirm_silent())
											flag_set(&game_variables->flags, 
											  IN_BETWEEN_GAMES);
										for(i = 0; i < 10; ++i)
											menu_push_char(ESCAPE);
										window_clear();
									break;
									case 6: /* Quit TMS */
										pmsg("Quit The Minstrel's Song: are you sure?");
										if (confirm_silent())
											{
											if (!(flag_check(game_variables->flags, IN_BETWEEN_GAMES)))
												{
												pmsg("Save game before quitting?");
												if (confirm_silent())
													save("TMS Save File");
												}
											exit(0);
											}									
									break;
									}
							break;
							case 130: /* Movement menu */
								switch(theMenuItem)
									{
									case 1: /* Left */
										menu_push_string("h");
									break;
									case 2: /* Right */
										menu_push_string("l");
									break;
									case 3: /* Up */
										menu_push_string("k");
									break;
									case 4: /* Down */
										menu_push_string("j");
									break;
									case 5: /* Up & left */
										menu_push_string("y");
									break;
									case 6: /* Up & right */
										menu_push_string("u");
									break;
									case 7: /* Down & left */
										menu_push_string("b");
									break;
									case 8: /* Down & right */
										menu_push_string("n");
									break;
									default:
										pmsg("This menu item exists to tell you how to move, not to be selected.");
									break;
									}
							break;
							case 131: /* Actions */
								switch(theMenuItem)
									{
									case 1: /* Activate an item */
										menu_push_string("a");
									break;
									case 2: /* Activate your location */
										menu_push_string("@");
									break;
									case 3: /* Allocate experience */
										menu_push_string("A");
									break;
									case 4: /* Clean an animal's carcass */
										menu_push_string("Dclean\n");
									break;
									case 5: /* Close a door */
										menu_push_string("C");
									break;
									case 6: /* Close an item */
										menu_push_string("c");
									break;
									case 7: /* Cover a weapon with poison */
										menu_push_string("Dcover with poison\n");
									break;
									case 8: /* Dismount your steed */
										menu_push_string("Ddismount\n");
									break;
									case 9: /* Drink (quaff) a liquid */
										menu_push_string("q");
									break;
									case 10: /* Drop an item */
										menu_push_string("d");
									break;
									case 11: /* Eat (munch) food */
										menu_push_string("m");
									break;
									case 12: /* Enter or exit a level */
										menu_push_string(">");
									break;
									case 13: /* Equip (wear, wield, etc.) an item */
										menu_push_string("e");
									break;
									case 14: /* Examine an item in your possession more closely */
										menu_push_string("x");
									break;
									case 15: /* Examine your surroundings more closely */
										menu_push_string("X");
									break;
									case 16: /* Fill an item with oil */
										menu_push_string("Dfill with oil\n");
									break;
									case 17: /* Fill an item with water */
										menu_push_string("Dfill with water\n");
									break;
									case 18: /* Fire or throw a missle weapon */
										menu_push_string("f");
									break;
									case 19: /* Fly or land */
										menu_push_string("F");
									break;
									case 20: /* Gather fruit or wood from a tree */
										menu_push_string("Dgather from tree\n");
									break;
									case 21: /* Give a name to another creature */
										menu_push_string("Dgive name\n");
									break;
									case 22: /* Give an item to another creature */
										menu_push_string("g");
									break;
									case 23: /* Go to sleep */
										menu_push_string("G");
									break;
									case 24: /* Insert one item into another */
										menu_push_string("Dinsert\n");
									break;
									case 25: /* Jump (vault) from one location to another */
										menu_push_string("v");
									break;
									case 26: /* Mount a steed */
										menu_push_string("Dmount\n");
									break;
									case 27: /* Move to a city location */
										menu_push_string("M");
									break;
									case 28: /* Open a door */
										menu_push_string("O");
									break;
									case 29: /* Open an item */
										menu_push_string("o");
									break;
									case 30: /* Pet an animal */
										menu_push_string("Dpet\n");
									break;
									case 31: /* Print an inventory of items in your possession */
										menu_push_string("i");
									break;
									case 32: /* Push a creature in a direction */
										menu_push_string("Dpush creature\n");
									break;
									case 33: /* Read an item */
										menu_push_string("r");
									break;
									case 34: /* Rest a moment */
										menu_push_string(".");
									break;
									case 35: /* Rest/wait for a while */
										menu_push_string(",");
									break;
									case 36: /* Remove an item from a container */
										menu_push_string("Dremove\n");
									break;
									case 37: /* Search (inspect) the surrounding area */
										menu_push_string("I");
									break;
									case 38: /* Start running */
										menu_push_string("Drun\n");
									break;
									case 39: /* Start walking */
										menu_push_string("Dwalk\n");
									break;
									case 40: /* Swap places with a creature */
										menu_push_string("Dswap\n");
									break;
									case 41: /* Take a nap */
										menu_push_string("Dnap\n");
									break;
									case 42: /* Talk to another person */
										menu_push_string("t");
									break;
									case 43: /* Unequip, i.e. remove, an item in use */
										menu_push_string("E");
									break;
									}
							break;
							case 132: /* Skills */
								switch(theMenuItem)
									{
									case 1: /* Animal handling */
										menu_push_string("sanimal handling\n");
									break;
									case 2: /* Chemistry */
										menu_push_string("schemistry\n");
									break;
									case 3: /* Fishing */
										menu_push_string("sfishing\n");
									break;
									case 4: /* Geography */
										menu_push_string("sgeography\n");
									break;
									case 5: /* Guess actions */
										menu_push_string("sguess actions\n");
									break;
									case 6: /* Herbalism */
										menu_push_string("sherbalism\n");
									break;
									case 7: /* Medicine */
										menu_push_string("smedicine\n");
									break;
									case 8: /* Music (flute) */
										menu_push_string("smusic (flute)\n");
									break;
									case 9: /* Music (harp) */
										menu_push_string("smusic (harp)\n");
									break;
									case 10: /* Music (lute) */
										menu_push_string("smusic (lute)\n");
									break;
									case 11: /* Music (organ) */
										menu_push_string("smusic (organ)\n");
									break;
									case 12: /* Music (singing) */
										menu_push_string("smusic (singing)\n");
									break;
									case 13: /* Navigation */
										menu_push_string("snavigation\n");
									break;
									case 14: /* Pick locks */
										menu_push_string("spick locks\n");
									break;
									case 15: /* Repair */
										menu_push_string("srepair\n");
									break;
									case 16: /* Technology identification */
										menu_push_string("stechnology identification\n");
									break;
									case 17: /* Tinkering */
										menu_push_string("stinkering\n");
									break;
									case 18: /* Tracking */
										menu_push_string("stracking\n");
									break;
									}
							break;
							case 133: /* Prayers */
								switch(theMenuItem)
									{
									case 1: /* Adoration */
										menu_push_string("padoration\n");
									break;
									case 2: /* Aegis of God */
										menu_push_string("paegis of God\n");
									break;
									case 3: /* Blessing */
										menu_push_string("pblessing\n");
									break;
									case 4: /* Breath of God */
										menu_push_string("pbreath of God\n");
									break;
									case 5: /* Breath prayer */
										menu_push_string("pbreath prayer\n");
									break;
									case 6: /* Breath of God */
										menu_push_string("pbreath of God\n");
									break;
									case 7: /* Chant */
										menu_push_string("pchant\n");
									break;
									case 8: /* Chariot of fire */
										menu_push_string("pchariot of fire\n");
									break;
									case 9: /* Contemplate Scripture */
										menu_push_string("pcontemplate Scripture\n");
									break;
									case 10: /* Converse */
										menu_push_string("pconverse\n");
									break;
									case 11: /* Dance */
										menu_push_string("pdance\n");
									break;
									case 12: /* Dawn of Creation */
										menu_push_string("pdawn of Creation\n");
									break;
									case 13: /* Divine sustenance */
										menu_push_string("pdivine sustenance\n");
									break;
									case 14: /* Doxology */
										menu_push_string("pdoxology\n");
									break;
									case 15: /* Emptying */
										menu_push_string("pemptying\n");
									break;
									case 16: /* Favor with man */
										menu_push_string("pfavor with man\n");
									break;
									case 17: /* Final strike */
										menu_push_string("pfinal strike\n");
									break;
									case 18: /* Fire from Heaven */
										menu_push_string("pfire from Heaven\n");
									break;
									case 19: /* Flying */
										menu_push_string("pflying\n");
									break;
									case 20: /* Fortitude */
										menu_push_string("pfortitude\n");
									break;
									case 21: /* Funeral */
										menu_push_string("pfuneral\n");
									break;
									case 22: /* Guardian angel */
										menu_push_string("pguardian angel\n");
									break;
									case 23: /* Healing */
										menu_push_string("phealing\n");
									break;
									case 24: /* Holy ground */
										menu_push_string("pholy ground\n");
									break;
									case 25: /* Holy of Holies */
										menu_push_string("pHoly of Holies\n");
									break;
									case 26: /* Humbling before God */
										menu_push_string("phumbling before God\n");
									break;
									case 27: /* Images */
										menu_push_string("pimages\n");
									break;
									case 28: /* Increase attribute */
										menu_push_string("pincrease attribute\n");
									break;
									case 29: /* Increase faith */
										menu_push_string("pincrease faith\n");
									break;
									case 30: /* Increase skill */
										menu_push_string("pincrease skill\n");
									break;
									case 31: /* Insight */
										menu_push_string("pinsight\n");
									break;
									case 32: /* Interpret tongues */
										menu_push_string("pinterpret tongues\n");
									break;
									case 33: /* Janra blessing */
										menu_push_string("pJanra blessing\n");
									break;
									case 34: /* Kythe */
										menu_push_string("pkythe\n");
									break;
									case 35: /* Lightning strike */
										menu_push_string("plightning strike\n");
									break;
									case 36: /* Listen to Creation */
										menu_push_string("plisten to Creation\n");
									break;
									case 37: /* Listen to silence */
										menu_push_string("plisten to silence\n");
									break;
									case 38: /* Listen to the Eternal Song */
										menu_push_string("plisten to the Eternal Song\n");
									break;
									case 39: /* Liturgy */
										menu_push_string("pliturgy\n");
									break;
									case 40: /* Love */
										menu_push_string("plove\n");
									break;
									case 41: /* Meditation */
										menu_push_string("pmeditation\n");
									break;
									case 42: /* Name */
										menu_push_string("pName\n");
									break;
									case 43: /* Name of Jesus */
										menu_push_string("pname of Jesus\n");
									break;
									case 44: /* Offer self */
										menu_push_string("poffer self\n");
									break;
									case 45: /* Paternoster */
										menu_push_string("ppaternoster\n");
									break;
									case 46: /* Persuasion */
										menu_push_string("ppersuasion\n");
									break;
									case 47: /* Praise God */
										menu_push_string("ppraise God\n");
									break;
									case 48: /* Prologue to John */
										menu_push_string("pprologue to John\n");
									break;
									case 49: /* Providence */
										menu_push_string("pprovidence\n");
									break;
									case 50: /* Raise dead */
										menu_push_string("praise dead\n");
									break;
									case 51: /* Receive gift */
										menu_push_string("preceive gift\n");
									break;
									case 52: /* Rejuvenate */
										menu_push_string("prejuvenate\n");
									break;
									case 53: /* Restoration */
										menu_push_string("prestoration\n");
									break;
									case 54: /* Reveal terrain */
										menu_push_string("preveal terrain\n");
									break;
									case 55: /* Sanctuary */
										menu_push_string("psanctuary\n");
									break;
									case 56: /* Shining light */
										menu_push_string("pshining light\n");
									break;
									case 57: /* Silent communion */
										menu_push_string("psilent communion\n");
									break;
									case 58: /* Silent contemplation */
										menu_push_string("psilent contemplation\n");
									break;
									case 59: /* Sing in tongues */
										menu_push_string("psing in tongues\n");
									break;
									case 60: /* Sing praises */
										menu_push_string("psing praises\n");
									break;
									case 61: /* Slay creature */
										menu_push_string("pslay creature\n");
									break;
									case 62: /* Speak in tongues */
										menu_push_string("pspeak in tongues\n");
									break;
									case 63: /* Star song */
										menu_push_string("pstar song\n");
									break;
									case 64: /* Stillness */
										menu_push_string("pstillness\n");
									break;
									case 65: /* Stop time */
										menu_push_string("pstop time\n");
									break;
									case 66: /* Submission */
										menu_push_string("psubmission\n");
									break;
									case 67: /* Thanksgiving */
										menu_push_string("pthanksgiving\n");
									break;
									case 68: /* Together with another person */
										menu_push_string("ptogether with another person\n");
									break;
									case 69: /* Tremble */
										menu_push_string("ptremble\n");
									break;
									case 70: /* Walk on water */
										menu_push_string("pwalk on water\n");
									break;
									case 71: /* Worship */
										menu_push_string("pworship\n");
									break;
									case 72: /* Worship service */
										menu_push_string("pworship service\n");
									break;
									}
							break;
							case 136: /* Other */
								switch(theMenuItem)
									{
									case 1: /* Become bellicose */
										menu_push_string("Dbecome bellicose\n");
									break;
									case 2: /* Charity contact */
										read_file(FILE_CHARITY_CONTACTS);
									break;
									case 3: /* Print license statement */
										read_file(FILE_COPYRIGHT);
									break;
									case 4: /* Print skill values */
										menu_push_string("Dprint skill values\n");
									break;
									case 5: /* Set options */
										menu_push_string("O");
									break;
									case 6: /* Set your haste level */
										menu_push_string("Dhaste\n");
									break;
									}
							break;
							case 134: /* Help -- some of these are special */
								switch(theMenuItem)
									{
									case 1: /* Complete list of commands */
										menu_push_char('/');
									break;
									case 2: /* Extended help */
										menu_push_string("Dextended_creature help\n");
									break;
									case 3: /* Read the FAQ list */
										menu_push_string("Dread FAQ list\n");
									break;
									case 4: /* Short help */
										menu_push_char('?');
									break;
									}
							break;
							case 135: /* Role play */
								switch(theMenuItem)
									{
									case 1: /* Espiriticthus: the cultures */
										read_file(FILE_CULTURES);
									break;
									case 2: /* Game master's introduction */
										read_file(FILE_GM_INTRO);
									break;
									case 3: /* Player's introduction */
										read_file(FILE_PLAYER_INTRO);
									break;
									case 4: /* Additional notes */
										read_file(FILE_NOTES);
									break;
									case 5: /* A mathematical model */
										read_file(FILE_MODEL);
									break;
									case 6: /* Why play? */
										read_file(FILE_WHYPLAY);
									break;
									}
							break;
							}
	}

#endif

#ifdef MAC_68k
pascal OSErr MyHandleOAPP(AppleEvent *theAppleEvent, AppleEvent *reply,
  long handlerRefcon)
  	{
    AppleEvent *dummy1;
    long dummy2;
    dummy1 = theAppleEvent;
    dummy1 = reply;
    dummy2 = handlerRefcon;
  	return 0;
  	}

pascal OSErr MyHandleODOC(AppleEvent *theAppleEvent, AppleEvent *reply,
  long handlerRefcon)
  	{
  	FInfo fi;
  	union four_letter_integer save_fli;
  	AEDescList docList;
  	long n, actualSize, dummy1;
    AppleEvent *dummy2;
	AEKeyword	keyWrd;
	DescType	retType;
	FSSpec aFile;
  	AEGetParamDesc( theAppleEvent, keyDirectObject, typeAEList, &docList);
    AECountItems( &docList, &n );
			if (n > 0)
				{
			 AEGetNthPtr( &docList,
												1, 
												typeFSS, 
												&keyWrd,
												&retType, 
												&aFile, 
												sizeof( FSSpec ), 
												&actualSize );
				FSpGetFInfo( &aFile, &fi );
				strcpy(save_fli.fli_char, "SAVE");
				if (fi.fdType == save_fli.fli_long) /* It's a save file */
					{
					/* for(i = 0; i < aFile.name[0]; ++i)
						message[i] = aFile.name[i + 1];
					message[i] = 0; */
					fs_anykey();
					window_clear();
					init_restore((char *) aFile.name);
					}
				}
    dummy1 = handlerRefcon;
    dummy2 = reply;
	return 0;
  	}  	

pascal OSErr MyHandlePDOC(AppleEvent *theAppleEvent, AppleEvent *reply,
  long handlerRefcon)
  	{
    AppleEvent *dummy1;
    long dummy2;
  	pmsg("The Minstrel's Song does not print documents.");
    dummy1 = theAppleEvent;
    dummy1 = reply;
    dummy2 = handlerRefcon;
  	return 0;
  	}

pascal OSErr MyHandleQUIT(AppleEvent *theAppleEvent, AppleEvent *reply,
  long handlerRefcon)
  	{
    AppleEvent *dummy1;
    long dummy2;
  	pmsg("Quit TMS: are you sure?");
  	if (confirm_silent())
  		{
  		if (!(flag_check(game_variables->flags, IN_BETWEEN_GAMES)))
  			{
  			pmsg("Save file before quitting?");
  			if (confirm_silent())
  				save("TMS Save File");
  			}
  		exit(0);
  		}
    dummy1 = theAppleEvent;
    dummy1 = reply;
    dummy2 = handlerRefcon;
  	return 0;
  	}

#endif

struct tile *new_tile(long icon_id)
	{
	struct tile *result;
	result = (struct tile *) calloc(1, sizeof(struct tile));
	result->me = result;
	result->icon_id = icon_id;
	result->next = NULL;
	return result;
	}

long tiles_are_equal(struct tile *tile1, struct tile *tile2)
	{
	while (1)
		{
		if ((tile1 == NULL) && (tile2 == NULL))
			return 1;
		if ((tile1 == NULL) || (tile2 == NULL))
			return 0;
		if ((tile1->icon_id) != (tile2->icon_id))
			return 0;
		tile1 = tile1->next;
		tile2 = tile2->next;
		}
	}
