/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2005 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include <string.h>
#include "tms.h"

#ifdef CODE_SEGMENT
#pragma segment TALK_C
#endif

char *talk_choice[6] =
    {
    "Greet",
    "Converse with",
    "Inquire about the profession of",
    "Trade with",
    "Request an action of",
    "Say goodbye to"
    };

char *intercessor_choice[2] =
    {
    "Pray for the Lord's blessing.",
    "Pray for healing."
    };
 
void talk(struct small_creature *c1, struct small_creature *c2)
    {
    char message[256], message2[256];
    long my_flag, my_continue;;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c1);
    check_pointer((struct pointer_struct *) c2);
#endif
    if ((c1 != NULL) && (c2 != NULL))
        {
        if (flag_check(c2->flags, HUMAN))
            {
            my_continue = TRUE;
            while (my_continue)
                {
#ifdef GTK
                switch(menu_choice("Talk: Would you like to:", talk_choice, 6) + 'a')
#else
                window_clear();
                fs_pmsg("Talk: would you like to:");
                fs_pmsg("");
                fs_pmsg("a: greet");
                fs_pmsg("b: converse with");
                fs_pmsg("c: inquire about the profession of");
                fs_pmsg("d: trade with");
                fs_pmsg("e: request an action of");
                fs_pmsg("f: invite to follow you");
                fs_pmsg("g: say goodbye to");
                fs_pmsg("");
                find_title(c2, message);
                fs_pmsg(message);
                fs_pmsg("");
                switch(tgetc())
#endif
                    {
                    case 'a':
                        window_clear();
                        if (c2->extended_creature != NULL)
                            switch(c2->extended_creature->gender)
                                {
                                case MALE:
                                    strncpy(message, "You give him ", 255);
                                    strncpy(message2, "He responds in kind.", 255);
                                break;
                                case FEMALE:
                                    strncpy(message, "You give her ", 255);
                                    strncpy(message2, "She responds in kind.", 255);
                                break;
                                }
                        else
                            switch(trandom() % 2)
                                {
                                case 0:
                                    strncpy(message, "You give him ", 255);
                                    strncpy(message2, "He responds in kind.", 255);
                                break;
                                case 1:
                                    strncpy(message, "You give her ", 255);
                                    strncpy(message2, "She responds in kind.", 255);
                                break;
                                }
                        message[255] = '\0';
                        message2[255] = '\0';
                        switch(c2->identity)
                            {
                            case JANRA:
                                my_flag = TRUE;
                /*
                                if (c2->extended_creature != NULL)
                                    {
                                    if ((game_variables->current_quest ==
                                      RECEIVED_GIFT) && (c2->extended_creature->age_class ==
                                      CHILD))
                                        {
                                        pmsg("The child gives you a flower.");
                                        acquire_item(c1, FLOWER);
                                        flag_set(&game_variables->quests_completed,
                                          RECEIVED_GIFT);
                                        my_flag = FALSE;
                                        }
                                    }
                */
                                if (my_flag)
                                    switch(trandom()%4)
                                        {
                                        case 0:
                                            strncat(message, "a sloppy, wet kiss.", max(0, 255 - strlen(message)));
                                            message[255] = '\0';
                                        break;
                                        case 1:
                                            strncat(message, "a honk on the nose.", max(0, 255 - strlen(message)));
                                            message[255] = '\0';
                                        break;
                                        case 2:
                                            strncat(message, "a floofing.", max(0, 255 - strlen(message)));
                                            message[255] = '\0';
                                        break;
                                        case 3:
                                            strncat(message, "a tickling.", max(0, 255 - strlen(message)));
                                            message[255] = '\0';
                                        break;
                                        }
                            break;
                            case JEC:
                                strncat(message, "your outstretched hand, and say, \"I give you my love.\"", max(0, 255 - strlen(message)));
                                message[255] = '\0';
                                fs_pmsg(message);
                                strncpy(message, "The response comes, \"And I give you mine.\"", 255);
                            break;
                            case NORKRIN:
                                strncat(message, "a hand on the shoulder.", 255 - max(0, strlen(message)));
                            break;
                            case SHAL:
                                strncat(message, "a gentle embrace.", 255 - max(0, strlen(message)));
                            break;
                            case TUZ:
                                strncat(message, "a crushing bear hug", 255 - max(0, strlen(message)));
                                if (trandom() % 4 == 0)
                                    strncat(message, ", and a punch in the stomach", 255 - max(0, strlen(message)));
                                strncat(message, ".", 255 - max(0, strlen(message)));
                            break;
                            case URVANOVESTILLI:
                                strncat(message, "a benediction, and three kisses on alternate cheeks.", 255 - max(0, strlen(message)));
                            break;
                            case YEDIDIA:
                                if (trandom() % 4 == 0)
                                    strncat(message, "a butterfly kiss.", 255 - max(0, strlen(message)));
                                else
                                    strncat(message, "a soft, gentle hug.", 255 - max(0, strlen(message)));
                            break;
                            }
                        message[255] = '\0';
                        fs_pmsg(message);
                        fs_pmsg(message2);
                    break;
                    case 'b':
                        window_clear();
                        if (language_check(c1, c2->identity))
                            {
                            if (c2->extended_creature != NULL)
                                {
                                switch(c2->extended_creature->talk)
                                    {
                                    case TALK_JANRA:
                                        if (game_variables->current_quest ==
                                          GUESSED_JANRA)
                                            janra_guess();
                                        else
                                            read_random_excerpt(FILE_QUOTES);
                                    break;
                                    case TALK_JEC: case TALK_NORKRIN: case
                                    TALK_TUZ:
                                    case TALK_URVANOVESTILLI: case TALK_YEDIDIA:
                                        read_random_excerpt(FILE_QUOTES);
                                    break;
                                    case TALK_SHAL:
                                        if (trandom() % 2)
                                            fs_pmsg("You see a gentle smile.  ");
                                        else
                                            read_random_excerpt(FILE_QUOTES);
                                    break;
                                    case TALK_CELEBRANT:
                                        talk_celebrant(c1, c2);
                                    break;
                                    case TALK_INTERCESSOR:
                                        talk_intercessor(c1, c2);
                                    break;
                                    case TALK_SERVER:
                                        talk_server(c1, c2);
                                    break;
                                    }
                                }
                            else
                                read_random_excerpt(FILE_QUOTES);
                            }
                        else
                            {
                            window_clear();
                            read_random_excerpt(FILE_TRANSLATION_FAILED);
                            }
                    break;
                    case 'c':
                        window_clear();
                        fs_pmsg("");
                        if (language_check(c1, c2->identity))
                            {
                            if (c2->extended_creature != NULL)
                                {
                                switch(c2->extended_creature->profession)
                                    {
                                    case ACROBAT:
                                        fs_pmsg("\"I am an acrobat.\"");
                                    break;
                                    case ANIMAL_HANDLER:
                                        fs_pmsg("\"I handle animals.\"");
                                    break;
                                    case ARCHER:
                                        fs_pmsg("\"I am an archer.\"");
                                    break;
                                    case BARD:
                                        fs_pmsg("\"I am a bard.\"");
                                    break;
                                    case HERBALIST:
                                        fs_pmsg("\"I am an herbalist.\"");
                                    break;
                                    case HUNTER:
                                        fs_pmsg("\"I am a hunter.\"");
                                    break;
                                    case INTERPRETER:
                                        fs_pmsg("\"I am an interpreter.\"");
                                    break;
                                    case JACK_OF_ALL_TRADES:
                                        fs_pmsg("\"I am really a jack of all trades.\"");
                                    break;
                                    case MAN_AT_ARMS:
                                        fs_pmsg("\"I study weapons and fighting art.\"");
                                    break;
                                    case MEDIC:
                                        fs_pmsg("\"I am a medic.\"");
                                    break;
                                    case MULTIPLE_PROFESSION:
                                    fs_pmsg("\"I'm an adventurer, with a couple of different talents.\"");
                                    break;
                                    case SCHOLAR:
                                        fs_pmsg("\"I am a scholar.\"");
                                    break;
                                    case SCOUT:
                                        fs_pmsg("\"I am a scout.\"");
                                    break;
                                    case WOODSMAN:
                                        fs_pmsg("\"I am a woodsman.\"");
                                    break;
                                    case AFFIRMER:
                                        fs_pmsg("\"It is my responsibility to help other people be who they are meant to be, to");
                                        fs_pmsg("affirm them.\"");
                                    break;
                                    case ARTISAN:
                                        fs_pmsg("\"I'm simply an artisan.\"");
                                    break;
                                    case BAKER:
                                        fs_pmsg("\"I am a baker.\"");
                                    break;
                                    case BLACKSMITH:
                                        fs_pmsg("\"I am a blacksmith.\"");
                                    break;
                                    case BREWER:
                                        fs_pmsg("\"I am a brewer.\"");
                                    break;
                                    case CARPENTER:
                                        fs_pmsg("\"I am a carpenter.\"");
                                    break;
                                    case COBBLER:
                                        fs_pmsg("\"I am a cobbler.\"");
                                    break;
                                    case COOK:
                                        fs_pmsg("\"I am a cook.\"");
                                    break;
                                    case DEVICE_MAKER:
                                        fs_pmsg("\"I am a craftsman who makes devices.\"");
                                    break;
                                    case FARMER:
                                        fs_pmsg("\"I am a farmer.\"");
                                    break;
                                    case FISHERMAN:
                                        fs_pmsg("\"I am a fisherman.\"");
                                    break;
                                    case GARDENER:
                                        fs_pmsg("\"I am a gardener.\"");
                                    break;
                                    case MASON:
                                        fs_pmsg("\"I am a mason.\"");
                                    break;
                                    case MERCHANT:
                                        fs_pmsg("\"I am a merchant.\"");
                                    break;
                                    case MYSTIC:
                                        fs_pmsg("\"I am a mystic.\"");
                                    break;
                                    case PHILOSOPHER:
                                        fs_pmsg("\"I am a philosopher.\"");
                                    break;
                                    case POET:
                                        fs_pmsg("\"I am a poet.\"");
                                    break;
                                    case SAILOR:
                                        fs_pmsg("\"I am a sailor.\"");
                                    break;
                                    case SHEPHERD:
                                        fs_pmsg("\"I am a shepherd.\"");
                                    break;
                                    case TAILOR:
                                        fs_pmsg("\"I am a tailor.\"");
                                    break;
                                    case TANNER:
                                        fs_pmsg("\"I am a tanner.\"");
                                    break;
                                    case WEAVER:
                                        fs_pmsg("\"I am a weaver.\"");
                                    break;
                                    default:
#ifdef HAS_SNPRINTF
                                        snprintf(message, 255, "Error; out of range profession %ld!", c2->extended_creature->profession);
#else
                                        sprintf(message, "Error; out of range profession %ld!", c2->extended_creature->profession);
#endif
                                        message[255] = '\0';
                                    break;
                                    }
                                }
                            else
                                fs_pmsg("\"I do just this and that, really...\"");
                            }
                        else
                            {
                            window_clear();
                            read_random_excerpt(FILE_TRANSLATION_FAILED);
                            }
                    break;
                    case 'd':
                        if (language_check(c1, c2->identity))
                            {
                            talk_trade(c1, c2);
                            }
                        else
                            {
                            window_clear();
                            read_random_excerpt(FILE_TRANSLATION_FAILED);
                            }
                    break;
                    case 'e':
                        if (language_check(c1, c2->identity))
                            {
                            window_clear();
                            if (c1->extended_creature != NULL)
                                {
                                if (c2->extended_creature != NULL)
                                    {
                                    if (skill_check(c1,
                                      c1->extended_creature->skills->av[PERSUASION],
                                      c2->extended_creature->persuade_diff,
                                      SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE) >
                                      0)
                                        {
                                        pmsg("\"What would you like for me to do?\"");
                                        get_command(c2);
                                        }
                                    }
                                else
                                    {
                                    if (skill_check(c1,
                                      c1->extended_creature->skills->av[PERSUASION],
                                      master_creatures[c2->identity]->persuade_diff,
                                      SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE) >
                                      0)
                                        {
                                        pmsg("\"What would you like for me to do?\"");
                                        get_command(c2);
                                        }
                                    }
                                }
                            }
                        else
                            {
                            window_clear();
                            read_random_excerpt(FILE_TRANSLATION_FAILED);
                            }
                    break;
                    case 'f':
                        if (language_check(c1, c2->identity))
                            {
                            window_clear();
                            if (c1->extended_creature != NULL)
                                {
                                if (c2->extended_creature != NULL)
                                    {
                                    if (skill_check(c1,
                                      c1->extended_creature->skills->av[PERSUASION],
                                      c2->extended_creature->persuade_diff + ONE_NOTCH,
                                      SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE) >
                                      0)
                                        {
                                        pmsg("I'll follow you.");
                                        make_follow(c2, c1);
                                        }
                                    else
                                        pmsg("I won't follow you for now.");
                                    }
                                else
                                    {
                                    if (skill_check(c1,
                                      c1->extended_creature->skills->av[PERSUASION],
                                      master_creatures[c2->identity]->persuade_diff +
                                      ONE_NOTCH,
                                      SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE) >
                                      0)
                                        {
                                        pmsg("I'll follow you.");
                                        make_follow(c2, c1);
                                        }
                                    else
                                        pmsg("I won't follow you for now.");
                                    }
                                }
                            }
                        else
                            {
                            window_clear();
                            read_random_excerpt(FILE_TRANSLATION_FAILED);
                            }
                    break;
                    case 'g': case 'q': case ESCAPE:
                        window_clear();
                        pmsg("\"Goodbye!\"");
                        my_continue = FALSE;
                    break;
                    }
                fs_anykey();
                }
            }
        else
            {
#ifdef GTK
            new_tgets("What would you like to say to it?", message, NULL);
#else
            pmsg("What would you like to say to it?");
            tgets(message);
#endif
            }
        }
    }

long janra_guess(void)
    {
    char garbage[256];
    long my_continue;
#ifdef GTK
    my_continue = tms_confirm("The Janra says, \"Would you like to play a guessing game?\"");
#else
    pmsg("The Janra says, \"Would you like to play a guessing game?\"");
    my_continue = confirm_silent();
#endif
    if (!(my_continue))
        return FALSE;
    while (my_continue)
        {
#ifdef GTK
        new_tgets("\"Ask me a yes/no question.\"", garbage, NULL);
#else
        pmsg("\"Ask me a yes/no question.\"");
        tgets(garbage);
#endif
        switch(trandom() % 2)
            {
            case 0:
                pmsg("\"No.\"");
            break;
            case 1:
                pmsg("\"Yes.\"");
            break;
            }
#ifdef GTK
        my_continue = tms_confirm("The Janra says, \"Would you like to ask me another question?\"");
#else
        pmsg("\"Would you like to ask me another question?\"");
        my_continue = confirm_silent();
#endif
        }
    return TRUE;
    }

void talk_celebrant(struct small_creature *c1, struct small_creature *c2)
    {
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c1);
    check_pointer((struct pointer_struct *) c2);
#endif
#ifdef GTK
    if (tms_confirm("\"Hello. Would you like me to pray with you?\""))
#else
    fs_pmsg("\"Hello.  Would you like for me to pray with you?\"");
    if (confirm_silent())
#endif
        talk_intercessor(c1, c2);
    }

void talk_intercessor(struct small_creature *c1, struct small_creature *c2)
    {
    struct small_creature *dummy;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c1);
    check_pointer((struct pointer_struct *) c2);
#endif
    window_clear();
#ifdef GTK
    switch(menu_choice("\"Greetings. What can I do for you?\"",
      intercessor_choice, 2))
#else
    fs_pmsg("\"Greetings.  Would you like for me to:");
    fs_pmsg("");
    fs_pmsg("a: \"bless you, or");
    fs_pmsg("b: pray for healing?\"");
    switch(tgetc())
#endif
        {
        case 'a':
            window_clear();
            fs_pmsg("May the Lord bless you richly.");
            if (status_check(c1, STATUS_MIRACLE_PROVIDENCE) < 3)
                status_add(c1, STATUS_MIRACLE_PROVIDENCE, 1);
        break;
        case 'b':
            fs_pmsg("Lord, impart your healing.");
            healing(c1, 1);
        break;
        }
    dummy = c2;
    }

void talk_server(struct small_creature *c1, struct small_creature *c2)
    {
    struct small_creature *dummy;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c1);
    check_pointer((struct pointer_struct *) c2);
#endif
    if (current_level->establishment != NULL)
        p_establishment(c1, TAVERN, current_level->establishment);
    dummy = c2;
    }

void talk_trade(struct small_creature *c1, struct small_creature *c2)
    {
    char message[256], temp[256];
    struct small_item *curr_item;
    struct ilist *curr_ilist, *traverse;
    long my_continue, foo, success_haggling, i, offer, selection_char, markup,
      buyback;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c1);
    check_pointer((struct pointer_struct *) c2);
#endif
    if ((c1 != NULL) && (c2 != NULL))
        if ((c1->extended_creature != NULL) && (c2->extended_creature != NULL))
            {
            switch(c2->identity)
                {
                case JANRA:
                    markup = 50;
                    buyback = 30;
                break;
                case JEC:
                    markup = 20;
                    buyback = 50;
                break;
                case NORKRIN:
                    markup = 30;
                    buyback = 40;
                break;
                case SHAL:
                    markup = 20;
                    buyback = 40;
                break;
                case TUZ:
                    markup = 50;
                    buyback = 60;
                break;
                case URVANOVESTILLI:
                    markup = 150;
                    buyback = 20;
                break;
                case YEDIDIA:
                    markup = 75;
                    buyback = 30;
                break;
                default:
                    markup = 50;
                    buyback = 50;
#ifdef DEBUG
pmsg("Talk_trade() called on creature of inappropriate race.");
#endif
                break;
                }
            if (c2->extended_creature->pack != NULL)
                for(traverse = c2->extended_creature->pack; traverse != NULL; traverse =
                  traverse->next)
        if (traverse->current != NULL)
                    if (traverse->current->price == 0)
                        traverse->current->price = random_adjust((((traverse->
                          current->value * (100 + markup))/100)*(100 +
                          markup))/100);
            my_continue = TRUE;
            while (my_continue)
                {
                game_variables->fs_messages_printed = 0;
                window_clear();
                fs_pmsg("You are trading with someone.");
                fs_pmsg("");
                fs_pmsg("You may:");
                fs_pmsg("");
                fs_pmsg("a: inquire about his inventory");
                if (c2->extended_creature->gender == MALE)
                    fs_pmsg("b: haggle over the price of an item he has");
                else
                    fs_pmsg("b: haggle over the price of an item she has");
                fs_pmsg("c: purchase an item");
                fs_pmsg("d: haggle over the price of an item which you wish to sell.");
                fs_pmsg("e: sell an item");
                fs_pmsg("f: quit trading");
                fs_pmsg("i: look at your inventory");
                fs_pmsg("");
                /* ## */
                switch(tgetc())
                    {
                    case 'a':
                        window_clear();
                        foo = 'a';
                        game_variables->fs_messages_printed = 0;
                        print_inventory(c2);
                        fs_anykey();
                    break;
                    case 'b':
                        fs_pmsg("");
                        foo = 'a';
                        fs_pmsg("Which item?");
                        /* ## */
                        selection_char = tgetc();
                        curr_item = find_item(&c2->extended_creature->pack,
                          selection_char, 0);
                        if (curr_item == NULL)
                            fs_pmsg("That is not a valid item.");
                        else
                            {
                            if (flag_check(curr_item->flags2, HAGGLED))
                                fs_pmsg("You have already haggled over the price of that item.");
                            else
                                {
                                flag_set(&curr_item->flags2, HAGGLED);
                                success_haggling = min(4,
                                  skill_check(c1,
                                    c1->extended_creature->skills->av[HAGGLING],
                                    c2->extended_creature->skills->av[HAGGLING],
                                    SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE));
                                if (success_haggling <= 0)
                                    fs_pmsg("You aren't able to bring the price down at all.");
                                else
                                    {
                                    for(i=0; i < success_haggling; ++i)
                                        curr_item->price = (curr_item->price *
                                          100) / (100 + markup);
                                    curr_item->price =
                                      random_adjust(curr_item->price);
                                    money_string(curr_item->price, temp);
#ifdef HAS_SNPRINTF
                                    snprintf(message, 255, "You haggle the price down to %s.", temp);
#else
                                    sprintf(message, "You haggle the price down to %s.", temp);
#endif
                                    message[255] = '\0';
                                    fs_pmsg(message);
                                    }
                                }
                            }
                        fs_anykey();
                    break;
                    case 'c':
                        fs_pmsg("");
                        fs_pmsg("Which item?");
                        /* ## */
                        selection_char = tgetc();
                        foo = 'a';
                        curr_item = find_item(&c2->extended_creature->pack,
                          selection_char, 0);
                        if (curr_item == NULL)
                            fs_pmsg("That is not a valid item.");
                        else
                            {
                            if (!(deduct_amount(c1, curr_item->price)))
                                fs_pmsg("You don't quite have enough money.");
                            else
                                {
                                add_amount(c2, curr_item->price);
                                foo = 'a';
                                flag_reset(&curr_item->flags2, HAGGLED);
                                extract_item(&c2->extended_creature->pack, 'a',
                                  &foo, selection_char,
                                  EXTRACT_REMOVE_ITEM);
                                find_and_remove_item(curr_item,
                                  &c2->extended_creature->pack);
                                add_item(&c1->extended_creature->pack, curr_item);
                                if (c1==player)
                                    {
                                    window_clear();
                                    pmsg("You put it in your pack...");
                                    }
                                calc_ready(c1);
                                calc_ready(c2);
                                }
                            }
                        fs_anykey();
                    break;
                    case 'd':
                        fs_pmsg("");
                        fs_pmsg("Which item (from your pack)?");
                        /* ## */
                        selection_char = tgetc();
                        foo = 'a';
                        curr_item = find_item(&c1->extended_creature->pack,
                          selection_char, EXTRACT_RECURSIVE);
                        if (curr_item == NULL)
                            fs_pmsg("That is not a valid item.");
                        else
                            if (flag_check(curr_item->flags2, HAGGLED))
                            fs_pmsg("You have already haggled over the price of that item.");
                        else
                            {

/*
 *
 * Shops will only pay half as much for items which are not identified.
 *
 */

                                offer = 1 + (((curr_item->value * (100 -
                                  buyback))/100) * (100 - buyback))/100/(1 +
                                  flag_check(curr_item->flags, IDENTIFIED));
                                money_string(offer, temp);
                                curr_item->price = offer;
                                if (c2->extended_creature->gender == MALE)
#ifdef HAS_SNPRINTF
                                    snprintf(message, 255, "He offers you %s for it.", temp);
#else
                                    sprintf(message, "He offers you %s for it.", temp);
#endif
                                else
#ifdef HAS_SNPRINTF
                                    snprintf(message, 255, "She offers you %s for it.", temp);
#else
                                    sprintf(message, "She offers you %s for it.", temp);
#endif
                                message[255] = '\0';
                                fs_pmsg(message);
                                flag_set(&curr_item->flags2, HAGGLED);
                                success_haggling = min(4,
                                  skill_check(c1, c1->extended_creature->skills->av[HAGGLING],
                                  c2->extended_creature->skills->av[HAGGLING], SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE));
                                if (success_haggling <= 0)
                                    fs_pmsg("You aren't able to bring the price up at all.");
                                else
                                    {
                                    for(i=0; i < success_haggling; ++i)
                                        curr_item->price = (curr_item->price * 100)
                                          / (100 - buyback);
                                    curr_item->price =
                                      random_adjust(curr_item->price);
                                    money_string(curr_item->price, temp);
#ifdef HAS_SNPRINTF
                                    snprintf(message, 255,
                                      "You haggle the price up to %s.", temp);
#else
                                    sprintf(message,
                                      "You haggle the price up to %s.", temp);
#endif
                                    message[255] = '\0';
                                    fs_pmsg(message);
                                    flag_set(&curr_item->flags2, HAGGLED);
                                    }
                                }
                        fs_anykey();
                    break;
                    case 'e':
                        fs_pmsg("");
                        fs_pmsg("Which item (from your pack)?");
                        /* ## */
                        selection_char = tgetc();
                        foo = 'a';
                        curr_item = find_item(&c1->extended_creature->pack, selection_char,
                          EXTRACT_RECURSIVE);
                        if (curr_item == NULL)
                            fs_pmsg("That is not a valid item.");
                        else
                            if (!(flag_check(curr_item->flags2, HAGGLED)))
                                pmsg("You have not haggled over that item");
                            else if (!(deduct_amount(c2, curr_item->price)))
                                {
                                if (c2->extended_creature->gender == MALE)
                                    pmsg("He doesn't have enough money.");
                                else
                                    pmsg("She doesn't have enough money.");
                                }
                            else
                                {
                                add_amount(c1, curr_item->price);
                                curr_item = extract_item(&c1->extended_creature->pack, 'a',
                                  &foo, selection_char, EXTRACT_REMOVE_ITEM);
                                find_and_remove_item(curr_item,
                                  &c1->extended_creature->pack);
                                curr_ilist = (struct ilist *) calloc(1,
                                  sizeof(struct ilist));
                                curr_ilist->me = curr_ilist;
                                curr_ilist->next = c2->extended_creature->pack;
                                curr_ilist->current = curr_item;
                                c2->extended_creature->pack = curr_ilist;
                                fs_pmsg("Sold!");
                                }
                        fs_anykey();
                    break;
                    case 'i':
                        print_inventory(c1);
                    break;
                    case 'q': case 'x': case ESCAPE: case 'f':
                        my_continue = 0;
                    break;
                    }
                }
            window_clear();
            }
    }
