/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2005 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include "tms.h"
#include <math.h>

#ifdef CODE_SEGMENT
#pragma segment DATA2_C
#endif

long all_creatures_acted;

void update_world(void)
    {
    struct level *this_level;
    struct clist *currentl;
    struct small_creature *currentc;
    long next_creature_action;
    this_level = current_level;
    all_creatures_acted = TRUE;
    next_creature_action = -1;
    if (!(flag_check(player->flags, INACTIVE)))
        {
        if (player->nextaction <= game_variables->elapsed_units)
            act(player);
        else
            next_creature_action = max(0, player->nextaction -
              game_variables->elapsed_units);
        }
    if (!all_creatures_acted)
        return;
    for(currentl=current_level->creatures;((currentl != NULL) && (this_level ==
      current_level)); currentl=currentl->next)
        if (currentl->current != NULL)
        {
        currentc=currentl->current;
        currentc->x = min(max(currentc->x, 0), MAX_X - 1);
        currentc->y = min(max(currentc->y, 0), MAX_Y - 1);
        if ((currentc->identity < 0) || (currentc->identity > LAST_ANIMAL))
            {
            currentc->identity = 0;
            if (currentc->hostile != NULL)
                {
                free_clist(currentc->hostile);
                currentc->hostile = NULL;
                }
            }
#ifdef DEBUG
        check_creature(currentc);
        check_pointer((struct pointer_struct *) currentc);
        check_pointer((struct pointer_struct *) currentl);
#endif
        if ((currentc->nextaction >= DAY) && (game_variables->elapsed_units <
          (DAY/2L)))
            currentc->nextaction -= DAY;
        if (!(flag_check(currentc->flags, INACTIVE)) && currentc != player)
            {
            if (currentc->nextaction <= game_variables->elapsed_units)
                act(currentc);
            else
                {
                if (next_creature_action != -1)
                    next_creature_action = min(next_creature_action, max(0,
                      currentc->nextaction - game_variables->elapsed_units));
                else
                    next_creature_action = max(0, currentc->nextaction -
                      game_variables->elapsed_units);
                }
            }
        /* Have a creature's mount act as well.  */
        if (this_level == current_level)
            if (currentc->extended_creature != NULL)
                if (currentc->extended_creature->mount != NULL)
                    {
                    if ((currentc->extended_creature->mount->nextaction >= DAY) &&
                     (game_variables->elapsed_units < DAY/2L))
                        currentc->extended_creature->mount->nextaction -= DAY;
                    if (!(flag_check(currentc->extended_creature->mount->flags, INACTIVE)))
                        while (currentc->extended_creature->mount->nextaction <=
                          game_variables->elapsed_units)
                            {
                            mount_act(currentc);
                            }
                    }
        }
    if (all_creatures_acted)
        {
        game_variables->elapsed_units += max(current_level->timescale,
          next_creature_action);
        if (game_variables->elapsed_units >= DAY)
            {
            ++game_variables->elapsed_days;
            game_variables->elapsed_units -= DAY;
            }
        time_check();
        }
    }

/* In time checks, if in the first half of any time interval, we run the */
/* appropriate check, and reset the appropriate time_flag.  If in the second */
/* half, we set the flag.  */

void time_check(void)
    {
    long my_continue;
    struct clist *traverse;
    if ((game_variables->elapsed_units % SECOND < SECOND/2) ||
      (current_level->timescale >= SECOND))
        {
        if ((flag_check(game_variables->flags, ONE_SECOND_CHECK)) ||
          (current_level->timescale >= SECOND))
            {
            flag_reset(&game_variables->flags, ONE_SECOND_CHECK);
            one_second_check();
            }
        }
    else
        flag_set(&game_variables->flags, ONE_SECOND_CHECK);
    my_continue = 1;
    if (current_level != countryside)
        if (!(flag_check(current_level->space
          [game_variables->new_level_player_x]
          [game_variables->new_level_player_y].flags, OCCUPIED)))
            if (!(player->followed_by == NULL))
                for(traverse = player->followed_by; ((!(traverse == NULL)) &&
                  (my_continue == 1)); traverse = traverse->next)
            if (traverse->current != NULL)
                    if ((!(is_on_level(traverse->current, current_level))) &&
              (traverse->current != player->extended_creature->mount))
                        {
                        no_hostile_add_creature(current_level,
                          traverse->current,
                          game_variables->new_level_player_x,
                          game_variables->new_level_player_y);
                        my_continue = 0;
                        }
    /*
    update_light_sources();
    */
    }

void one_second_check(void)
    {
    player->extended_creature->stati->time[STATUS_FATIGUED] = 
      player->extended_creature->stati->time[STATUS_PASSED_OUT] =
      player->extended_creature->stati->time[STATUS_THIRSTY] =
      player->extended_creature->stati->time[STATUS_TIRED] = 0;
    if ((game_variables->elapsed_units % MINUTE < MINUTE/2) ||
      (current_level->timescale >= MINUTE))
        {
        if ((flag_check(game_variables->flags, ONE_MINUTE_CHECK)) ||
          (current_level->timescale >= MINUTE))
            {
            flag_reset(&game_variables->flags, ONE_MINUTE_CHECK);
            one_minute_check();
            }
        }
    else
        flag_set(&game_variables->flags, ONE_MINUTE_CHECK);
    /*
    update_light_sources();
    */
    }

void one_minute_check(void)
    {
    struct clist *traverse;
    struct small_creature *c;
    long i, result;
    if (game_variables->elapsed_units % HOUR < HOUR/2)
        {
        if (flag_check(game_variables->flags, ONE_HOUR_CHECK))
            {
            flag_reset(&game_variables->flags, ONE_HOUR_CHECK);
            one_hour_check();
            }
        }
    else
        flag_set(&game_variables->flags, ONE_HOUR_CHECK);
    /*
    if (flag_check(player->flags, SLEEPING))
        noprompt_pmsg("You are asleep.");
    else
        noprompt_pmsg("You are awake.");
    */
    for(traverse = current_level->creatures; (!(traverse == NULL)); traverse =
      traverse->next)
        if (traverse->current != NULL)
        {
        c = traverse->current;
        if (!(c->extended_creature == NULL))
            {
            for (i=0;i<NUM_STATI;++i)
                {
                if ((flag_check(adjustment_info[i].flags, DECREASES_OVER_TIME))
                  && (!((flag_check(adjustment_info[i].flags,
                  NO_CHANGE_IN_RESTORATION)) && (status_check(c,
                  STATUS_MIRACLE_RESTORATION) > 0))))
                    {
                    if (flag_check(adjustment_info[i].flags, HAS_MINIMUM))
                        c->extended_creature->stati->time[i] =
                          max(c->extended_creature->stati->time[i] - MINUTE,
                          adjustment_info[i].time_increment *
                          adjustment_info[i].min);
                    else
                        c->extended_creature->stati->time[i] =
                          c->extended_creature->stati->time[i] - MINUTE;
                    }
                if ((flag_check(adjustment_info[i].flags, INCREASES_OVER_TIME))
                  && (!(((flag_check(c->flags, SLEEPING)) ||
                  (status_check(c, STATUS_PASSED_OUT) > 0)) &&
                  (flag_check(adjustment_info[i].flags,
                  NO_INCREASE_WHEN_ASLEEP)))) &&
                  (!((flag_check(adjustment_info[i].flags,
                  NO_CHANGE_IN_RESTORATION)) && (status_check(c,
                  STATUS_MIRACLE_RESTORATION > 0)))))
                    {
                    if (flag_check(adjustment_info[i].flags, HAS_MAXIMUM))
                        c->extended_creature->stati->time[i] =
                          min(c->extended_creature->stati->time[i] + MINUTE,
                          adjustment_info[i].time_increment *
                          adjustment_info[i].min);
                    else
                        c->extended_creature->stati->time[i] =
                        c->extended_creature->stati->time[i] + MINUTE;
                    if (c == player)
                        if ((c->extended_creature->stati->time[i] > adjustment_info[i].
                          time_increment) && (c->extended_creature->stati->time[i] %
                          adjustment_info[i].time_increment < MINUTE))
                            status_message(c, i);
                    }
                if (flag_check(adjustment_info[i].flags,
                  CHECK_HIGH_VALUES_DAMAGE))
                    {
                    result = skill_check(c, c->extended_creature->attributes[CO],
                      (-10 + status_check(c, i)) * ONE_NOTCH, 0);
                    if (result < 0)
                        creature_damage(c, 10 * abs(-1 - result), 0, \
                          abs(-1 - result));
                    }
                if (flag_check(adjustment_info[i].flags, CHECK_PASS_OUT))
                    {
                    result = skill_check(c, c->extended_creature->attributes[CO],
                      (-5 + status_check(c, i)) * ONE_NOTCH, 0);
                    if (result < 1)
                        pass_out(c, 1);
                    }
                }
            if (c->extended_creature->stati->time[STATUS_PASSED_OUT] > 0)
                {
                c->extended_creature->stati->time[STATUS_PASSED_OUT] =
                  max(c->extended_creature->stati->time[STATUS_PASSED_OUT] -
                  skill_check(c, c->extended_creature->attributes[CO], EASY,
                  0) * adjustment_info[STATUS_PASSED_OUT].time_increment,
                  adjustment_info[STATUS_PASSED_OUT].time_increment *
                  adjustment_info[STATUS_PASSED_OUT].min);
                if (status_check(c, STATUS_PASSED_OUT) == 0)
                    come_to(c);
                }
            if (flag_check(c->flags, SLEEPING))
                {
                c->extended_creature->stati->time[STATUS_TIRED] =
                  max(c->extended_creature->stati->time[STATUS_TIRED] -
                  attribute_adjust(3L*MINUTE,
                  c->extended_creature->attributes[CO]),
                  adjustment_info[STATUS_TIRED].time_increment *
                  adjustment_info[STATUS_TIRED].min);
                if (c->extended_creature->stati->time[STATUS_SLEEPING] <= 0)
                    wake_up(c);
                }
            if (flag_check(current_level->space[c->x][c->y].flags, IS_COLD))
                {
                result = skill_check(c, c->extended_creature->skills->av[COLD_TOLERANCE],
                  DIFFICULT, 0);
                if (result <= 0)
                    {
                    c->extended_creature->stati->time[STATUS_COLD] += (2L*MINUTE * (1 -
                      result));
                    if (c == player)
                        if ((c->extended_creature->stati->time[STATUS_COLD] >
                          adjustment_info[STATUS_COLD].time_increment) &&
                          (c->extended_creature->stati->time[STATUS_COLD] %
                          adjustment_info[STATUS_COLD].time_increment < 2L *
                          MINUTE))
                            status_message(c, STATUS_COLD);
                    }
                }
            if (flag_check(current_level->space[c->x][c->y].flags,
              EXTREMELY_COLD))
                {
                result = skill_check(c, c->extended_creature->skills->av[COLD_TOLERANCE],
                  VERY_DIFFICULT, 0);
                if (result <= 0)
                    {
                    c->extended_creature->stati->time[STATUS_COLD] += (2L*MINUTE * (1 -
                      result));
                    if (c == player)
                        if ((c->extended_creature->stati->time[STATUS_COLD] >
                          adjustment_info[STATUS_COLD].time_increment) &&
                          (c->extended_creature->stati->time[STATUS_COLD] %
                          adjustment_info[STATUS_COLD].time_increment < 2L *
                          MINUTE))
                            status_message(c, i);
                    }
                }
            calc_ready(c);
            }
        }
    if (!(is_on_level(player, current_level)))
        add_creature(current_level, player, player->x, player->y);
    check_level_pointers(current_level);
    if (game_variables->elapsed_units % (10L * MINUTE) < MINUTE)
        one_use_light_sources();
    update_light_sources();
    }

void one_hour_check(void)
    {
    struct clist *traverse;
    struct small_creature *c;
    long num_animals, num_humans, success, encountered;
    char creature_title[256], message[256];
    status_add(player, STATUS_HUNGRY, 1);
    c = NULL;
    if (game_variables->elapsed_units % DAY < DAY/2L)
        {
        if (flag_check(game_variables->flags, ONE_DAY_CHECK))
            {
            flag_reset(&game_variables->flags, ONE_DAY_CHECK);
            one_day_check();
            }
        }
    else
        flag_set(&game_variables->flags, ONE_DAY_CHECK);
    if (current_level->space[player->x][player->y].special != NULL)
        {
        encountered = FALSE;
        if (current_level->space[player->x][player->y].special->
          animal_encounter_frequency > 0)
            if ((trandom()%(current_level->space[player->x][player->y].special->
              animal_encounter_frequency/20) == 0) && (!(has_hummer(player))))
                {
                num_animals = 1;
                while (trandom() % current_level->space[player->x][player->y].
                  special->animal_encounter_frequency == 0)
                    ++num_animals;
                encounter(current_level->space[player->x][player->y].special->
                  animal_encounter_type, num_animals);
                encountered = TRUE;
                }
        if (!(encountered))
            if (current_level->space[player->x][player->y].special->
              human_encounter_frequency > 0)
                if (trandom()%(current_level->space[player->x][player->y].
                  special->human_encounter_frequency)/10 == 0)
                    {
                    num_humans = 1;
                    while (trandom() % current_level->space[player->x]
                      [player->y].special->human_encounter_frequency == 0)
                        ++num_humans;
                        human_encounter(current_level->space[player->x]
                          [player->y].special->human_encounter_type,
                          num_humans);
                    }
        }
    else
        {
        encountered = FALSE;
        if (current_level->animal_encounter_frequency > 0)
            if ((trandom()%current_level->animal_encounter_frequency == 0)
              && (!(has_hummer(player))))
                {
                num_animals = 1;
                while (trandom() % current_level->animal_encounter_frequency
                  == 0)
                    ++num_animals;
                encounter(current_level->animal_encounter_type, num_animals);
                encountered = TRUE;
                }
        if (!(encountered))
            if (current_level->human_encounter_frequency > 0)
                if (trandom()%current_level->human_encounter_frequency == 0)
                    {
                    num_humans = 1;
                    while (trandom() % current_level->human_encounter_frequency
                      == 0)
                        ++num_humans;
                    human_encounter(current_level->human_encounter_type,
                      num_humans);
                    }
            }
        /* Cathedrals have hourly worship services.  */
        if (current_level->level_type == LEVEL_CATHEDRAL)
        worship_service();
    for(traverse = current_level->creatures; (traverse != NULL); traverse =
      traverse->next)
        if (traverse->current != NULL)
        {
        c = traverse->current;
        if (c->extended_creature != NULL)
            {
            if (!(flag_check(c->flags, SLEEPING)))
                if (!(skill_check(c, c->extended_creature->attributes[CO] +
                  c->extended_creature->attributes[WI], (0 - 5 +
                  status_check(c, STATUS_TIRED)) * ONE_NOTCH, 0) > 0))
                    go_to_sleep(c);
            }
        }
    /* If the player is in the countryside, check to see if he gets lost.  */
    if ((current_level == countryside) && (status_check(player,
      STATUS_SLEEPING) <= 0))
        {
        if (player->extended_creature != NULL)
            {
            success = skill_check(player,
              player->extended_creature->skills->av[NAVIGATION], MODERATE,
              SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE);
            if (success < 0)
                pmsg("You're lost!");
            if ((status_check(player, STATUS_LOST) > 0) && (0 - success >
              status_check(player, STATUS_LOST)))
                pmsg("You find your way!");
            status_add(player, STATUS_LOST, 0 - success);
            }
        }
    if (player->followed_by != NULL)
        {
        for(traverse = player->followed_by; traverse != NULL; traverse =
          traverse->next)
        if (traverse->current != NULL)
            if (is_on_level(traverse->current, current_level))
                if (traverse->current->extended_creature != NULL)
                    {
                    c = traverse->current;
                    find_title(c, creature_title);
                    if (is_hungry(c))
                        {
                        if (find_and_remove_id(&c->extended_creature->pack, FOOD))
                            status_add(c, STATUS_HUNGRY, -1);
                        else if (find_and_remove_id(&c->extended_creature->pack,
                          RATION))
                            status_add(c, STATUS_HUNGRY, -1);
                        else if (find_and_remove_id(&c->extended_creature->pack,
                          TREE_FRUIT))
                            status_add(c, STATUS_HUNGRY, -1);
                        else
                            {
#ifdef HAS_SNPRINTF
                            snprintf(message, 255, "%s appears hungry.",
                              creature_title);
#else
                            sprintf(message, "%s appears hungry.",
                              creature_title);
#endif
                            message[255] = '\0';
                            pmsg(message);
                            }
                        }
                    if (is_thirsty(c))
                        {
                        if (find_and_remove_id(&c->extended_creature->pack, WATER))
                            status_add(c, STATUS_THIRSTY, -1);
                        else if (find_and_remove_id(&c->extended_creature->pack, WINE))
                            {
                            status_add(c, STATUS_THIRSTY, -1);
                            status_add(c, STATUS_ALCOHOL, 1);
                            }
                        else if (find_and_remove_id(&c->extended_creature->pack, BEER))
                            {
                            status_add(c, STATUS_THIRSTY, -1);
                            status_add(c, STATUS_ALCOHOL, 1);
                            }
                        else
                            {
#ifdef HAS_SNPRINTF
                            snprintf(message, 255, "%s appears thirsty.",
                              creature_title);
#else
                            sprintf(message, "%s appears thirsty.",
                              creature_title);
#endif
                            message[255] = '\0';
                            pmsg(message);
                            }
                        }
                    if (is_tired(c))
                        {
#ifdef HAS_SNPRINTF
                        snprintf(message, 255, "%s falls asleep.", creature_title);
#else
                        sprintf(message, "%s falls asleep.", creature_title);
#endif
                        message[255] = '\0';
                        pmsg(message);
                        go_to_sleep(c);
                        }
                    }
        }
    update_light_sources();
    }

void one_day_check(void)
    {
    struct clist *traverse;
    long success;
    if (game_variables->elapsed_days % MONTH < MONTH/2)
        {
        if (flag_check(game_variables->flags, ONE_MONTH_CHECK))
            {
            flag_reset(&game_variables->flags, ONE_MONTH_CHECK);
            one_month_check();
            }
        }
    else
        flag_set(&game_variables->flags, ONE_MONTH_CHECK);
    for (traverse = master_clist; (!(traverse == NULL)); traverse =
      traverse->next)
        if (traverse->current != NULL && !(traverse->current->extended_creature == NULL))
            {
            if (traverse->current->extended_creature->stati->time[STATUS_WOUNDED] > 0)
                {
                success =
                  skill_check(traverse->current,
                  traverse->current->extended_creature->attributes[CO] +
                  traverse->current->extended_creature->skills->av[MEDICINE],
                  DIFFICULT, 0);
                traverse->current->extended_creature->stati->time[STATUS_WOUNDED] =
                  max(0,
                  traverse->current->extended_creature->stati->time[STATUS_WOUNDED] -
                  success);
                traverse->current->extended_creature->stati->time[STATUS_HEALABLE] =
                  max(0,
                  traverse->current->extended_creature->stati->time[STATUS_HEALABLE] -
                  success);
                traverse->current->extended_creature->stati->time
                  [STATUS_HEALABLE_ANTIDOTE] = max(0,
                  traverse->current->extended_creature->stati->time
                  [STATUS_HEALABLE_ANTIDOTE] - success);
                calc_ready(traverse->current);
                }
            }
        else if (traverse->current != NULL)
            {
            if (traverse->current->wounded > 0)
                {
                success = min(skill_check(traverse->current,
                  master_creatures[traverse->current->identity]->attributes[CO],
                  DIFFICULT, 0), traverse->current->wounded);
                traverse->current->wounded -= success;
                traverse->current->att += 3 * success;
                traverse->current->def += 2 * success;
                traverse->current->dmg += success;
                traverse->current->hv += success;
                traverse->current->sp += success;
                }
            }
    update_light_sources();
    }

void one_month_check(void)
    {
    if (game_variables->elapsed_days % YEAR < YEAR/2)
        {
        if (flag_check(game_variables->flags, ONE_YEAR_CHECK))
            {
            flag_reset(&game_variables->flags, ONE_YEAR_CHECK);
            one_year_check();
            }
        }
    else
        flag_set(&game_variables->flags, ONE_YEAR_CHECK);
    update_light_sources();
    }

/* Here we deal with aging.  Unique creatures do not age.  */

void one_year_check(void)
    {
    long i, j, age_class_type;
    struct clist *traverse;
    for(traverse = master_clist; (!(traverse == NULL)); traverse =
      traverse->next)
        if (traverse->current != NULL)
        {
        if (flag_check(traverse->current->flags, HUMAN))
            age_class_type = traverse->current->identity;
        else
            age_class_type = FIRST_NONHUMAN;
        ++traverse->current->age;
        if (!(flag_check(traverse->current->flags, UNIQUE)))
            for(i=0;i<NUM_AGE_CLASSES;++i)
                if (traverse->current->age ==
                  age_class_years[age_class_type][i])
                    {
                    if (!(traverse->current->extended_creature == NULL))
                        {
                        ++traverse->current->extended_creature->age_class;
                        for(j=0;j<NUM_ATTRIBUTES;++j)
                            {
                            traverse->current->extended_creature->attributes[j] += 
                                (age_attribute_adjustment[i][j] -
                                age_attribute_adjustment[i - 1][j]);
                            traverse->current->extended_creature->perm_attributes[j] += 
                                (age_attribute_adjustment[i][j] -
                                age_attribute_adjustment[i - 1][j]);
                            }
                        calc_ready(traverse->current);
                        }
                    else
                        {
                        traverse->current->att +=
                            (age_attribute_adjustment[i][DE] -
                            age_attribute_adjustment[i - 1][DE]) +
                            (age_attribute_adjustment[i][SPEED] -
                            age_attribute_adjustment[i - 1][SPEED]) +
                            (age_attribute_adjustment[i][ST] -
                            age_attribute_adjustment[i - 1][ST]);
                        traverse->current->dmg +=
                            (age_attribute_adjustment[i][ST] -
                            age_attribute_adjustment[i - 1][ST]);
                        traverse->current->hv +=
                            (age_attribute_adjustment[i][CO] -
                            age_attribute_adjustment[i - 1][CO]) +
                            (age_attribute_adjustment[i][ST] -
                            age_attribute_adjustment[i - 1][ST]);
                        traverse->current->def +=
                            (age_attribute_adjustment[i][AG] -
                            age_attribute_adjustment[i - 1][AG]) +
                            (age_attribute_adjustment[i][SPEED] -
                            age_attribute_adjustment[i - 1][SPEED]);
                        }
                    }
        }
    update_light_sources();
    }

/* Longer days in the summer, shorter in the winter */

long my_daylight(void)
    {
    long result;
    result = (((double) abs(game_variables->elapsed_units - (DAY/2L))) /
      ((double) (DAY/2L)) < (.5 + .25*cos((((double)
      (game_variables->elapsed_days % YEAR))/((double) YEAR))*2*PI)));
    result = 1;
    if (result)
        {
        if (!(flag_check(game_variables->flags, DAYLIGHT)))
            {
            pmsg("The sun rises.");
            flag_set(&game_variables->flags, DAYLIGHT);
            if (flag_check(game_variables->flags,
              PLAYER_SLEEPING_UNTIL_SUNRISE))
                wake_up(player);
            }
        }
    else
        {
        if (flag_check(game_variables->flags, DAYLIGHT))
            {
            pmsg("The sun sets.");
            flag_reset(&game_variables->flags, DAYLIGHT);
            }
        }
    return result;
    }

long twilight(void)
    {
    long result;
    result = (((double) abs(game_variables->elapsed_units - (DAY/2L))) /
      ((double) (DAY/2L)) < (.6 + .3*cos((((double)
      (game_variables->elapsed_days % YEAR))/((double) YEAR))*2*PI)));
    result = 1;
    if (result)
        {
        if (!(flag_check(game_variables->flags, TWILIGHT)))
            {
            pmsg("The first rays of dawn peek over the horizon.");
            flag_set(&game_variables->flags, TWILIGHT);
            }
        }
    else
        {
        if (flag_check(game_variables->flags, TWILIGHT))
            {
            pmsg("The last rays of the dying sun ebb into darkness.");
            flag_reset(&game_variables->flags, TWILIGHT);
            }
        }
    return result;
    }

void update_light_sources(void)
    {
    long i, j;
    struct light_source_struct *lcurr;
    for(i=0;i<MAX_X;++i)
        for(j=0;j<MAX_Y;++j)
            {
            if (!(flag_check(current_level->space[i][j].flags,
              PERM_ILLUMINATED)))
                flag_reset(&current_level->space[i][j].flags,
                  CURR_ILLUMINATED);
            if (!(flag_check(current_level->space[i][j].flags,
              PERM_DIMLY_LIT)))
                flag_reset(&current_level->space[i][j].flags,
                  DIMLY_LIT);
            }
    if (flag_check(current_level->flags, OUTDOORS))
        {
        if (my_daylight())
            {
            for(i=0;i<MAX_X;++i)
                for(j=0;j<MAX_Y;++j)
                    flag_set(&current_level->space[i][j].flags,
                      CURR_ILLUMINATED);
            }
        else if (twilight())
            {
            for(i=0;i<MAX_X;++i)
                for(j=0;j<MAX_Y;++j)
                    flag_set(&current_level->space[i][j].flags, DIMLY_LIT);
            }
        }
    if (!(current_level->light_sources==NULL))
        {
        recalculate_light_sources(current_level);
        for(lcurr=current_level->light_sources;(!(lcurr==NULL));
          lcurr=lcurr->next)
            {
            for(i=0;i<MAX_X;++i)
                for(j=0;j<MAX_Y;++j)
                    if ((distance(i, j, lcurr->x, lcurr->y) <= 1) ||
                      ((lcurr->x - i)*(lcurr->x - i) + (lcurr->y - j)*
                      (lcurr->y - j) <= 2 + lcurr->radius*lcurr->radius/
                      (current_level->scale*current_level->scale)))
                        flag_set(&current_level->space[i][j].flags,
                          CURR_ILLUMINATED);
                    else if ((distance(i, j, lcurr->x, lcurr->y) <= 2) ||
                      ((lcurr->x - i)*(lcurr->x - i) + (lcurr->y - j)*
                      (lcurr->y - j) <= 4 + lcurr->radius*lcurr->radius * 4 /
                      (current_level->scale*current_level->scale)))
                        flag_set(&current_level->space[i][j].flags, DIMLY_LIT);
            }
        }
    }
