/***************************************************************************/
/* The Minstrel's Song is (c) 1998-2005 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.                 */
/***************************************************************************/

#include "tms.h"
#include <math.h>

#ifdef CODE_SEGMENT
#pragma segment UTIL2_C_A
#endif

char *yes_no_choice[2] =
  {
  "Yes",
  "No"
  };

long is_hungry(struct small_creature *c)
    {
    if (!(c->extended_creature == NULL))
        return (status_check(c, STATUS_HUNGRY) > 0);
    else
        return 0;
    }

long is_thirsty(struct small_creature *c)
    {
    if (!(c->extended_creature == NULL))
        return (status_check(c, STATUS_THIRSTY) > 0);
    else
        return 0;
    }

void add_random_creature(struct level *l, long encounter_type)
    {
    long x, y;
    struct small_creature *new_creature;
    x = trandom() % MAX_X;
    y = trandom() % MAX_Y;
    while ((flag_check(l->space[x][y].flags, OCCUPIED)) ||
        (!(flag_check(l->space[x][y].flags, CAN_OCCUPY))))
        {
        x = trandom() % MAX_X;
        y = trandom() % MAX_Y;
        }
    new_creature = make_random_creature(encounter_type);
    flag_set(&new_creature->flags, INACTIVE);
    no_hostile_add_creature(l, new_creature, x, y);
    check_addition(l, new_creature->identity, x, y, 0);
    }

void swap_places(struct small_creature *c1, struct small_creature *c2)
    {
    long x, y;
    if ((c1 != NULL) && (c2 != NULL))
        {
        x = c1->x;
        y = c1->y;
        c1->x = c2->x;
        c1->y = c2->y;
        c2->x = x;
        c2->y = y;
        correct_xy();
        }
    }

#ifdef CODE_SEGMENT
#pragma segment UTIL2_C_B
#endif

void find_string(long string_id, char *result)
    {
    switch(string_id)
        {
        case ST_DEFAULT:
            strncpy(result,
              "Error.  Default value inappropriately sent to find_string.", 255);
        break;
        case ST_EMPTY:
            strncpy(result, "", 255);
        break;
        case ST_A_BARE_ROOM:
            strncpy(result, "a bare room", 255);
        break;
        case ST_A_BED:
            strncpy(result, "a bed", 255);
        break;
        case ST_A_BEDROOM:
            strncpy(result, "a bedroom", 255);
        break;
        case ST_A_BOLOGNA_SANDWICH:
            strncpy(result, "a bologna sandwich", 255);
        break;
        case ST_A_BRONZE_STATUE_IN_A_NATIVITY_SCENE:
            strncpy(result, "a bronze statue in a Nativity scene", 255);
        break;
        case ST_A_BUILDING:
            strncpy(result, "a building", 255);
        break;
        case ST_A_BUILDING_WOVEN_OUT_OF_LIVING_TREES:
            strncpy(result, "a building woven out of living trees", 255);
        break;
        case ST_A_CABINET:
            strncpy(result, "a cabinet", 255);
        break;
        case ST_A_CATHEDRAL:
            strncpy(result, "a cathedral", 255);
        break;
        case ST_A_CHAIR:
            strncpy(result, "a chair", 255);
        break;
        case ST_A_CHEMICAL_LABORATORY:
            strncpy(result, "a chemical laboratory", 255);
        break;
        case ST_A_CLOAKROOM:
            strncpy(result, "a cloakroom", 255);
        break;
        case ST_A_CLOSED_DOOR:
            strncpy(result, "a closed door", 255);
        break;
        case ST_A_CLOSET:
            strncpy(result, "a closet", 255);
        break;
        case ST_A_COCONUT:
            strncpy(result, "a coconut", 255);
        break;
        case ST_A_COLLECTION_BOX:
            strncpy(result, "a collection box", 255);
        break;
        case ST_A_CRYPT:
            strncpy(result, "a crypt", 255);
        break;
        case ST_A_CUCUMBER:
            strncpy(result, "a cucumber", 255);
        break;
        case ST_A_DEN:
            strncpy(result, "a den", 255);
        break;
        case ST_A_DENSE_FOREST:
            strncpy(result, "a dense forest", 255);
        break;
        case ST_A_DEVICE_LABORATORY:
            strncpy(result, "a device laboratory", 255);
        break;
        case ST_A_DIAS:
            strncpy(result, "a dias", 255);
        break;
        case ST_A_DOORWAY_OF_HANGING_VINES:
            strncpy(result, "a doorway of hanging vines", 255);
        break;
        case ST_A_DUNGEON_DEEP_IN_THE_BOWELS_OF_THE_EARTH:
            strncpy(result, "a dungeon, deep in the bowels of the earth", 255);
        break;
        case ST_A_FIRE:
            strncpy(result, "a fire", 255);
        break;
        case ST_A_FOUNTAIN:
            strncpy(result, "a fountain", 255);
        break;
        case ST_A_GARDEN:
            strncpy(result, "a garden", 255);
        break;
        case ST_A_GREAT_HALL:
            strncpy(result, "a great hall", 255);
        break;
        case ST_A_HALLWAY:
            strncpy(result, "a hallway", 255);
        break;
        case ST_A_HEDGE:
            strncpy(result, "a hedge", 255);
        break;
        case ST_A_JEC_TOWN:
            strncpy(result, "a Jec town", 255);
        break;
        case ST_A_KITCHEN:
            strncpy(result, "a kitchen", 255);
        break;
        case ST_A_LABYRINTH:
            strncpy(result, "a labyrinth", 255);
        break;
        case ST_A_LARGE_AND_WELL_WORN_BOOK:
            strncpy(result, "a large and well-worn book", 255);
        break;
        case ST_A_LIBRARY:
            strncpy(result, "a library", 255);
        break;
        case ST_A_LITTLE_OF_THIS_A_LITTLE_OF_THAT:
            strncpy(result, "A little of this, a little of that", 255);
        break;
        case ST_A_MANGO:
            strncpy(result, "a mango", 255);
        break;
        case ST_A_MECHANICAL_ROOM:
            strncpy(result, "a mechanical room", 255);
        break;
        case ST_A_MUSIC_ROOM:
            strncpy(result, "a music room", 255);
        break;
        case ST_A_MYSTERIOUS_DUNGEON:
            strncpy(result, "a mysterious dungeon", 255);
        break;
        case ST_A_NECTARINE:
            strncpy(result, "a nectarine", 255);
        break;
        case ST_A_PARLOR:
            strncpy(result, "a parlor", 255);
        break;
        case ST_A_PARTRIDGE:
            strncpy(result, "a partridge", 255);
        break;
        case ST_A_PEACEFUL_FOREST:
            strncpy(result, "a peaceful forest", 255);
        break;
        case ST_A_PEACH:
            strncpy(result, "a peach", 255);
        break;
        case ST_A_PEAR:
            strncpy(result, "a pear", 255);
        break;
        case ST_A_PEW:
            strncpy(result, "a pew", 255);
        break;
        case ST_A_PILE_OF_RUBBLE:
            strncpy(result, "a pile of rubble", 255);
        break;
        case ST_A_PIT:
            strncpy(result, "a pit", 255);
        break;
        case ST_A_POOL_OF_WATER:
            strncpy(result, "a pool of water", 255);
        break;
        case ST_A_REUBEN:
            strncpy(result, "a reuben", 255);
        break;
        case ST_A_ROCKY_PEAK:
            strncpy(result, "a rocky peak", 255);
        break;
        case ST_A_ROOM_WITH_A_DIAS:
            strncpy(result, "a room with a dias", 255);
        break;
        case ST_A_ROOM_WITH_MURALS:
            strncpy(result, "a room with murals", 255);
        break;
        case ST_A_SHAL_VILLAGE:
            strncpy(result, "a Shal village", 255);
        break;
        case ST_A_SMALL_ISLAND_IN_THE_OCEAN:
            strncpy(result, "a small island in the Ocean", 255);
        break;
        case ST_A_STAINED_GLASS_WINDOW:
            strncpy(result, "a stained glass window", 255);
        break;
        case ST_A_STAIRWELL_LEADING_DOWN:
            strncpy(result, "a stairwell leading down", 255);
        break;
        case ST_A_STAIRWELL_LEADING_UP:
            strncpy(result, "a stairwell leading up", 255);
        break;
        case ST_A_STATUE:
            strncpy(result, "a statue", 255);
        break;
        case ST_A_STONE_WALL:
            strncpy(result, "a stone wall", 255);
        break;
        case ST_A_STOREROOM:
            strncpy(result, "a storeroom", 255);
        break;
        case ST_A_STREAM:
            strncpy(result, "a stream", 255);
        break;
        case ST_A_SYSTEM_OF_CAVERNS:
            strncpy(result, "a system of caverns", 255);
        break;
        case ST_A_TABLE:
            strncpy(result, "a table", 255);
        break;
        case ST_A_TABLE_OF_PRAYER_CANDLES:
            strncpy(result, "a table of prayer candles", 255);
        break;
        case ST_A_TANGERINE:
            strncpy(result, "a tangerine", 255);
        break;
        case ST_A_TAVERN:
            strncpy(result, "a tavern", 255);
        break;
        case ST_A_TORCH:
            strncpy(result, "a torch", 255);
        break;
        case ST_A_TREASURY:
            strncpy(result, "a treasury", 255);
        break;
        case ST_A_TUNA_MELT:
            strncpy(result, "a tuna melt", 255);
        break;
        case ST_A_TWISTY_PASSAGEWAY:
            strncpy(result, "a twisty passageway", 255);
        break;
        case ST_A_VAST_MANSION:
            strncpy(result, "a vast mansion", 255);
        break;
        case ST_A_VERDANT_FOREST:
            strncpy(result, "a verdant forest", 255);
        break;
        case ST_A_WINDOW:
            strncpy(result, "a window", 255);
        break;
        case ST_A_WOODEN_WALL:
            strncpy(result, "a wooden wall", 255);
        break;
        case ST_ALE_JEC:
            strncpy(result, "ale (Jec)", 255);
        break;
        case ST_ALE_SHAL:
            strncpy(result, "ale (Shal)", 255);
        break;
        case ST_ALE_TUZ:
            strncpy(result, "ale (Tuz)", 255);
        break;
        case ST_AN_ALTAR:
            strncpy(result, "an altar", 255);
        break;
        case ST_AN_APPLE:
            strncpy(result, "an apple", 255);
        break;
        case ST_AN_ARMORY:
            strncpy(result, "an armory", 255);
        break;
        case ST_AN_ART_GALLERY:
            strncpy(result, "an art gallery", 255);
        break;
        case ST_AN_ART_STUDIO:
            strncpy(result, "an art studio", 255);
        break;
        case ST_AN_OPEN_DOOR:
            strncpy(result, "an open door", 255);
        break;
        case ST_AN_ORANGE:
            strncpy(result, "an orange", 255);
        break;
        case ST_AN_URVANOVESTILLI_CITY:
            strncpy(result, "an Urvanovestilli city", 255);
        break;
        case ST_ANKLE_BRACELET:
            strncpy(result, "ankle bracelet", 255);
        break;
        case ST_ANTIPASTA:
            strncpy(result, "antipasta", 255);
        break;
        case ST_APPLE:
            strncpy(result, "apple", 255);
        break;
        case ST_APPLE_CIDER_SHAL:
            strncpy(result, "apple cider (Shal)", 255);
        break;
        case ST_APPLE_CIDER_URVANOVESTILLI:
            strncpy(result, "apple cider (Urvanovestilli)", 255);
        break;
        case ST_APPLE_CIDER_YEDIDIA:
            strncpy(result, "apple cider (Yedidia)", 255);
        break;
        case ST_APPLE_JUICE:
            strncpy(result, "apple juice", 255);
        break;
        case ST_APPLE_WINE_YEDIDIA:
            strncpy(result, "apple wine (Yedidia)", 255);
        break;
        case ST_ARMOR_FOR_EVERYONE:
            strncpy(result, "Armor for everyone", 255);
        break;
        case ST_ARMOR_OF_CALIPER_FOR_SERIOUS_ADVENTURERS:
            strncpy(result, "Armor of caliper for serious adventurers", 255);
        break;
        case ST_BACON:
            strncpy(result, "bacon", 255);
        break;
        case ST_BEAN_SALAD:
            strncpy(result, "bean salad", 255);
        break;
        case ST_BEANS:
            strncpy(result, "beans", 255);
        break;
        case ST_BEAR_CURRY:
            strncpy(result, "bear curry", 255);
        break;
        case ST_BEAR_JERKY:
            strncpy(result, "bear jerky", 255);
        break;
        case ST_BEEF_BARLEY_SOUP:
            strncpy(result, "beef barley soup", 255);
        break;
        case ST_BEEF_BARLEY_STEW:
            strncpy(result, "beef barley stew", 255);
        break;
        case ST_BEEF_CURRY:
            strncpy(result, "beef curry", 255);
        break;
        case ST_BEEF_JERKY:
            strncpy(result, "beef jerky", 255);
        break;
        case ST_BEEF_NOODLE_SOUP:
            strncpy(result, "beef noodle soup", 255);
        break;
        case ST_BEEF_STEW:
            strncpy(result, "beef stew", 255);
        break;
        case ST_BERRY_TEA:
            strncpy(result, "berry tea", 255);
        break;
        case ST_BISCUITS:
            strncpy(result, "biscuits", 255);
        break;
        case ST_BLUE_CHEESE:
            strncpy(result, "blue cheese", 255);
        break;
        case ST_BLUE_LEATHER_BOUND_BOOK:
            strncpy(result, "blue, leatherbound book", 255);
        break;
        case ST_BLUEBERRY_WINE_YEDIDIA:
            strncpy(result, "blueberry wine (Yedidia)", 255);
        break;
        case ST_BOOK_WITH_RAINBOW_CLOTH_COVER:
            strncpy(result, "book with rainbow cloth cover", 255);
        break;
        case ST_BOOKS_OF_CALIPER_FOR_SERIOUS_STUDENTS:
            strncpy(result, "Books of caliper for serious students", 255);
        break;
        case ST_BRAISED_CABBAGE:
            strncpy(result, "braised cabbage", 255);
        break;
        case ST_BRANDY_URVANOVESTILLI:
            strncpy(result, "brandy (Urvanovestilli)", 255);
        break;
        case ST_BREAD:
            strncpy(result, "bread", 255);
        break;
        case ST_BREAD_AND_CHUTNEY:
            strncpy(result, "bread and chutney", 255);
        break;
        case ST_BREADED_RABBIT:
            strncpy(result, "breaded rabbit", 255);
        break;
        case ST_CAMEMBERT:
            strncpy(result, "camembert", 255);
        break;
        case ST_CAPPUCINO_COFFEE:
            strncpy(result, "cappucino coffee", 255);
        break;
        case ST_CAVIAR:
            strncpy(result, "caviar", 255);
        break;
        case ST_CHEESE_MEDLEY:
            strncpy(result, "cheese medley", 255);
        break;
        case ST_CHICKEN:
            strncpy(result, "chicken", 255);
        break;
        case ST_CHICKEN_CACCIATORE:
            strncpy(result, "chicken cacciatore", 255);
        break;
        case ST_CHICKEN_GUMBO:
            strncpy(result, "chicken gumbo", 255);
        break;
        case ST_CHOCOLATE:
            strncpy(result, "chocolate", 255);
        break;
        case ST_CIOPPINO:
            strncpy(result, "cioppino", 255);
        break;
        case ST_CIRCLE_OF_FRIENDS:
            strncpy(result, "Circle of Friends", 255);
        break;
        case ST_CLOCKWORK_DEVICES_OF_CALIPER:
            strncpy(result, "Clockwork devices of caliper", 255);
        break;
        case ST_COFISA_TEA:
            strncpy(result, "cofisa tea", 255);
        break;
        case ST_COME_AND_EAT:
            strncpy(result, "Come and eat.", 255);
        break;
        case ST_COME_ONE_COME_ALL:
            strncpy(result, "Come one, come all!", 255);
        break;
        case ST_COOL_MOCHA_COFFEE:
            strncpy(result, "cool mocha coffee", 255);
        break;
        case ST_CORNED_BEEF_AND_CABBAGE:
            strncpy(result, "corned beef and cabbage", 255);
        break;
        case ST_CRAB:
            strncpy(result, "crab", 255);
        break;
        case ST_CRAB_SALAD:
            strncpy(result, "crab salad", 255);
        break;
        case ST_CRAM:
            strncpy(result, "cram", 255);
        break;
        case ST_CRYONA:
            strncpy(result, "Cryona", 255);
        break;
        case ST_CURED_APRICOTS:
            strncpy(result, "cured apricots", 255);
        break;
        case ST_DEEP_SALTY_WATER:
            strncpy(result, "deep, salty water", 255);
        break;
        case ST_DIAMOND:
            strncpy(result, "diamond", 255);
        break;
        case ST_DICED_POTATOES:
            strncpy(result, "diced potatoes", 255);
        break;
        case ST_DRAGON_STEAK:
            strncpy(result, "dragon steak", 255);
        break;
        case ST_DRIED_BERRIES:
            strncpy(result, "dried berries", 255);
        break;
        case ST_DRIED_FISH:
            strncpy(result, "dried fish", 255);
        break;
        case ST_DRIED_PEACHES:
            strncpy(result, "dried peaches", 255);
        break;
        case ST_EMERALD:
            strncpy(result, "emerald", 255);
        break;
        case ST_ENTER_IN_SILENCE:
            strncpy(result, "Enter in silence.", 255);
        break;
        case ST_EQUIPMENT_FOR_ADVENTURERS:
            strncpy(result, "Equipment for adventurers", 255);
        break;
        case ST_EQUIPMENT_OF_CALIPER_FOR_SERIOUS_ADVENTURERS:
            strncpy(result, "Equipment of caliper for serious adventurers", 255);
        break;
        case ST_ESCARGOT:
            strncpy(result, "escargot", 255);
        break;
        case ST_ESPRESSO_COFFEE:
            strncpy(result, "espresso coffee", 255);
        break;
        case ST_EXTRA_STOUT_TUZ:
            strncpy(result, "extra stout (Tuz)", 255);
        break;
        case ST_FETTUCCINE_ALFREDO:
            strncpy(result, "fettucine alfredo", 255);
        break;
        case ST_FIGS:
            strncpy(result, "figs", 255);
        break;
        case ST_FINELY_CRAFTED_SILVER_RING:
            strncpy(result, "finely crafted silver ring", 255);
        break;
        case ST_FISH_CURRY:
            strncpy(result, "fish curry", 255);
        break;
        case ST_FISH_HEAD_CURRY:
            strncpy(result, "fish head curry", 255);
        break;
        case ST_FLARISTIMMO:
            strncpy(result, "Flaristimmo", 255);
        break;
        case ST_FRIED_CLAMS:
            strncpy(result, "fried clams", 255);
        break;
        case ST_FRIED_RICE:
            strncpy(result, "fried rice", 255);
        break;
        case ST_FRIENDLY_PETS_SOLD_HERE:
            strncpy(result, "Friendly pets sold here", 255);
        break;
        case ST_FRITTATA:
            strncpy(result, "frittata", 255);
        break;
        case ST_FRUIT_SALAD:
            strncpy(result, "fruit salad", 255);
        break;
        case ST_GIN_URVANOVESTILLI:
            strncpy(result, "gin (Urvanovestilli)", 255);
        break;
        case ST_GINGER_BEER:
            strncpy(result, "ginger beer", 255);
        break;
        case ST_GOAT_CHEESE:
            strncpy(result, "goat cheese", 255);
        break;
        case ST_GOAT_CURRY:
            strncpy(result, "goat curry", 255);
        break;
        case ST_GOAT_KID:
            strncpy(result, "goat kid", 255);
        break;
        case ST_GOAT_MILK:
            strncpy(result, "goat milk", 255);
        break;
        case ST_GOLD_RING_WITH_A_LARGE_EMERALD:
            strncpy(result, "gold ring, with a large emerald", 255);
        break;
        case ST_GOLDEN_BROOCH:
            strncpy(result, "golden brooch", 255);
        break;
        case ST_GRAPES:
            strncpy(result, "grapes", 255);
        break;
        case ST_GREEN_WINE_URVANOVESTILLI_MISTRELLI:
            strncpy(result, "green wine (Urvanovestilli: Mistrelli)", 255);
        break;
        case ST_GROG_TUZ:
            strncpy(result, "grog (Tuz)", 255);
        break;
        case ST_GUAVA:
            strncpy(result, "guava", 255);
        break;
        case ST_GUAVA_CIDER_YEDIDIA:
            strncpy(result, "guava cider (Yedidia)", 255);
        break;
        case ST_GUAVA_PUREE:
            strncpy(result, "guava puree", 255);
        break;
        case ST_GUAVA_WINE_YEDIDIA:
            strncpy(result, "guava wine (Yedidia)", 255);
        break;
        case ST_HELSRIANA_TEA:
            strncpy(result, "helsriana tea", 255);
        break;
        case ST_HELSRIANA_TEA_SPICED:
            strncpy(result, "helsriana tea (spiced)", 255);
        break;
        case ST_HERBAL_SOUP:
            strncpy(result, "herbal soup", 255);
        break;
        case ST_HOT_TODDY_URVANOVESTILLI:
            strncpy(result, "hot toddy (Urvanovestilli)", 255);
        break;
        case ST_HOUSE_RED_WINE:
            strncpy(result, "house red wine", 255);
        break;
        case ST_HOUSE_WHITE_WINE:
            strncpy(result, "house white wine", 255);
        break;
        case ST_ILLUMINATED_MANUSCRIPT:
            strncpy(result, "illuminated manuscript", 255);
        break;
        case ST_IVORY_BRACELET:
            strncpy(result, "ivory bracelet", 255);
        break;
        case ST_JERKY:
            strncpy(result, "jerky", 255);
        break;
        case ST_JERKY_CHEESE:
            strncpy(result, "jerky cheese", 255);
        break;
        case ST_KHOOR_TUZ:
            strncpy(result, "khoor (Tuz)", 255);
        break;
        case ST_KIWI_JUICE:
            strncpy(result, "kiwi juice", 255);
        break;
        case ST_KIWI_WINE_YEDIDIA:
            strncpy(result, "kiwi wine (Yedidia)", 255);
        break;
        case ST_KONSILA_TEA:
            strncpy(result, "konsila tea", 255);
        break;
        case ST_LAGER_JEC:
            strncpy(result, "lager (Jec)", 255);
        break;
        case ST_LAGER_URVANOVESTILLI:
            strncpy(result, "lager (Urvanovestilli)", 255);
        break;
        case ST_LAGER_YEDIDIA:
            strncpy(result, "lager (Yedidia)", 255);
        break;
        case ST_LAPIS_LAZULI:
            strncpy(result, "lapis lazuli", 255);
        break;
        case ST_LASAGNA:
            strncpy(result, "lasagna", 255);
        break;
        case ST_LEATHERBOUND_BIBLE:
            strncpy(result, "leatherbound Bible", 255);
        break;
        case ST_LEEK_SOUP:
            strncpy(result, "leek soup", 255);
        break;
        case ST_LEMON_TEA:
            strncpy(result, "lemon tea", 255);
        break;
        case ST_LEMON_WINE_YEDIDIA:
            strncpy(result, "lemon wine (Yedidia)", 255);
        break;
        case ST_LENTIL_SOUP:
            strncpy(result, "lentil soup", 255);
        break;
        case ST_LETTUCE_SALAD:
            strncpy(result, "lettuce salad", 255);
        break;
        case ST_LISS:
            strncpy(result, "Liss", 255);
        break;
        case ST_LOBSTER:
            strncpy(result, "lobster", 255);
        break;
        case ST_MANGO_CURRY:
            strncpy(result, "mango curry", 255);
        break;
        case ST_MAPLE_SYRUP_WINE_YEDIDIA:
            strncpy(result, "maple syrup wine (Yedidia)", 255);
        break;
        case ST_MEAD_JEC:
            strncpy(result, "mead (Jec)", 255);
        break;
        case ST_MEAD_SHAL:
            strncpy(result, "mead (Shal)", 255);
        break;
        case ST_MEAD_URVANOVESTILLI:
            strncpy(result, "mead (Urvanovestilli)", 255);
        break;
        case ST_MEAD_YEDIDIA:
            strncpy(result, "mead (Yedidia)", 255);
        break;
        case ST_MEAT_AND_POTATOES:
            strncpy(result, "meat and potatoes", 255);
        break;
        case ST_MECHANICAL_EQUIPMENT:
            strncpy(result, "mechanical equipment", 255);
        break;
        case ST_MEDICAL_HOSPICE_FOR_THE_SICK_AND_WOUNDED:
            strncpy(result, "Medical hospice for the sick and wounded", 255);
        break;
        case ST_MILK:
            strncpy(result, "milk", 255);
        break;
        case ST_MINESTRONE:
            strncpy(result, "minestrone", 255);
        break;
        case ST_MINT_ESPRESSO_COFFEE:
            strncpy(result, "mint espresso coffee", 255);
        break;
        case ST_MINT_TEA:
            strncpy(result, "mint tea", 255);
        break;
        case ST_MISCELLANEOUS_EQUIPMENT_FOR_ADVENTURERS:
            strncpy(result, "Miscellaneous equipment for adventurers", 255);
        break;
        case ST_MOCHA_COFFEE:
            strncpy(result, "mocha coffee", 255);
        break;
        case ST_MOSTACCIOLI:
            strncpy(result, "mostaccioli", 255);
        break;
        case ST_MUTTON:
            strncpy(result, "mutton", 255);
        break;
        case ST_MUTTON_CURRY:
            strncpy(result, "mutton curry", 255);
        break;
        case ST_NECTARINE_WINE_YEDIDIA:
            strncpy(result, "nectarine wine (Yedidia)", 255);
        break;
        case ST_NEVER_NEVER_LAND:
            strncpy(result, "Never, Never Land", 255);
        break;
        case ST_OATMEAL_STOUT_TUZ:
            strncpy(result, "oatmeal stout (Tuz)", 255);
        break;
        case ST_OLD_ROTTED_TOME:
            strncpy(result, "old, rotted tome", 255);
        break;
        case ST_ORANGE:
            strncpy(result, "orange", 255);
        break;
        case ST_ORANGE_JUICE:
            strncpy(result, "orange juice", 255);
        break;
        case ST_ORANGE_TANGERINE_NECTARINE_SALAD:
            strncpy(result, "orange-tangerine-nectarine salad", 255);
        break;
        case ST_ORANGE_WINE_YEDIDIA:
            strncpy(result, "orange wine (Yedidia)", 255);
        break;
        case ST_OUTSIDE_A_JEC_TOWN:
            strncpy(result, "outside a Jec town", 255);
        break;
        case ST_OUTSIDE_A_PEACEFUL_SHAL_VILLAGE:
            strncpy(result, "outside a peaceful Shal village", 255);
        break;
        case ST_OUTSIDE_A_POOL_OF_WATER:
            strncpy(result, "outside a pool of water", 255);
        break;
        case ST_OUTSIDE_A_SMALL_ISLAND:
            strncpy(result, "outside a small island", 255);
        break;
        case ST_OUTSIDE_A_SMALL_TUZ_VILLAGE:
            strncpy(result, "outside a small Tuz village", 255);
        break;
        case ST_OUTSIDE_A_YEDIDIA_VILLAGE:
            strncpy(result, "outside a Yedidia village", 255);
        break;
        case ST_OUTSIDE_AN_URVANOVESTILLI_CITY:
            strncpy(result, "outside an Urvanovestilli city", 255);
        break;
        case ST_OUTSIDE_THE_MOUTH_OF_A_CAVERN:
            strncpy(result, "outside the mouth of a cavern", 255);
        break;
        case ST_PAIR_OF_RUBY_EARRINGS:
            strncpy(result, "pair of ruby earrings", 255);
        break;
        case ST_PEACH:
            strncpy(result, "peach", 255);
        break;
        case ST_PEACH_PIE:
            strncpy(result, "peach pie", 255);
        break;
        case ST_PEACH_WINE_YEDIDIA:
            strncpy(result, "peach wine (Yedidia)", 255);
        break;
        case ST_PEAR:
            strncpy(result, "pear", 255);
        break;
        case ST_PEAR_CIDER_SHAL:
            strncpy(result, "pear cider (Shal)", 255);
        break;
        case ST_PEAR_CIDER_URVANOVESTILLI:
            strncpy(result, "pear cider (Urvanovestilli)", 255);
        break;
        case ST_PEAR_CIDER_YEDIDIA:
            strncpy(result, "pear cider (Yedidia)", 255);
        break;
        case ST_PEAR_JUICE:
            strncpy(result, "pear juice", 255);
        break;
        case ST_PEAR_LIQUEUR_URVANOVESTILLI:
            strncpy(result, "pear liqueur (Urvanovestilli)", 255);
        break;
        case ST_PEAR_WINE_YEDIDIA:
            strncpy(result, "pear wine (Yedidia)", 255);
        break;
        case ST_PEAR_SAUCE_WITH_RAISINS:
            strncpy(result, "pear sauce with raisins", 255);
        break;
        case ST_PEARS:
            strncpy(result, "pears", 255);
        break;
        case ST_PEELED_APPLES:
            strncpy(result, "peeled apples", 255);
        break;
        case ST_PEPPER_CHEESE:
            strncpy(result, "pepper cheese", 255);
        break;
        case ST_PINEAPPLE:
            strncpy(result, "pineapple", 255);
        break;
        case ST_PIPE_ORGAN:
            strncpy(result, "pipe organ", 255);
        break;
        case ST_PLUM_PIE:
            strncpy(result, "plum pie", 255);
        break;
        case ST_PLUMS:
            strncpy(result, "plums", 255);
        break;
        case ST_PORK_SIRLOIN:
            strncpy(result, "pork sirloin", 255);
        break;
        case ST_PORTER_TUZ:
            strncpy(result, "porter (Tuz)", 255);
        break;
        case ST_PORTER_URVANOVESTILLI:
            strncpy(result, "porter (Urvanovestilli)", 255);
        break;
        case ST_PORTER_YEDIDIA:
            strncpy(result, "porter (Yedidia)", 255);
        break;
        case ST_PORTO_URVANOVESTILLI:
            strncpy(result, "Porto (Urvanovestilli)", 255);
        break;
        case ST_POTATOES:
            strncpy(result, "potatoes", 255);
        break;
        case ST_PROVIDING_FINE_HORSES_TO_EVERY_CUSTOMER:
            strncpy(result, "Providing fine horses to every customer", 255);
        break;
        case ST_RAISINS:
            strncpy(result, "raisins", 255);
        break;
        case ST_RASPBERRY_WINE_YEDIDIA:
            strncpy(result, "raspberry wine (Yedidia)", 255);
        break;
        case ST_RAVIOLI:
            strncpy(result, "ravioli", 255);
        break;
        case ST_RED_WINE:
            strncpy(result, "red wine", 255);
        break;
        case ST_RED_WINE_JEC_HISH:
            strncpy(result, "red wine (Jec: Hish)", 255);
        break;
        case ST_RED_WINE_JEC_HOS:
            strncpy(result, "red wine (Jec: Hos)", 255);
        break;
        case ST_RED_WINE_JEC_KANS:
            strncpy(result, "red wine (Jec: Kans)", 255);
        break;
        case ST_RED_WINE_JEC_LUT:
            strncpy(result, "red wine (Jec: Lut)", 255);
        break;
        case ST_RED_WINE_JEC_MILN:
            strncpy(result, "red wine (Jec: Miln)", 255);
        break;
        case ST_RED_WINE_JEC_NUV:
            strncpy(result, "red wine (Jec: Nuv)", 255);
        break;
        case ST_RED_WINE_JEC_TOL:
            strncpy(result, "red wine (Jec: Tol)", 255);
        break;
        case ST_RED_WINE_JEC_VERN:
            strncpy(result, "red wine (Jec: Vern", 255);
        break;
        case ST_RED_WINE_SHAL_HESRI:
            strncpy(result, "red wine (Shal: Hesri)", 255);
        break;
        case ST_RED_WINE_SHAL_INGSA:
            strncpy(result, "red wine (Shal: Ingsa)", 255);
        break;
        case ST_RED_WINE_SHAL_KASSILLA:
            strncpy(result, "red wine (Shal: Kassilla)", 255);
        break;
        case ST_RED_WINE_SHAL_LITRI:
            strncpy(result, "red wine (Shal: Litri)", 255);
        break;
        case ST_RED_WINE_SHAL_MAC_68kEP:
            strncpy(result, "red wine (Shal: Macep)", 255);
        break;
        case ST_RED_WINE_SHAL_NOLDI:
            strncpy(result, "red wine (Shal: Noldi)", 255);
        break;
        case ST_RED_WINE_SHAL_SALN:
            strncpy(result, "red wine (Shal: Saln)", 255);
        break;
        case ST_RED_WINE_SHAL_SIF:
            strncpy(result, "red wine (Shal: Sif)", 255);
        break;
        case ST_RED_WINE_URVANOVESTILLI_CANSOMILTRAMA:
            strncpy(result, "red wine (Urvanovestilli: Cansomiltrama)", 255);
        break;
        case ST_RED_WINE_URVANOVESTILLI_CAPITELLO:
            strncpy(result, "red wine (Urvanovestilli: Capitello)", 255);
        break;
        case ST_RED_WINE_URVANOVESTILLI_ELHANNADAN:
            strncpy(result, "red wine (Urvanovestilli: Elhannadan)", 255);
        break;
        case ST_RED_WINE_URVANOVESTILLI_ELIRE:
            strncpy(result, "red wine (Urvanovestilli: Elire)", 255);
        break;
        case ST_RED_WINE_URVANOVESTILLI_ELMIRTRA:
            strncpy(result, "red wine (Urvanovestilli: Elmirtra)", 255);
        break;
        case ST_RED_WINE_URVANOVESTILLI_KILNATRONA:
            strncpy(result, "red wine (Urvanovestilli: Kilnatrona)", 255);
        break;
        case ST_RED_WINE_URVANOVESTILLI_MISTRELLI:
            strncpy(result, "red wine (Urvanovestilli: Mistrelli)", 255);
        break;
        case ST_RED_WINE_URVANOVESTILLI_SANDRELLA:
            strncpy(result, "red wine (Urvanovestilli: Sandrella)", 255);
        break;
        case ST_RED_WINE_URVANOVESTILLI_STANDRILNATRELLA:
            strncpy(result, "red wine (Urvanovestilli: Standrilnatrella)", 255);
        break;
        case ST_RED_WINE_URVANOVESTILLI_TALMINDATRII:
            strncpy(result, "red wine (Urvanovestilli: Talmindatrii)", 255);
        break;
        case ST_RED_WINE_YEDIDIA_DOSSE:
            strncpy(result, "red wine (Yedidia: Dosse)", 255);
        break;
        case ST_RED_WINE_YEDIDIA_EHOLINA:
            strncpy(result, "red wine (Yedidia: Eholina)", 255);
        break;
        case ST_RED_WINE_YEDIDIA_FILTRI:
            strncpy(result, "red wine (Yedidia: Filtri)", 255);
        break;
        case ST_RED_WINE_YEDIDIA_FISRATIL:
            strncpy(result, "red wine (Yedidia: Fisratil)", 255);
        break;
        case ST_RED_WINE_YEDIDIA_FISSK:
            strncpy(result, "red wine (Yedidia: Fissk)", 255);
        break;
        case ST_RED_WINE_YEDIDIA_SALINA:
            strncpy(result, "red wine (Yedidia: Salina)", 255);
        break;
        case ST_RED_WINE_YEDIDIA_SANLI:
            strncpy(result, "red wine (Yedidia: Sanli)", 255);
        break;
        case ST_RED_WINE_YEDIDIA_SILNA:
            strncpy(result, "red wine (Yedidia: Silna)", 255);
        break;
        case ST_RED_WINE_YEDIDIA_VASLI:
            strncpy(result, "red wine (Yedidia: Vasli)", 255);
        break;
        case ST_RHOG:
            strncpy(result, "Rhog", 255);
        break;
        case ST_RICE:
            strncpy(result, "rice", 255);
        break;
        case ST_RICE_WITH_TOMATOES:
            strncpy(result, "rice with tomatoes", 255);
        break;
        case ST_ROAST_APPLE:
            strncpy(result, "roast apple", 255);
        break;
        case ST_ROAST_BOAR:
            strncpy(result, "roast boar", 255);
        break;
        case ST_ROAST_FISH:
            strncpy(result, "roast fish", 255);
        break;
        case ST_ROAST_PEANUTS:
            strncpy(result, "roast peanuts", 255);
        break;
        case ST_ROAST_RABBIT:
            strncpy(result, "roast rabbit", 255);
        break;
        case ST_ROAST_VENISON:
            strncpy(result, "roast venison", 255);
        break;
        case ST_ROOT_BEER:
            strncpy(result, "root beer", 255);
        break;
        case ST_ROSE_WINE_URVANOVESTILLI_ELIRE:
            strncpy(result, "rose wine (Urvanovestilli: Elire)", 255);
        break;
        case ST_ROSE_WINE_YEDIDIA_DOSSE:
            strncpy(result, "rose wine (Yedidia: Dosse)", 255);
        break;
        case ST_ROSE_WINE_YEDIDIA_EHOLINA:
            strncpy(result, "rose wine (Yedidia: Eholina)", 255);
        break;
        case ST_ROSE_WINE_YEDIDIA_FILTRI:
            strncpy(result, "rose wine (Yedidia: Filtri)", 255);
        break;
        case ST_ROSE_WINE_YEDIDIA_FISRATIL:
            strncpy(result, "rose wine (Yedidia: Fisratil)", 255);
        break;
        case ST_ROSE_WINE_YEDIDIA_FISSK:
            strncpy(result, "rose wine (Yedidia: Fissk)", 255);
        break;
        case ST_ROSE_WINE_YEDIDIA_SALINA:
            strncpy(result, "rose wine (Yedidia: Salina)", 255);
        break;
        case ST_ROSE_WINE_YEDIDIA_SANLI:
            strncpy(result, "rose wine (Yedidia: Sanli)", 255);
        break;
        case ST_ROSE_WINE_YEDIDIA_SILNA:
            strncpy(result, "rose wine (Yedidia: Silna)", 255);
        break;
        case ST_ROSE_WINE_YEDIDIA_TIRNA:
            strncpy(result, "rose wine (Yedidia: Tirna)", 255);
        break;
        case ST_ROSE_WINE_YEDIDIA_VASLI:
            strncpy(result, "rose wine (Yedidia: Vasli)", 255);
        break;
        case ST_RUBY:
            strncpy(result, "ruby", 255);
        break;
        case ST_RUM_CAKES:
            strncpy(result, "rum cakes", 255);
        break;
        case ST_RUM_TUZ:
            strncpy(result, "rum (Tuz)", 255);
        break;
        case ST_RUM_URVANOVESTILLI:
            strncpy(result, "rum (Urvanovestilli)", 255);
        break;
        case ST_RYANS_CORNER:
            strncpy(result, "Ryan's Corner", 255);
        break;
        case ST_RYE_BREAD:
            strncpy(result, "rye bread", 255);
        break;
        case ST_SALAMI:
            strncpy(result, "salami", 255);
        break;
        case ST_SHARING_NATURES_SECRETS_FOR_GENERATIONS:
            strncpy(result, "Sharing nature's secrets for generations", 255);
        break;
        case ST_SHARP_CHEDDAR:
            strncpy(result, "sharp cheddar", 255);
        break;
        case ST_SHELVES:
            strncpy(result, "shelves", 255);
        break;
        case ST_SHERRY_URVANOVESTILLI:
            strncpy(result, "sherry (Urvanovestilli)", 255);
        break;
        case ST_SMALL_BLACK_LEATHER_BOOK:
            strncpy(result, "small black leather book", 255);
        break;
        case ST_SMALL_JOURNAL:
            strncpy(result, "small journal", 255);
        break;
        case ST_SMALL_WHITE_BOOK:
            strncpy(result, "small white book", 255);
        break;
        case ST_SMOKED_BEEF:
            strncpy(result, "smoked beef", 255);
        break;
        case ST_SMOKED_BEER_TUZ:
            strncpy(result, "smoked beer (Tuz)", 255);
        break;
        case ST_SOUP:
            strncpy(result, "soup", 255);
        break;
        case ST_SPAGHETTI:
            strncpy(result, "spaghetti", 255);
        break;
        case ST_SPICED_RUM_TUZ:
            strncpy(result, "spiced rum (Tuz)", 255);
        break;
        case ST_SPICED_RUM_URVANOVESTILLI:
            strncpy(result, "spiced rum (Urvanovestilli)", 255);
        break;
        case ST_SPICED_RUM_YEDIDIA:
            strncpy(result, "spiced rum (Yedidia)", 255);
        break;
        case ST_SPICED_WINE_SHAL:
            strncpy(result, "spiced wine (Shal)", 255);
        break;
        case ST_SPICED_WINE_URVANOVESTILLI:
            strncpy(result, "spiced wine (Urvanovestilli)", 255);
        break;
        case ST_SPICED_WINE_YEDIDIA:
            strncpy(result, "spiced wine (Yedidia)", 255);
        break;
        case ST_SPLIT_PEA_SOUP:
            strncpy(result, "split pea soup", 255);
        break;
        case ST_SQUASH:
            strncpy(result, "squash", 255);
        break;
        case ST_STAR_SAPPHIRE:
            strncpy(result, "star sapphire", 255);
        break;
        case ST_STEAK_AND_BISCUITS:
            strncpy(result, "steak and biscuits", 255);
        break;
        case ST_STOUT_TUZ:
            strncpy(result, "stout (Tuz)", 255);
        break;
        case ST_STRAWBERRIES:
            strncpy(result, "strawberries", 255);
        break;
        case ST_STRAWBERRY_PIE:
            strncpy(result, "strawberry pie", 255);
        break;
        case ST_STRAWBERRY_TEA:
            strncpy(result, "strawberry tea", 255);
        break;
        case ST_STRAWBERRY_WINE_YEDIDIA:
            strncpy(result, "strawberry wine (Yedidia)", 255);
        break;
        case ST_SUGAR_CANE:
            strncpy(result, "sugar cane", 255);
        break;
        case ST_SUPPLIES_TO_MEET_YOUR_DAY_TO_DAY_NEEDS:
            strncpy(result, "Supplies to meet your day-to-day needs", 255);
        break;
        case ST_SYLLII:
            strncpy(result, "Syllii", 255);
        break;
        case ST_TALINOR_TEA:
            strncpy(result, "talinor tea", 255);
        break;
        case ST_TEQUILA_TUZ:
            strncpy(result, "tequila (Tuz)", 255);
        break;
        case ST_TEQUILA_URVANOVESTILLI:
            strncpy(result, "tequila (Urvanovestilli)", 255);
        break;
        case ST_TEST:
            strncpy(result, "test", 255);
        break;
        case ST_TEV:
            strncpy(result, "Tev", 255);
        break;
        case ST_THE_ADVENTURERS_GUILD:
            strncpy(result, "The Adventurers' Guild", 255);
        break;
        case ST_THE_BEST_IN_RARE_HERBS:
            strncpy(result, "The best in rare herbs", 255);
        break;
        case ST_THE_BOARS_HEAD:
            strncpy(result, "The Boar's Head", 255);
        break;
        case ST_THE_BOOK_LOVERS_CORNER:
            strncpy(result, "The book lover's corner", 255);
        break;
        case ST_THE_COUNTRYSIDE:
            strncpy(result, "the countryside", 255);
        break;
        case ST_THE_DRAGONS_DEN:
            strncpy(result, "The Dragon's Den", 255);
        break;
        case ST_THE_EAST_RIDGE_MOUNTAINS:
            strncpy(result, "the East Ridge Mountains", 255);
        break;
        case ST_THE_FLOOR:
            strncpy(result, "the floor", 255);
        break;
        case ST_THE_FOG_VALLEY:
            strncpy(result, "the Fog Valley", 255);
        break;
        case ST_THE_FROZEN_GROUND:
            strncpy(result, "the frozen ground", 255);
        break;
        case ST_THE_GRIFFIN:
            strncpy(result, "The Griffin", 255);
        break;
        case ST_THE_GROUND:
            strncpy(result, "the ground", 255);
        break;
        case ST_THE_ICE_PEAKS:
            strncpy(result, "the Ice Peaks", 255);
        break;
        case ST_THE_JEC_TOWN_HISH:
            strncpy(result, "the Jec town Hish", 255);
        break;
        case ST_THE_JEC_TOWN_HOS:
            strncpy(result, "the Jec town Hos", 255);
        break;
        case ST_THE_JEC_TOWN_KANS:
            strncpy(result, "the Jec town Kans", 255);
        break;
        case ST_THE_JEC_TOWN_LUT:
            strncpy(result, "the Jec town Lut", 255);
        break;
        case ST_THE_JEC_TOWN_MILN:
            strncpy(result, "the Jec town Miln", 255);
        break;
        case ST_THE_JEC_TOWN_NUV:
            strncpy(result, "the Jec town Nuv", 255);
        break;
        case ST_THE_JEC_TOWN_TOL:
            strncpy(result, "the Jec town Tol", 255);
        break;
        case ST_THE_JEC_TOWN_VERN:
            strncpy(result, "the Jec town Vern", 255);
        break;
        case ST_THE_KINGS_COURT:
            strncpy(result, "The King's Court", 255);
        break;
        case ST_THE_LION_TAMERS_DEN:
            strncpy(result, "The Lion Tamer's Den", 255);
        break;
        case ST_THE_LIONHEART:
            strncpy(result, "The Lionheart", 255);
        break;
        case ST_THE_MAPMAKERS_SHOP:
            strncpy(result, "The Mapmaker's Shop", 255);
        break;
        case ST_THE_MIDDLE_PLAINS:
            strncpy(result, "the Middle Plains", 255);
        break;
        case ST_THE_MOONLIT_PATH:
            strncpy(result, "The Moonlit Path", 255);
        break;
        case ST_THE_NORTHERN_WASTES:
            strncpy(result, "the Northern Wastes", 255);
        break;
        case ST_THE_OCEAN:
            strncpy(result, "the Ocean", 255);
        break;
        case ST_THE_SAILORS_CRAG:
            strncpy(result, "The Sailor's Crag", 255);
        break;
        case ST_THE_SANDY_GROUND:
            strncpy(result, "the sandy ground", 255);
        break;
        case ST_THE_SHAL_VILLAGE_HESRI:
            strncpy(result, "the Shal village Hesri", 255);
        break;
        case ST_THE_SHAL_VILLAGE_INGSA:
            strncpy(result, "the Shal village Ingsa", 255);
        break;
        case ST_THE_SHAL_VILLAGE_KASSILLA:
            strncpy(result, "the Shal village Kassilla", 255);
        break;
        case ST_THE_SHAL_VILLAGE_LITRI:
            strncpy(result, "the Shal village Litri", 255);
        break;
        case ST_THE_SHAL_VILLAGE_MAC_68kEP:
            strncpy(result, "the Shal village Macep", 255);
        break;
        case ST_THE_SHAL_VILLAGE_NOLDI:
            strncpy(result, "the Shal village Noldi", 255);
        break;
        case ST_THE_SHAL_VILLAGE_SALN:
            strncpy(result, "the Shal village Saln", 255);
        break;
        case ST_THE_SHAL_VILLAGE_SIF:
            strncpy(result, "the Shal village Sif", 255);
        break;
        case ST_THE_SILVER_RING:
            strncpy(result, "The Silver Ring", 255);
        break;
        case ST_THE_SILVERFISH:
            strncpy(result, "The Silverfish", 255);
        break;
        case ST_THE_TINKERERS_GUILD:
            strncpy(result, "The Tinkerer's Guild", 255);
        break;
        case ST_THE_TOMB_OF_A_SAINT:
            strncpy(result, "the tomb of a saint", 255);
        break;
        case ST_THE_TUZ_VILLAGE_DOZ:
            strncpy(result, "the Tuz village Doz", 255);
        break;
        case ST_THE_TUZ_VILLAGE_GHIRTON:
            strncpy(result, "the Tuz village Ghirton", 255);
        break;
        case ST_THE_TUZ_VILLAGE_GORF:
            strncpy(result, "the Tuz village Gorf", 255);
        break;
        case ST_THE_TUZ_VILLAGE_KANDRHI:
            strncpy(result, "the Tuz village Kandrhi", 255);
        break;
        case ST_THE_TUZ_VILLAGE_KORG:
            strncpy(result, "the Tuz village Korg", 255);
        break;
        case ST_THE_TUZ_VILLAGE_KUNDER:
            strncpy(result, "the Tuz village Kunder", 255);
        break;
        case ST_THE_TUZ_VILLAGE_LUZZ:
            strncpy(result, "the Tuz village Luzz", 255);
        break;
        case ST_THE_TUZ_VILLAGE_RASTI:
            strncpy(result, "the Tuz village Rasti", 255);
        break;
        case ST_THE_TUZ_VILLAGE_RHALLTIR:
            strncpy(result, "the Tuz village Rhalltir", 255);
        break;
        case ST_THE_TUZ_VILLAGE_RHAV:
            strncpy(result, "the Tuz village Rhav", 255);
        break;
        case ST_THE_TUZ_VILLAGE_STORNGE:
            strncpy(result, "the Tuz village Stornge", 255);
        break;
        case ST_THE_TUZ_VILLAGE_TUZZNIR:
            strncpy(result, "the Tuz village Tuzznir", 255);
        break;
        case ST_THE_TUZ_VILLAGE_WAZ:
            strncpy(result, "the Tuz village Waz", 255);
        break;
        case ST_THE_TUZ_VILLAGE_ZOLK:
            strncpy(result, "the Tuz village Zolk", 255);
        break;
        case ST_THE_TUZ_VILLAGE_ZUT:
            strncpy(result, "the Tuz village Zut", 255);
        break;
        case ST_THE_TUZ_VILLAGE_BORD:
            strncpy(result, "the Tuz village Bord", 255);
        break;
        case ST_THE_URVANOVESTILLI_CITY_CANSOMILTRAMA:
            strncpy(result, "the Urvanovestilli city Cansomiltrama", 255);
        break;
        case ST_THE_URVANOVESTILLI_CITY_CAPITELLO:
            strncpy(result, "the Urvanovestilli city Capitello", 255);
        break;
        case ST_THE_URVANOVESTILLI_CITY_ELHANNADAN:
            strncpy(result, "the Urvanovestilli city Elhannadan", 255);
        break;
        case ST_THE_URVANOVESTILLI_CITY_ELIRE:
            strncpy(result, "the Urvanovestilli city Elire\'", 255);
        break;
        case ST_THE_URVANOVESTILLI_CITY_ELMIRTRA:
            strncpy(result, "the Urvanovestilli city Elmirtra", 255);
        break;
        case ST_THE_URVANOVESTILLI_CITY_KILNATRONA:
            strncpy(result, "the Urvanovestilli city Kilnatrona", 255);
        break;
        case ST_THE_URVANOVESTILLI_CITY_MISTRELLI:
            strncpy(result, "the Urvanovestilli city Mistrelli", 255);
        break;
        case ST_THE_URVANOVESTILLI_CITY_SANDRELLA:
            strncpy(result, "the Urvanovestilli city Sandrella", 255);
        break;
        case ST_THE_URVANOVESTILLI_CITY_STANDRILNATRELLA:
            strncpy(result, "the Urvanovestilli city Standrilnatrella", 255);
        break;
        case ST_THE_URVANOVESTILLI_CITY_TALMIRNATRII:
            strncpy(result, "the Urvanovestilli city Talmirnatrii", 255);
        break;
        case ST_THE_YEDIDIA_VILLAGE_DOSSE:
            strncpy(result, "the Yedidia village Dosse", 255);
        break;
        case ST_THE_YEDIDIA_VILLAGE_EHOLINA:
            strncpy(result, "the Yedidia village Eholina", 255);
        break;
        case ST_THE_YEDIDIA_VILLAGE_FILTRI:
            strncpy(result, "the Yedidia village Filtri", 255);
        break;
        case ST_THE_YEDIDIA_VILLAGE_FISRATIL:
            strncpy(result, "the Yedidia village Fisratil", 255);
        break;
        case ST_THE_YEDIDIA_VILLAGE_FISSK:
            strncpy(result, "the Yedidia village Fissk", 255);
        break;
        case ST_THE_YEDIDIA_VILLAGE_SALINA:
            strncpy(result, "the Yedidia village Salina", 255);
        break;
        case ST_THE_YEDIDIA_VILLAGE_SANLI:
            strncpy(result, "the Yedidia village Sanli", 255);
        break;
        case ST_THE_YEDIDIA_VILLAGE_SILNA:
            strncpy(result, "the Yedidia village Silna", 255);
        break;
        case ST_THE_YEDIDIA_VILLAGE_TIRNA:
            strncpy(result, "the Yedidia village Tirna", 255);
        break;
        case ST_THE_YEDIDIA_VILLAGE_VASLI:
            strncpy(result, "the Yedidia village Vasli", 255);
        break;
        case ST_THIN_BOOK_WITH_A_DECORATED_SPINE:
            strncpy(result, "thin book with a decorated spine", 255);
        break;
        case ST_TIGERS_EYE:
            strncpy(result, "tiger's eye", 255);
        break;
        case ST_TISANE_TEA:
            strncpy(result, "tisane tea", 255);
        break;
        case ST_TUNA_STEAK:
            strncpy(result, "tuna steak", 255);
        break;
        case ST_TUZ_COFFEE:
            strncpy(result, "Tuz coffee", 255);
        break;
        case ST_UNDERNEATH_A_TREE:
            strncpy(result, "underneath a tree", 255);
        break;
        case ST_VEGETABLE_STEW:
            strncpy(result, "vegetable stew", 255);
        break;
        case ST_VENISON:
            strncpy(result, "venison", 255);
        break;
        case ST_VENISON_JERKY:
            strncpy(result, "venison jerky", 255);
        break;
        case ST_WASSAIL_JEC:
            strncpy(result, "wassail (Jec)", 255);
        break;
        case ST_WASSAIL_SHAL:
            strncpy(result, "wassail (Shal)", 255);
        break;
        case ST_WASSAIL_TUZ:
            strncpy(result, "wassail (Tuz)", 255);
        break;
        case ST_WASSAIL_URVANOVESTILLI:
            strncpy(result, "wassail (Urvanovestilli)", 255);
        break;
        case ST_WASSAIL_YEDIDIA:
            strncpy(result, "wassail (Yedidia)", 255);
        break;
        case ST_WATER:
            strncpy(result, "water", 255);
        break;
        case ST_WE_HELP_MAKE_A_HOUSE_A_HOME:
            strncpy(result, "We help make a house a home", 255);
        break;
        case ST_WE_LOCATE_RARE_AND_HARD_TO_FIND_ITEMS:
            strncpy(result, "We locate rare and hard-to-find items", 255);
        break;
        case ST_WEAPONS_FOR_THE_COMMON_MAN:
            strncpy(result, "Weapons for the common man", 255);
        break;
        case ST_WEAPONS_OF_CALIPER_FOR_SERIOUS_ADVENTURERS:
            strncpy(result, "Weapons of caliper for serious adventurers", 255);
        break;
        case ST_WHEAT_BREAD:
            strncpy(result, "wheat bread", 255);
        break;
        case ST_WHISKEY_JEC:
            strncpy(result, "whiskey (Jec)", 255);
        break;
        case ST_WHISKEY_URVANOVESTILLI:
            strncpy(result, "whiskey (Urvanovestilli)", 255);
        break;
        case ST_WHITE_WINE:
            strncpy(result, "white wine", 255);
        break;
        case ST_WHITE_WINE_SHAL_HESRI:
            strncpy(result, "white wine (Shal: Hesri)", 255);
        break;
        case ST_WHITE_WINE_SHAL_INGSA:
            strncpy(result, "white wine (Shal: Ingsa)", 255);
        break;
        case ST_WHITE_WINE_SHAL_KASSILLA:
            strncpy(result, "white wine (Shal: Kassilla)", 255);
        break;
        case ST_WHITE_WINE_SHAL_LITRI:
            strncpy(result, "white wine (Shal: Litri)", 255);
        break;
        case ST_WHITE_WINE_SHAL_MAC_68kEP:
            strncpy(result, "white wine (Shal: Macep)", 255);
        break;
        case ST_WHITE_WINE_SHAL_NOLDI:
            strncpy(result, "white wine (Shal: Noldi)", 255);
        break;
        case ST_WHITE_WINE_SHAL_SALN:
            strncpy(result, "white wine (Shal: Saln)", 255);
        break;
        case ST_WHITE_WINE_SHAL_SIF:
            strncpy(result, "white wine (Shal: Sif)", 255);
        break;
        case ST_WHITE_WINE_URVANOVESTILLI_CANSOMILTRAMA:
            strncpy(result, "white wine (Urvanovestilli: Cansomiltrama)", 255);
        break;
        case ST_WHITE_WINE_URVANOVESTILLI_CAPITELLO:
            strncpy(result, "white wine (Urvanovestilli: Capitello)", 255);
        break;
        case ST_WHITE_WINE_URVANOVESTILLI_ELHANNADAN:
            strncpy(result, "white wine (Urvanovestilli: Elhannadan)", 255);
        break;
        case ST_WHITE_WINE_URVANOVESTILLI_ELIRE:
            strncpy(result, "white wine (Urvanovestilli: Elire)", 255);
        break;
        case ST_WHITE_WINE_URVANOVESTILLI_ELMIRTRA:
            strncpy(result, "white wine (Urvanovestilli: Elmirtra)", 255);
        break;
        case ST_WHITE_WINE_URVANOVESTILLI_KILNATRONA:
            strncpy(result, "white wine (Urvanovestilli: Kilnatrona)", 255);
        break;
        case ST_WHITE_WINE_URVANOVESTILLI_MISTRELLI:
            strncpy(result, "white wine (Urvanovestilli: Mistrelli)", 255);
        break;
        case ST_WHITE_WINE_URVANOVESTILLI_SANDRELLA:
            strncpy(result, "white wine (Urvanovestilli: Sandrella)", 255);
        break;
        case ST_WHITE_WINE_URVANOVESTILLI_STANDRILNATRELLA:
            strncpy(result, "white wine (Urvanovestilli: Standilnatrella)", 255);
        break;
        case ST_WHITE_WINE_URVANOVESTILLI_TALMIRNATRII:
            strncpy(result, "white wine (Urvanovestilli: Talmirnatrii)", 255);
        break;
        case ST_WHITE_WINE_YEDIDIA_DOSSE:
            strncpy(result, "white wine (Yedidia: Dosse)", 255);
        break;
        case ST_WHITE_WINE_YEDIDIA_EHOLINA:
            strncpy(result, "white wine (Yedidia: Eholina)", 255);
        break;
        case ST_WHITE_WINE_YEDIDIA_FILTRI:
            strncpy(result, "white wine (Yedidia: Filtri)", 255);
        break;
        case ST_WHITE_WINE_YEDIDIA_FISRATIL:
            strncpy(result, "white wine (Yedidia: Fisratil)", 255);
        break;
        case ST_WHITE_WINE_YEDIDIA_FISSK:
            strncpy(result, "white wine (Yedidia: Fissk)", 255);
        break;
        case ST_WHITE_WINE_YEDIDIA_SALINA:
            strncpy(result, "white wine (Yedidia: Salina)", 255);
        break;
        case ST_WHITE_WINE_YEDIDIA_SANLI:
            strncpy(result, "white wine (Yedidia: Sanli)", 255);
        break;
        case ST_WHITE_WINE_YEDIDIA_SILNA:
            strncpy(result, "white wine (Yedidia: Silna)", 255);
        break;
        case ST_WHITE_WINE_YEDIDIA_TIRNA:
            strncpy(result, "white wine (Yedidia: Tirna)", 255);
        break;
        case ST_WHITE_WINE_YEDIDIA_VASLI:
            strncpy(result, "white wine (Yedidia: Vasli)", 255);
        break;
        case ST_YAMS:
            strncpy(result, "yams", 255);
        break;
        case ST_YE_OLDE_JEWELLERS_SHOPPE:
            strncpy(result, "Ye olde jeweller's shoppe", 255);
        break;
        case ST_YONA_TEA:
            strncpy(result, "yona tea", 255);
        break;
        case ST_YOU_ASCEND_FROM_A_CRYPT:
            strncpy(result, "You ascend from a crypt.", 255);
        break;
        case ST_YOU_DESCEND_INTO_A_CRYPT:
            strncpy(result, "You descend into a crypt.", 255);
        break;
        case ST_YOU_ENTER_A_CATHEDRAL:
            strncpy(result, "You enter a cathedral.", 255);
        break;
        case ST_YOU_ENTER_A_TAVERN:
            strncpy(result, "You enter a tavern.", 255);
        break;
        case ST_YOU_LEAVE_A_CATHEDRAL:
            strncpy(result, "You leave a cathedral.", 255);
        break;
        case ST_YOU_LEAVE_A_JEC_TOWN:
            strncpy(result, "You leave a Jec town.", 255);
        break;
        case ST_YOU_LEAVE_A_SHAL_VILLAGE:
            strncpy(result, "You leave a Shal village.", 255);
        break;
        case ST_YOU_LEAVE_A_TAVERN:
            strncpy(result, "You leave a tavern.", 255);
        break;
        case ST_YOU_LEAVE_A_TUZ_VILLAGE:
            strncpy(result, "You leave a Tuz village.", 255);
        break;
        case ST_YOU_LEAVE_A_YEDIDIA_VILLAGE:
            strncpy(result, "You leave a Yedidia village.", 255);
        break;
        case ST_YOU_LEAVE_AN_URVANOVESTILLI_CITY:
            strncpy(result, "You leave an Urvanovestilli city.", 255);
        break;
        case ST_YOU_LEAVE_THE_COUNTRYSIDE:
            strncpy(result, "You leave the countryside.", 255);
        break;
        case ST_YOU_RETURN_TO_THE_COUNTRYSIDE:
            strncpy(result, "You return to the countryside.", 255);
        break;
        case ST_YOU_WALK_INTO_A_JEC_TOWN:
            strncpy(result, "You walk into a Jec town.", 255);
        break;
        case ST_YOU_WALK_INTO_A_SHAL_VILLAGE:
            strncpy(result, "You walk into a Shal village.", 255);
        break;
        case ST_YOU_WALK_INTO_A_TUZ_VILLAGE:
            strncpy(result, "You walk into a Tuz village.", 255);
        break;
        case ST_YOU_WALK_INTO_A_YEDIDIA_VILLAGE:
            strncpy(result, "You walk into a Yedidia village.", 255);
        break;
        case ST_YOU_WALK_INTO_AN_URVANOVESTILLI_CITY:
            strncpy(result, "You walk into an Urvanovestilli city.", 255);
        break;
        case ST_YOUR_SOURCE_FOR_CLOCKWORK_DEVICES:
            strncpy(result, "Your source for clockwork devices", 255);
        break;
        default:
#ifdef HAS_SNPRINTF
            snprintf(result, 255, "Error.  Out of range value %ld given to find_string.", string_id);
#else
            sprintf(result, "Error.  Out of range value %ld given to find_string.", string_id);
#endif
            result[255] = '\0';
        break;
        }
    result[255] = '\0';
    }

#ifdef CODE_SEGMENT
#pragma segment UTIL2_C_C
#endif

/* Make creature c1 hostile to creature c2.  */

void make_hostile(struct small_creature *c1, struct small_creature *c2)
    {
    wake_up(c1);
    flag_set(&c1->flags, RUNNING);
    /* If a creature becomes hostile, it obviously stops following.  */
    reset_follow(c1, c2);
    append_creature_to_clist(c2, &c1->hostile);
    flag_reset(&c1->flags, INACTIVE);
    }

long is_on_level(struct small_creature *c, struct level *l)
    {
    struct clist *traverse;
    if (!(l->creatures == NULL))
        for(traverse = l->creatures; (!(traverse == NULL)); traverse =
          traverse->next)
        if (traverse->current != NULL)
            if (c == traverse->current)
                return 1;
    return 0;
    }

void make_follow(struct small_creature *c1, struct small_creature *c2)
    {
    flag_reset(&c1->flags, INACTIVE);
    reset_follow(c1, c2);
    if (c1->follow != NULL)
        {
        free_clist(c1->follow);
        c1->follow = NULL;
        }
    append_creature_to_clist(c2, &c1->follow);
    append_creature_to_clist(c1, &c2->followed_by);
    }

/* If more than one of a creature is usually found, make an appropriate pack */
/* of creatures.  */

long check_addition(struct level *l, long creature_id, long x, long y, long
  creature_count)
    {
    long i, j, local_creature_count;
    struct small_creature *this_creature;
    struct clist *cl, *local_master, *traverse1, *traverse2;
    local_creature_count = creature_count;
    local_master = NULL;
    i = x;
    j = y;
    if (master_creatures[creature_id]->number > 0 && i >= 0 && j >= 0 && i <
      MAX_X && j < MAX_Y)
        {
        if (l->space[x][y].creatures != NULL)
            {
            cl = (struct clist *) calloc(1, sizeof(struct clist));
            cl->me = cl;
            cl->current = l->space[x][y].creatures->current;
            cl->next = NULL;
            local_master = cl;
            }
        else
            {
            cl = NULL;
            local_master = NULL;
            }
        while ((trandom() % (master_creatures[creature_id]->number) > 0) &&
            (i >= 0) && (j >= 0) && (i < MAX_X) && (j < MAX_Y))
            {
            switch(trandom()%4)
                {
                case 0: ++i; break;
                case 1: --i; break;
                case 2: ++j; break;
                case 3: --j; break;
                }
            if ((flag_check(l->space[i][j].flags, AVAILABLE)) &&
                (flag_check(l->space[i][j].flags, CAN_OCCUPY)) &&
                (local_creature_count < MAX_CREATURES_CREATED_WITH_LEVEL))
                {
                this_creature = make_random_creature(creature_id);
                no_hostile_add_creature(l, this_creature, i, j);
                flag_set(&this_creature->flags, INACTIVE);
                cl = (struct clist *) calloc(1, sizeof(struct clist));
                cl->me = cl;
                cl->current = this_creature;
                cl->next = local_master;
                local_master = cl;
                ++local_creature_count;
                }
            }
        if (local_master != NULL)
            for(traverse1 = local_master; (!(traverse1 == NULL)); traverse1 =
              traverse1->next)
        if (traverse1->current != NULL)
                for(traverse2 = local_master; (!(traverse2 == NULL)); traverse2
                  = traverse2->next)
        if (traverse2->current != NULL)
                    make_follow(traverse1->current, traverse2->current);
        }
    free_clist(local_master);
    return local_creature_count;
    }

void pass_time(long time_units)
    {
    long i;
    for(i=0;i<time_units/MINUTE;++i)
        {
        game_variables->elapsed_units += MINUTE;
        one_minute_check();
        if (((game_variables->elapsed_units / MINUTE) % 60) == 0)
            update_window();
        }
    }

void mist_circle(struct level *l, long x, long y, long radius)
    {
    long i, j;
    for(i=max(0, x - radius); i < min(MAX_X, x + radius + 1); ++i)
        for(j=max(0, y - radius); j < min(MAX_Y, y + radius + 1); ++j)
            if (((x - i) * (x - i) + (y - j) * (y - j)) <= (radius * radius))
                flag_set(&l->space[i][j].flags, S_CLOAKED_BY_MIST);
    }

/* As of 20 Mar 03, the stati hungry [for creatures other than the player],
 * thirsty, tired, fatigued, and passed out are disabled, as being unnecessary
 * irritants. */
void status_add(struct small_creature *c, long status, long increment)
    {
    if (((status == STATUS_FATIGUED) ||
      (status == STATUS_HUNGRY && c != player) ||
      (status == STATUS_PASSED_OUT) ||
      (status == STATUS_THIRSTY) ||
      (status == STATUS_TIRED)) &&
      (increment > 0))
        return;
    if (!(c->extended_creature == NULL))
        {
        c->extended_creature->stati->time[status] += adjustment_info[status].
          time_increment * increment;
        if (flag_check(adjustment_info[status].flags, HAS_MAXIMUM))
            c->extended_creature->stati->time[status] = min(
              c->extended_creature->stati->time[status],
              adjustment_info[status].time_increment *
              adjustment_info[status].max);
        if (flag_check(adjustment_info[status].flags, HAS_MINIMUM))
            c->extended_creature->stati->time[status] = max(
              c->extended_creature->stati->time[status],
              adjustment_info[status].time_increment *
              adjustment_info[status].min);
        calc_ready(c);
        }
    if ((c == player) && (increment > 0))
        status_message(c, status);
    }

void add_permanent_status(struct small_creature *c, long status, long
  increment)
    {
    if (c->extended_creature != NULL)
        {
        c->extended_creature->stati->permanent[status] += increment;
        calc_ready(c);
        }
    }

void correct_xy(void)
    {
    long i, j;
    struct clist *traverse;
    for(i=0;i<MAX_X;++i)
        for(j=0;j<MAX_Y;++j)
            if (current_level->space[i][j].creatures != NULL)
                {
                free_clist(current_level->space[i][j].creatures);
                current_level->space[i][j].creatures = NULL;
                flag_reset(&current_level->space[i][j].flags, OCCUPIED);
                }
    for(traverse = current_level->creatures; (!(traverse == NULL)); traverse =
      traverse->next)
        if (traverse->current != NULL)
        {
        append_creature_to_clist(traverse->current, &current_level->space
          [traverse->current->x][traverse->current->y].creatures);
        flag_set(&current_level->space[traverse->current->x]
          [traverse->current->y].flags, OCCUPIED);
        }
    }

void find_title(struct small_creature *c, char *title)
    {
    if (!(c->name == NULL))
        strncpy(title, c->name->text, 255);
    else if (!(c->extended_creature == NULL))
        strncpy(title, c->extended_creature->title, 255);
    else if ((is_following(c, player)) && (!(flag_check(c->flags, HUMAN))))
#ifdef HAS_SNPRINTF
        snprintf(title, 255, "your %s", master_creatures[c->identity]->species);
#else
        sprintf(title, "your %s", master_creatures[c->identity]->species);
#endif
    else
#ifdef HAS_SNPRINTF
        snprintf(title, 255, "the %s", master_creatures[c->identity]->species);
#else
        sprintf(title, "the %s", master_creatures[c->identity]->species);
#endif
    title[255] = '\0';
    }

/* Destroys the item and returns a list of items that came from it.  Another
function should check if a creature succeeds in cleaning, and should extract
the item.  */

struct ilist *clean(struct small_item *i)
    {
    char item_name[256];
    struct ilist *result;
    struct small_item *curr_item;
    if (i != NULL)
        {
        if (i->identity == MORTAL_REMAINS)
            {
            if (flag_check(master_creatures[i->other]->flags, HUMAN))
                {
                pmsg("That is a person's corpse, not an animal's carcass.");
                result = (struct ilist *) calloc(1, sizeof(struct ilist));
                result->me = result;
                result->current = i;
                result->next = NULL;
                }
            else if (flag_check(i->flags2, NO_CLEAN))
                {
                pmsg("That item has already been cleaned.");
                result = (struct ilist *) calloc(1, sizeof(struct ilist));
                result->me = result;
                result->current = i;
                result->next = NULL;
                }
            else
                {
                pmsg("You clean it...");
                result = (struct ilist *) calloc(1, sizeof(struct ilist));
                result->me = result;
                result->current = generate_item(current_level, FOOD);
                result->current->weight = i->weight/2; /* No skeleton, etc.  */
                result->current->uses = i->uses;
                result->current->value = i->value * 2;
                  /* Cleaned meat is more valuable.  */
                result->current->flags = i->flags;
                result->current->flags2 = i->flags2;
                flag_set(&result->current->flags2, SOME);
                switch(master_creatures[i->identity]->meat_type)
                    {
                    case MEAT_DEAD:
#ifdef HAS_SNPRINTF
                        snprintf(item_name, 255, "dead %s",
                          master_creatures[i->other]->species);
#else
                        sprintf(item_name, "dead %s",
                          master_creatures[i->other]->species);
#endif
                        flag_reset(&result->current->flags2, SOME);
                    break;
                    case MEAT_FILLET:
#ifdef HAS_SNPRINTF
                        snprintf(item_name, 255, "%s fillet",
                          master_creatures[i->other]->species);
#else
                        sprintf(item_name, "%s fillet",
                          master_creatures[i->other]->species);
#endif
                        flag_reset(&result->current->flags2, SOME);
                    break;
                    case MEAT_JERKY:
#ifdef HAS_SNPRINTF
                        snprintf(item_name, 255, "%s jerky",
                          master_creatures[i->other]->species);
#else
                        sprintf(item_name, "%s jerky",
                          master_creatures[i->other]->species);
#endif
                    break;
                    case MEAT_MEAT:
#ifdef HAS_SNPRINTF
                        snprintf(item_name, 255, "%s meat",
                          master_creatures[i->other]->species);
#else
                        sprintf(item_name, "%s meat",
                          master_creatures[i->other]->species);
#endif
                    break;
                    case MEAT_NAME_ALONE:
#ifdef HAS_SNPRINTF
                        snprintf(item_name, 255, "%s",
                          master_creatures[i->other]->species);
#else
                        sprintf(item_name, "%s",
                          master_creatures[i->other]->species);
#endif
                    break;
                    case MEAT_NONE:
                        pmsg("You couldn't get an appreciable amount of meat out of it.");
                        free_items(result);
                        result = NULL;
                    break;
                    case MEAT_ROAST:
#ifdef HAS_SNPRINTF
                        snprintf(item_name, 255, "roast %s",
                          master_creatures[i->other]->species);
#else
                        sprintf(item_name, "roast %s",
                          master_creatures[i->other]->species);
#endif
                    break;
                    case MEAT_STEAK:
#ifdef HAS_SNPRINTF
                        snprintf(item_name, 255, "%s steak",
                          master_creatures[i->other]->species);
#else
                        sprintf(item_name, "%s steak",
                          master_creatures[i->other]->species);
#endif
                    break;
                    case MEAT_VENISON:
#ifdef HAS_SNPRINTF
                        snprintf(item_name, 255, "venison");
#else
                        sprintf(item_name, "venison");
#endif
                    break;
                    }
                item_name[255] = '\0';
                if (!(result == NULL))
                    {
                    name_item(result->current, item_name);
                    result->next = NULL;
                    }
                switch(i->other) /* What kind of creature it was */
                    {
                    case BEAR:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "bear skin rug");
                        curr_item->weight = 20L*LB;
                        curr_item->value = 200L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case BOAR:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "boar's hide");
                        curr_item->weight = 2L*LB;
                        curr_item->value = 25L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case BULETTE:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "bulette's hide");
                        curr_item->weight = 50L*LB;
                        curr_item->value = 800L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case CARIBOU:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "caribou's antler");
                        curr_item->number = 2;
                        curr_item->weight = 5L*LB;
                        curr_item->value = 50L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case COBRA:
                        curr_item = generate_item(current_level, POISON_STRONG);
                        add_item(&result, curr_item);
                    break;
                    case CROCODILE:
                        curr_item = (struct small_item *) calloc(1,
                          sizeof(struct small_item));
                        curr_item->me = curr_item;
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "crocodile's hide");
                        curr_item->weight = 10L*LB;
                        curr_item->value = 100L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case DEER:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "antler");
                        curr_item->number = 2;
                        curr_item->weight = 2L*LB;
                        curr_item->value = 35L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "deer's hide");
                        curr_item->weight = 2L*LB;
                        curr_item->value = 25L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case DRAGON:
                        curr_item = generate_item(current_level, FOOD);
                        name_item(curr_item, "dragon's heart");
                        curr_item->weight = 50L*LB;
                        curr_item->uses = 25;
                        curr_item->value = 2000L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "dragon's scales");
                        curr_item->weight = 200L*LB;
                        curr_item->value = 5000L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case ELEPHANT:
                        curr_item = (struct small_item *) calloc(1,
                          sizeof(struct small_item));
                        curr_item->me = curr_item;
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "elephant's hide");
                        curr_item->weight = 50L*LB;
                        curr_item->value = 200L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "elephant's tusks");
                        curr_item->weight = 50L*LB;
                        curr_item->value = 500L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case GIANT_SCORPION:
                        curr_item = generate_item(current_level, POISON_VERY_STRONG);
                        curr_item->uses *= random_adjust(5);
                        curr_item->weight *= curr_item->uses;
                        curr_item->value *= curr_item->uses;
                        add_item(&result, curr_item);
                    break;
                    case GIANT_VIPER:
                        curr_item = generate_item(current_level, POISON_EXTREMELY_STRONG);
                        curr_item->uses *= random_adjust(100);
                        curr_item->weight *= curr_item->uses;
                        curr_item->value *= curr_item->uses;
                        add_item(&result, curr_item);
                    break;
                    case GIANT_WASP:
                        curr_item = generate_item(current_level, POISON_MODERATE);
                        curr_item->uses *= random_adjust(2);
                        curr_item->weight *= curr_item->uses;
                        add_item(&result, curr_item);
                    break;
                    case GRYPHON:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "gryphon's claws");
                        curr_item->weight = 8L*OZ;
                        curr_item->value = 20L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case JEWEL_SERPENT:
                        curr_item = generate_item(current_level,
                        MORTAL_REMAINS);
                        name_item(curr_item, "serpent's jewel");
                        curr_item->weight = 8L*OZ;
                        curr_item->value = 5000L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                        curr_item = generate_item(current_level, POISON_VERY_STRONG);
                        curr_item->uses *= random_adjust(5);
                        curr_item->weight *= curr_item->uses;
                        curr_item->value *= curr_item->uses;
                        add_item(&result, curr_item);
                    break;
                    case LEVIATHAN:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "Leviathan's scale");
                        curr_item->weight = 5L*LB;
                        curr_item->value = 2000L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case MAMMOTH:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "mammoth's pelt");
                        curr_item->weight = 200L*LB;
                        curr_item->value = 5000L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "mammoth's tusks");
                        curr_item->weight = 50L*LB;
                        curr_item->value = 500L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case MASTODON:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "mastodon's pelt");
                        curr_item->weight = 200L*LB;
                        curr_item->value = 5000L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "mastodon's tusks");
                        curr_item->weight = 50L*LB;
                        curr_item->value = 500L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case PANTHER:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "panther's pelt");
                        curr_item->weight = 5L*LB;
                        curr_item->value = 500L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case POISON_QUILLED_PORCUPINE:
                        curr_item = generate_item(current_level, POISON_WEAK);
                        curr_item->uses *= random_adjust(50);
                        curr_item->weight *= curr_item->uses;
                        curr_item->value *= curr_item->uses;
                        add_item(&result, curr_item);
                    break;
                    case RABBIT:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "rabbit's pelt");
                        curr_item->weight = 3L*OZ;
                        curr_item->value = 1L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case RAM:
                        curr_item = generate_item(current_level, HORN);
                        name_item(curr_item, "ram's horn");
                        curr_item->number = 2;
                        curr_item->weight *= curr_item->number;
                        curr_item->value *= curr_item->number;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "ram's hide");
                        curr_item->weight = 2L*LB;
                        curr_item->value = 35L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case RHINOCEROS:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "rhinoceros's horns");
                        curr_item->weight = 5L*LB;
                        curr_item->value = 500L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case SCORPION:
                        curr_item = generate_item(current_level, POISON_WEAK);
                        add_item(&result, curr_item);
                    break;
                    case SHARK:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "shark's hide");
                        curr_item->weight = 20L*LB;
                        curr_item->value = 350L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case STEGOSAURUS:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "stegosaurus's hide");
                        curr_item->weight = 200L*LB;
                        curr_item->value = 5000L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case STINGING_INSECT:
                        curr_item = generate_item(current_level, POISON_WEAK);
                        add_item(&result, curr_item);
                    break;
                    case STONESHELL:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "stone shell");
                        curr_item->weight = 300L*LB;
                        curr_item->value = 5000L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case TRICERATOPS:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "triceratops's hide");
                        curr_item->weight = 100L*LB;
                        curr_item->value = 1000L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "triceratops's horns");
                        curr_item->weight = 10L*LB;
                        curr_item->value = 200L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case TURTLE:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "turtle's shell");
                        curr_item->weight = 50L*LB;
                        curr_item->value = 50L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case TYRANNOSAURUS_REX:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "tyrannosaurus rex's hide");
                        curr_item->weight = 200L*LB;
                        curr_item->value = 5000L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "tyrannosaurus rex's claws");
                        curr_item->weight = LB;
                        curr_item->value = 50L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case WALRUS:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "walrus's tusks");
                        curr_item->weight = 10L*LB;
                        curr_item->value = 200L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        flag_set(&curr_item->flags, SOME);
                        add_item(&result, curr_item);
                    break;
                    case WOLF:
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "wolf's pelt");
                        curr_item->weight = 2L*LB;
                        curr_item->value = 35L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    case WYVERN:
                        curr_item = generate_item(current_level, POISON_STRONG);
                        curr_item->uses *= random_adjust(5);
                        curr_item->weight *= curr_item->uses;
                        curr_item->value *= curr_item->uses;
                        add_item(&result, curr_item);
                        curr_item = generate_item(current_level, MORTAL_REMAINS);
                        name_item(curr_item, "wyvern's head");
                        curr_item->weight = 10L*LB;
                        curr_item->value = 200L*AU;
                        flag_set(&curr_item->flags, NO_CLEAN);
                        add_item(&result, curr_item);
                    break;
                    }
                free_item(i);
                }
            return result;
            }
        else
            {
            pmsg("You can't clean that.");
            result = (struct ilist *) calloc(1, sizeof(struct ilist));
            result->me = result;
            result->current = i;
            result->next = NULL;
            return result;
            }
        }
    else
        return NULL;
    }

void name_item(struct small_item *i, char *name)
    {
    if (!(i->tname == NULL))
        free_text_struct(i->tname);
    i->tname = (struct text_struct *) calloc(1, sizeof(struct text_struct));
    i->tname->me = i->tname;
    strncpy(i->tname->text, name, 117);
    i->tname->text[117] = '\0';
    i->tname->next = NULL;
    }

void add_item(struct ilist **il, struct small_item *i)
    {
    struct ilist *cltemp, *traverse;
    cltemp = (struct ilist *) calloc(1, sizeof(struct ilist));
    cltemp->me = cltemp;
    cltemp->current = i;
    cltemp->next = NULL;
    if (*il == NULL)
        *il = cltemp;
    else
        {
        traverse = *il;
        while (!(traverse->next == NULL))
            traverse = traverse->next;
        traverse->next = cltemp;
        }
    }

long ask_question_internal(char *question, long yes_val, long no_val)
    {
#ifdef GTK
    if (menu_choice(question, yes_no_choice, 2) == 0)
        return yes_val;
    else
        return no_val;
#else
    char resp;
    fs_pmsg(question);
    for(resp = tgetc(); ((resp != 'y') && (resp != 'Y') && (resp != 'n') &&
      (resp != 'N'));resp = tgetc())
        my_noop();
    if ((resp == 'y') || (resp == 'Y'))
        return yes_val;
    else
        return no_val;
#endif
    }

long ask_value(char *question, long average, long min_val, long max_val)
    {
    char input[256];
    long answer;
#ifdef GTK
    new_tgets(question, input, NULL);
#else
    pmsg(question);
    tgets(input);
#endif
#ifdef MAC_68k
    answer = atoi(input);
#else
    sscanf(input, "%ld", &answer);
#endif
    if (answer < min_val)
        {
#ifdef GTK
        fs_pmsg("I think that that sounds a little low.\n");
#else
        printw("I think that that sounds a little low.\n");
#endif
        answer = min_val;
        }
    else if (answer > max_val)
        {
#ifdef GTK
        fs_pmsg("Even if it's true, I don't believe it.\n");
#else
        printw("Even if it's true, I don't believe it.\n");
#endif
        answer = max_val;
        }
    window_refresh();
    return (long) (log(((double) answer)/((double) average))/(log(2.0)/5.0));
    }

long ask_question(char *question, long yes_val, long no_val, long
  attribute)
    {
    long result;
    result = ask_question_internal(question, yes_val, no_val);
    player->extended_creature->attributes[attribute] += result;
    if (result == yes_val)
        return TRUE;
    else
        return FALSE;
    }
