/**********************************************************************/
/* The Minstrel's Song is (c) 1998 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.            */
/**********************************************************************/

#include "tms.h"
#include <math.h>

#ifdef CODE_SEGMENT
#pragma segment UTIL4B_C
#endif

long found_in_distribution(long unit_id, long list_id, long type)
    {
    long success, i, distribution[NUM_DIST_SLOTS][3];
    switch(type)
	{
	case DISTRIBUTION_CREATURE:
	    switch(list_id)
		{
		case JEC_ENCOUNTER:
		    distribution_copy(jec_encounter, distribution);
		break;
		case NORKRIN_ENCOUNTER:
		    distribution_copy(norkrin_encounter, distribution);
		break;
		case SHAL_ENCOUNTER:
		    distribution_copy(shal_encounter, distribution);
		break;
		case TUZ_ENCOUNTER:
		    distribution_copy(tuz_encounter, distribution);
		break;
		case URVANOVESTILLI_ENCOUNTER:
		    distribution_copy(urvanovestilli_encounter, distribution);
		break;
		case YEDIDIA_ENCOUNTER:
		    distribution_copy(yedidia_encounter, distribution);
		break;
		case LEVEL_1_ENCOUNTER:
		    distribution_copy(level_1_encounter, distribution);
		break;
		case LEVEL_2_ENCOUNTER:
		    distribution_copy(level_2_encounter, distribution);
		break;
		case LEVEL_3_ENCOUNTER:
		    distribution_copy(level_3_encounter, distribution);
		break;
		case LEVEL_4_ENCOUNTER:
		    distribution_copy(level_4_encounter, distribution);
		break;
		case LEVEL_5_ENCOUNTER:
		    distribution_copy(level_5_encounter, distribution);
		break;
		case LAND_SPECIAL_ENCOUNTER:
		    distribution_copy(land_special_encounter, distribution);
		break;
		case SEA_SPECIAL_ENCOUNTER:
		    distribution_copy(sea_special_encounter, distribution);
		break;
		default:
		    pmsg("found_in_distribution called with inappropriate list id");
		    return 0;
		break;
		}
	break;
	case DISTRIBUTION_ITEM:
	    switch(list_id)
		{
		case ARMOR_FINE: case ARMOR_NORMAL: case ARMOR_NORMAL_FINE:
		    distribution_copy(armor, distribution);
		break;
		case DEVICE_FINE: case DEVICE_NORMAL: case DEVICE_NORMAL_FINE:
		    distribution_copy(device, distribution);
		break;
		case FURNITURE_FINE: case FURNITURE_NORMAL: case
		  FURNITURE_NORMAL_FINE:
		    distribution_copy(furniture, distribution);
		break;
		case LIQUID_FINE: case LIQUID_NORMAL: case LIQUID_NORMAL_FINE:
		    distribution_copy(liquid, distribution);
		break;
		case NATURAL_FINE: case NATURAL_NORMAL: case
		  NATURAL_NORMAL_FINE:
		    distribution_copy(natural, distribution);
		break;
		case NON_DEVICE_EQUIPMENT_FINE: case
		  NON_DEVICE_EQUIPMENT_NORMAL: case
		  NON_DEVICE_EQUIPMENT_NORMAL_FINE:
		    distribution_copy(non_device_equipment, distribution);
		break;
		case NON_EQUIPMENT_TREASURE_FINE: case
		  NON_EQUIPMENT_TREASURE_NORMAL: case
		  NON_EQUIPMENT_TREASURE_NORMAL_FINE:
		    distribution_copy(non_equipment_treasure, distribution);
		break;
		case SUPPLIES_FINE: case SUPPLIES_NORMAL: case
		  SUPPLIES_NORMAL_FINE:
		    distribution_copy(supplies, distribution);
		break;
		case WEAPON_FINE: case WEAPON_NORMAL: case WEAPON_NORMAL_FINE:
		    distribution_copy(weapon, distribution);
		break;
		case BUILDING_ITEM_FINE: case BUILDING_ITEM_NORMAL: case
		  BUILDING_ITEM_NORMAL_FINE:
		    distribution_copy(building_item, distribution);
		break;
		case DUNGEON_ITEM_FINE: case DUNGEON_ITEM_NORMAL: case
		  DUNGEON_ITEM_NORMAL_FINE:
		    distribution_copy(dungeon_item, distribution);
		break;
		case OUTDOORS_ITEM_FINE: case OUTDOORS_ITEM_NORMAL: case
		  OUTDOORS_ITEM_NORMAL_FINE:
		    distribution_copy(outdoors_item, distribution);
		break;
		case TINY_ITEM_FINE: case TINY_ITEM_NORMAL: case
		  TINY_ITEM_NORMAL_FINE:
		    distribution_copy(tiny_item, distribution);
		break;
		case BOOKSTORE_ITEM_FINE: case BOOKSTORE_ITEM_NORMAL:
		  case BOOKSTORE_ITEM_NORMAL_FINE:
		    distribution_copy(bookstore_item, distribution);
		break;
		case HERBALIST_ITEM_FINE: case HERBALIST_ITEM_NORMAL:
		  case HERBALIST_ITEM_NORMAL_FINE:
		    distribution_copy(herbalist_item, distribution);
		break;
		case JEWELLER_ITEM_FINE: case JEWELLER_ITEM_NORMAL:
		  case JEWELLER_ITEM_NORMAL_FINE:
		    distribution_copy(jeweller_item, distribution);
		break;
		default:
		    pmsg("found_in_distribution called with inappropriate list id");
		    return 0;
		break;
		}
	break;
	default:
	    pmsg("found_in_distribution called with inappropriate distribution id");
	    return 0;
	break;
	}
    success = 0;
    for(i = 0; i < NUM_DIST_SLOTS; ++i)
	success |= ((distribution[i][0] == unit_id) || (distribution[i][1] ==
	  unit_id));
    return success;
    }

void distribution_copy(long source[NUM_DIST_SLOTS][3], long
  destination[NUM_DIST_SLOTS][3])
    {
    long i, j;
    for(i = 0; i < NUM_DIST_SLOTS; ++i)
	for(j = 0; j < 3; ++j)
	    destination[i][j] = source[i][j];
    }

void hostility_check(struct level *l, struct small_creature *c)
    {
    struct clist *traverse;
    if (!(flag_check(c->flags, HIDDEN)))
	if (l->creatures != NULL)
	    for(traverse=l->creatures;(!(traverse==NULL));
	      traverse=traverse->next)
		if (!(is_following(traverse->current, c)))
		    if ((trandom()%100 < master_creatures[traverse->current->
		      identity]->chance_hostility) && (traverse->current != c))
			make_hostile(traverse->current, c);
    }

void set_options(void)
    {
    window_clear();
    fs_pmsg("You are now setting options for the game.  For each option you have three");
    fs_pmsg("choices: (s)et the option, (r)eset the option, or (p)ass over it.  Set");
    fs_pmsg("chooses the option and makes it true, reset rejects the option and makes it");
    fs_pmsg("false, and passing over an option leaves it as it is.");
    fs_anykey();
    fs_pmsg("Prompt for messages: This option controls whether, when there are enough");
    fs_pmsg("messages printed since you last hit a key, the game prompts for you to hit");
    fs_pmsg("'space' before printing any more.  If this option is reset, some messages may");
    fs_pmsg("scroll by before you can read them.");
    set_options_internal(&game_variables->flags, MESSAGES_PROMPT);
    fs_pmsg("Ask before pickup: If this variable is set, the game will ask you if you want");
    fs_pmsg("to pick something up, when you run across it.  If it is not set, you will");
    fs_pmsg("automatically pick up whatever you run across.  (You can still always drop what");
    fs_pmsg("you don't want.");
    set_options_internal(&game_variables->flags, ASK_PICKUP);
    fs_pmsg("Maximum refresh: This controls whether the game updates the screen more");
    fs_pmsg("frequently, or less frequently.");
    set_options_internal(&game_variables->flags, MAX_REFRESH);
    fs_pmsg("Player at center: This option controls whether the game always keeps the player");
    fs_pmsg("at the center of the screen, or whether it lets him move about and only shifts");
    fs_pmsg("the perspective when the player is near the edge of the screen.  (Setting the");
    fs_pmsg("option keeps the player at the center.");
    set_options_internal(&game_variables->flags, PLAYER_AT_CENTER);
    fs_pmsg("Negative confirm: When you say that you want to do something which the game");
    fs_pmsg("regards as dangerous, the game will be more discouraging in asking you if you");
    fs_pmsg("really want to do that.  This is recommended for novice players.");
    set_options_internal(&game_variables->flags, NEGATIVE_CONFIRM);
    fs_pmsg("Confirm when in doubt: If you do something which the game is not sure of, this");
    fs_pmsg("option will have the game prompt for confirmation.  (It is related to the");
    fs_pmsg("previous option, but not the same.");
    set_options_internal(&game_variables->flags, CONFIRM_WHEN_IN_DOUBT);
    fs_pmsg("Free unneeded levels: Normally, the game forgets all but a few levels when the");
    fs_pmsg("player leaves them, in order to save memory.  If this option is reset, the game");
    fs_pmsg("will remember all levels, but take large amounts of memory.  It is strongly");
    fs_pmsg("recommended that this option ALWAYS be set unless you have massive amounts of");
    fs_pmsg("memory and disk space.");
    set_options_internal(&game_variables->flags, FREE_UNNEEDED_LEVELS);
    fs_pmsg("Always display staircase: This will enable you to always see a staircase, even");
    fs_pmsg("if there is an item, creature, etc. on top of it.  This can be very useful in");
    fs_pmsg("dungeons.");
    set_options_internal(&game_variables->flags, ALWAYS_DISPLAY_STAIRCASES);
    fs_pmsg("Bellicose: This option controls whether your character will attack a creature");
    fs_pmsg("which is not hostile, or merely swap places with it, when you move over a");
    fs_pmsg("creature.  It is probably good to set this flag when hunting and in some other");
    fs_pmsg("cases, but generally to have it be reset.");
    set_options_internal(&player->flags, BELLICOSE);
    }

void set_options_internal(long *variable, long flags)
    {
    char response;
    fs_pmsg("");
    if (flag_check(*variable, flags))
	fs_pmsg("This option is currently set.");
    else
	fs_pmsg("This option is not currently set.");
    fs_pmsg("(s)et the option, (r)eset, or (p)ass over it, leaving it unchanged?");
    /* ## */
    response = tgetc();
    while ((response != 's') && (response != 'r') && (response != 'p'))
	{
	fs_pmsg("Please hit 's', 'r', or 'p'.");
	response = tgetc();
	}
    switch(response)
	{
	case 's':
	    flag_set(variable, flags);
	    pmsg("Set.");
	break;
	case 'r':
	    flag_reset(variable, flags);
	    pmsg("Reset.");
	break;
	case 'p':
	    pmsg("Passed over.");
	break;
	default:
	    pmsg("Error: exceptional response permitted in set_options_internal");
	break;
	}
    fs_anykey();
    window_clear();
    }

long has_item_id(struct ilist *il, long item_id, long flags)
    {
    long success;
    struct ilist *traverse;
    success = FALSE;
    if (il != NULL)
	for(traverse = il; traverse != NULL; traverse = traverse->next)
	    {
	    if (traverse->current->identity == item_id)
		success = TRUE;
	    if (flag_check(flags, EXTRACT_RECURSIVE))
		if (traverse->current->contents != NULL)
		    success |= has_item_id(traverse->current->contents,
		      item_id, flags);
	    }
    return success;
    }

void add_amount(struct small_creature *c, long amount)
    {
    long curr_price;
    if (c->extended_creature != NULL)
	{
/*
 *
 * curr_price is the remaining amount of money to be paid.  Shops always take
 * the lowest coin which the player has.
 *
 */
	curr_price = amount;
	c->extended_creature->au += curr_price/AU;
	curr_price = curr_price % AU;
	c->extended_creature->el += curr_price/EL;
	curr_price = curr_price % EL;
	c->extended_creature->si += curr_price/SI;
	curr_price = curr_price % SI;
	c->extended_creature->cu += curr_price/CU;
	curr_price = curr_price % CU;
	}
    }

long deduct_amount(struct small_creature *c, long amount)
    {
    long curr_price;
    if (c->extended_creature != NULL)
	{
	if (amount > (c->extended_creature->au * AU +
	  c->extended_creature->el * EL + c->extended_creature->si * SI +
	  c->extended_creature->cu * CU))
	    return 0;
	else
	    {
/*
 *
 * curr_price is the remaining amount of money to be paid.  Shops always take
 * the lowest coin which the player has.
 *
 */
	    curr_price = amount;
	    if (c->extended_creature->cu * CU > curr_price)
		{
		c->extended_creature->cu -= curr_price/CU;
		curr_price = curr_price % CU;
		}
	    if (c->extended_creature->si * SI > curr_price)
		{
		c->extended_creature->si -= curr_price/SI;
		curr_price = curr_price % SI;
		}
	    if (c->extended_creature->el * EL > curr_price)
		{
		c->extended_creature->el -= curr_price/EL;
		curr_price = curr_price % EL;
		}
	    if (c->extended_creature->au * AU > curr_price)
		{
		c->extended_creature->au -= curr_price/AU;
		curr_price = curr_price % AU;
		}
	    c->extended_creature->el -= curr_price/EL;
	    curr_price = curr_price % EL;
	    c->extended_creature->si -= curr_price/SI;
	    curr_price = curr_price % SI;
	    c->extended_creature->cu -= curr_price/CU;
	    curr_price = curr_price % CU;
	    return TRUE;
	    }
	}
    return TRUE;
    }

/* Remove one instance of a creature from a clist.  */

void remove_creature_from_clist(struct small_creature *c, struct clist **cl)
    {
    struct clist *traverse, *prev, *temp;
    if (*cl != NULL)
	{
	if ((*cl)->current == c)
	    {
	    temp = *cl;
	    *cl = (*cl)->next;
	    free(temp);
	    }
	else
	    {
	    for(prev = traverse = *cl; traverse != NULL;)
		{
		if (traverse->current == c)
		    {
		    prev->next = traverse->next;
		    free(traverse);
		    traverse = NULL;
		    }
		prev = traverse;
		if (traverse != NULL)
		    traverse = traverse->next;
		}
	    }
	}
    }

void append_creature_to_clist(struct small_creature *c, struct clist **cl)
    {
    struct clist *traverse, *new_clist;
    new_clist = (struct clist *) calloc(1, sizeof(struct clist));
#ifdef DEBUG
    new_clist->me = new_clist;
#endif
    new_clist->current = c;
    new_clist->next = NULL;
    if (*cl == NULL)
	*cl = new_clist;
    else if ((*cl)->next == NULL)
	(*cl)->next = new_clist;
    else
	{
	for(traverse = *cl; traverse->next != NULL; traverse = traverse->next)
        my_noop();
	traverse->next = new_clist;
	}
    }

void identify(struct small_item *i)
    {
    if (i != NULL)
	{
	flag_set(&i->flags, IDENTIFIED);
	if ((flag_check(i->flags, MAY_HAVE_COMPARTMENT)) && (flag_check(i->flags,
	  CONTAINER)))
	pmsg("It has a hidden compartment; it may be opened etc. as a regular container.");
	}
    }
